angular.module('bagu')
/******************
     静态常量定义
*******************/
//定义全局常量
.value('SERVER_SETTINGS',{
    //服务器地址
    //'CUR_SERVER':'http://120.24.60.192:3000',
    'CUR_SERVER':'http://112.74.88.16:3000',
    //'CUR_SERVER':'http://localhost:3000',
    'SERVER_LIST':[
      {name:'深圳',url:'http://112.74.88.16:3000'},
      {name:'北京',url:'http://120.24.60.192:3000'},
      // {name:'上海',url:'http://120.24.60.192:3000'},
      // {name:'广州',url:'http://120.24.60.192:3000'},
      {name:'测试',url:'http://localhost:3000'},
      // {name:'自动',url:'http://112.74.88.16:3000'}
    ],
    'UPDATESERVER_LIST':[
      {name:'深圳',url:'http://bzptech.com/app/version.xml'},
      {name:'北京',url:'http://bzptech.com/app/version.xml'},
      {name:'上海',url:'http://bzptech.com/app/version.xml'},
      {name:'广州',url:'http://bzptech.com/app/version.xml'},
      {name:'自动',url:'http://bzptech.com/app/version.xml'}
    ]
})
//事件
.constant('EVENTS', {
  //权限验证
  'AUTH': {
    //未登录
    NOTAUTHENTICATED: 'auth-not-authenticated',
    //无权限
    NOTAUTHORIZED: 'auth-not-authorized'
  },
  //网络消息
  'NET': {
    //无返回
    NORESPONSE: 'net-no-response'
  },
  //缓存数据消息
  'CACHE':{
    //缓存清空
    CLEAR: 'cache-clear',
    //楼房列表有更新
    BUILDINGLISTREFRESH: 'cache-buildinglist-refresh',
    //楼房有更新(基本信息,房间列表,房间信息,出租信息,费用信息,产品信息)
    BUILDINGREFRESH: 'cache-building-refresh',
    //房间有更新
    ROOMREFRESH: 'cache-room-refresh',
    //合同有更新
    CONTRACTREFRESH: 'cache-contract-refresh',
    //租客有更新
    CUSTOMERREFRESH: 'cache-customer-refresh',
    //租金单有更新
    INVOICEREFRESH: 'cache-invoice-refresh',
    //调租记录有更新
    PRICEREFRESH: 'cache-pricelog-refresh',
    //产品列表有更新
    PRODUCTLISTREFRESH: 'cache-productlist-refresh',
    //产品信息有更新
    PRODUCTREFRESH: 'cache-product-refresh',
  }
})
//列表项定义
.constant('STATUS', {
  //出租状态：0,自住; 1,未出租; 2,已预订; 3,已出租; 4,未缴费; 5,快到期; 6,退房中
  'RENT': {
    '0':'自住', '1':'空', '2':'已订', '3':'已租', '4':'未缴费', '5':'快到期', '6':'退房中'
  }
})
//用户角色定义
.constant('USER_ROLES', {
  //管理者
  'admin': 'admin_role',
  //查询用户
  'public': 'public_role'
})
//本地设置项
.constant('LOCAL', {
  //本地存储令牌的KEY值
  TOKEN_KEY: '_CURUSER',
  //默认设置
  DEFAULT:{
    //租客
    CUSTOMER:{
      //默认图像
      PORTRAIT: 'img/person.png'
    }
  },
  //抄表记录最大重试记录
  VALUELOG_CACHE_MAXRETRY: 100,
  //语音模块的语言设置
  AUDIO:{
    LANGUAGES:[
      {name:'关闭语音',code:''},
      {name:'普通话',code:'cn'},
      {name:'粤语',code:'yy'},
    ],
    DEFAULT_LANGUAGE: 'yy',
  },
})
//定义全局常量
.value('SMS',{
  templates: [{
    name: '催缴',
    value: 0,
    example: '101您好,您本月应缴435元(租金400水费35电费0),更多信息请关注公众号:包租婆科技',
    msgTemplate: '{{room.code}}您好,您本月应缴{{invoice.money}}元({{#invoice.items}}{{name}}{{money}}{{/invoice.items}}),更多信息请关注公众号:包租婆科技'
  }, {
    name: '催缴(最后通知)',
    value: 1,
    example: '101您好,您本月应缴435元(租金400水费35电费0),请于2016/5/5日前缴清，否则将停水电，房东示！更多信息请关注公众号:包租婆科技',
    msgTemplate: '{{room.code}}您好,您本月应缴{{invoice.money}}元({{#invoice.items}}{{name}}{{money}}{{/invoice.items}}),请于{{{lastPayDate}}}前缴清，否则将停水电，房东示！更多信息请关注公众号:包租婆科技'
  }, {
    name: '现场收租通知',
    value: 2,
    example: '101您好,我正在本楼房管处收租，请前来缴租。房东示',
    msgTemplate: '{{room.code}}您好,我正在本楼房管处收租，请前来缴租。房东示'
  }, {
    name: '续约提醒',
    value: 3,
    example: '101您好，您的合同将于2016/5/31日到期,您无需担心,我们将为您自动续约。如需退租，请提前一个月告知。房东示',
    msgTemplate: '{{room.code}}您好，您的合同将于{{{rentEndDate}}}到期,您无需担心,我们将为您自动续约。如需退租，请提前一个月告知。房东示'
  }, {
    name: '自动续约通知',
    value: 4,
    example: '101您好，您的合同已成功自动续约。如需退租，请提前一个月告知。房东示',
    msgTemplate: '{{room.code}}您好，您的合同已成功自动续约。如需退租，请提前一个月告知。房东示'
  }, {
    name: '邀请推荐新租客',
    value: 5,
    example: '101您好，本楼近期有空房可出租:403(单房)503(一房一厅),欢迎推荐朋友前来入住，介绍成功即可免费上网一个月。房东示',
    msgTemplate: '{{room.code}}您好，本楼近期有空房可出租:{{#emptyRooms}}{{code}}({{roomtype}}){{/emptyRooms}},欢迎推荐朋友前来入住，介绍成功送免费光纤宽带一个月。房东示'
  }, {
    name: '居住证办理通知',
    value: 6,
    example: '101您好，如果您还没有办理居住证，请及时到派出所办理，需要房屋编码的请到管理处查询。',
    msgTemplate: '{{room.code}}您好，如果您还没有办理居住证，请及时到派出所办理，需要房屋编码的请到管理处查询。'
  }, {
    name: '自定义',
    value: 7,
    example: '您可以根据自己的需求，向租客发送短信，比如，停电通知，安全提示等',
    msgTemplate: '您可以根据自己的需求，向租客发送短信，比如，停电通知，安全提示等',
    edit: true
  }, ]
});
// {
//     content: '<i class="icon ion-loading-c"></i>',
//     animation: 'fade-in',
//     showBackdrop: false,
//     maxWidth: 50,
//     showDelay: 0
//   }
