angular.module('bagu.controllers')
	.controller('AppCtrl', function ($q, $ionicPlatform, $scope, $state, $ionicModal, $ionicPopover, $ionicPopup, $ionicHistory,
		$ionicSideMenuDelegate, $ionicListDelegate, $ionicLoading, $timeout, _, $cordovaCamera, $cordovaFileTransfer, $cordovaFile, $cordovaInAppBrowser,
		AuthService, EVENTS, DATALIST, SERVER_SETTINGS, $Rfs, $Audio,
		$Window, $Update, $Print, $Invoice, $Product, $Customer, $Building, $RoomValue) {

		// With the new view caching in Ionic, Controllers are only called
		// when they are recreated or on app start, instead of every page change.
		// To listen for when this page is active (for example, to refresh data),
		// listen for the $ionicView.enter event:
		//$scope.$on('$ionicView.enter', function(e) {
		//});
		$scope.user = AuthService.user();

		$scope._ = _;
		$scope.DATALIST = DATALIST;

		//是否有未关闭窗口
		$scope.alertPopup = null;

		//打开帮助页
		$scope.helper = function () {
			var url = 'http://bzptech.com/rent/helper/index.html';
			//判断当前平台
			if (window.cordova && cordova) {
				var requestOptions = {
					location: 'no',
				};
				if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
					requestOptions.toolbarposition = 'bottom';
					return $cordovaInAppBrowser.open(url, '_blank', requestOptions);
				} else {
					requestOptions.mediaPlaybackRequiresUserAction = 'no';
					requestOptions.zoom = 'no';
					//requestOptions.clearcache = 'yes';
					return $cordovaInAppBrowser.open(url, '_system', requestOptions);
				}
			} else {
				return window.open(url, 'helper', 'top=0,left=0,toolbar=no,location=no, status=no');
			}
		};

		//注销登录,并且转跳到登录页面
		$scope.logout = function () {
			$ionicSideMenuDelegate.toggleLeft(false);
			AuthService.logout();
			$state.go('login');
		};

		//是否已登录?
		$scope.isAuthenticated = AuthService.isAuthenticated;

		/***右侧功能菜单***/
		function getBooleanValue(value, defvalue) {
			defvalue = defvalue ? defvalue : true;
			if (_.isFunction(value)) {
				return value($scope.$actionData);
			} else if (_.isBoolean(value)) {
				return value;
			} else if (_.isString(value)) {
				return value.uppercase() === 'TRUE';
			} else return defvalue;
		}
		//判断是否隐藏操作(不可见)
		$scope.isVisibleAction = function (action) {
			return getBooleanValue(action.visible, true);
		};
		//判断是否禁用操作(灰色)
		$scope.isDisabledAction = function (action) {
			return getBooleanValue(action.disabled, false);
		};
		//计算herf
		$scope.getActionHref = function (action) {
			if (_.isFunction(action.href)) {
				return action.href($scope.$actionData);
			} else return action.href;
		};
		//计算操作名称
		$scope.getActionText = function (action) {
			if (_.isFunction(action.text)) {
				return action.text($scope.$actionData);
			} else return action.text;
		};
		//触发功能(菜单)
		$scope.doMenuAction = function (action) {
			$scope.actionMenu.hide();
			return action.click && action.click($scope.$actionData, action);
		};
		//触发开关状态(菜单)
		$scope.doToggleChange = function (action) {
			return action.change && action.change(action.checked);
		};
		//触发选择项目(菜单)
		$scope.doMenuItemSelect = function (action,option) {
			action.value = option.value;
			return $scope.doMenuAction(action);
		};

		//触发功能(按钮点击)
		$scope.doButtonClick = function (action) {
			return action.click && action.click($scope.$actionData);
		};
		//设置操作菜单
		$scope.setActionMenus = function (menus) {
			$scope.$actionMenus = menus;
		};
		//设置操作按钮
		$scope.setActionButtons = function (buttons) {
			$scope.$actionButtons = buttons;
		};
		//设置绑定的数据对象
		$scope.setActionData = function (data) {
			$scope.$actionData = data;
		};
		//是否有显示状态的菜单项?(无则不弹出Popover)
		$scope.hasActionMenus = function (event) {
			return _.findIndex($scope.$actionMenus, function(item){
				return getBooleanValue(item.visible, true);
			}) >= 0;
		};
		//显示功能菜单
		$scope.showActionMenus = function (event,newPopover) {
			if (!$scope.actionMenu || newPopover) {
				//创建菜单对象
				$ionicPopover.fromTemplateUrl('templates/action.menu.html', {
					scope: $scope
				}).then(function (popover) {
					$scope.actionMenu = popover;
					$scope.actionMenu.show(event);
				});
			} else {
				$scope.actionMenu.show(event);
			}
		};

		//打印单个租金单
		$scope.doPrintInvoice = function(invoice) {
			//写入租金单数据
			$Print.clearPrintData();
			$Print.addInvoiceData([invoice]);
			$state.go('app.printer');
		};

		//打印财务统计
		$scope.doPrintAnalysis = function(analysis) {
			//写入租金单数据
			$Print.clearPrintData();
			$Print.addAnalysisesData([analysis]);
			$state.go('app.printer');
		};

		/***收费项目***/
		//收费项目管理
		$scope.ProductWindow = {};
		(function (ProductWindow) {
			//模态窗体
			ProductWindow._selectView = undefined;
			ProductWindow._manageView = undefined;
			//产品列表
			ProductWindow._productClasses = undefined;
			//配置环境
			ProductWindow.option = undefined;
			ProductWindow.feetypes = DATALIST.PRODUCT_FEETYPE.enum;
			ProductWindow.timelimits = DATALIST.PRODUCT_TIMELIMIT;
			//菜单定义
			ProductWindow.actions = [
				{
					id: 1,
					text: '增值服务项目',
					badge: 0,
					class: '',
					badgeclass: 'badge-assertive',
					href: undefined,
					click: function (data) {
						//跳转到增值服务选择页面
						$state.go('app.providers');
					}
				},
				{
					id: 2,
					text: '自定义项目',
					badge: 0,
					class: '',
					href: undefined,
					click: function (data) {
						//新增自定义项目
						ProductWindow.newProduct();
					}
				}];

			/*****工具函数*****/
			//分析产品订购记录
			function setOrderProducts(products) {
				//计算各产品的到期时间
				$Product.fixOrderProducts(products);
				//处理订购记录(设置订购标记\单价等)
				_.forEach(ProductWindow._productClasses, function (productclass) {
					_.forEach(productclass.types, function (type) {
						_.forEach(type.products, function (product) {
							//初始化
							product.isordered = undefined;
							product.showPrice = undefined;
							product.showPledge = undefined;
							product.begintime = undefined;
							product.endtime = undefined;
							product.record = undefined;
							//判断是否为已订购产品
							if (products) {
								var orderproduct = _.find(products, function (item) {
									return item._id === product._id;
								});
								if (orderproduct) {
									//已订购产品
									product.isordered = true;
									//计算显示单价和单位
									product.showPrice = orderproduct.price;
									product.showPledge = orderproduct.pledge;
									product.begintime = new Date(orderproduct.begintime);
									product.endtime = new Date(orderproduct.endtime);
									product.record = orderproduct.productrecord;
								}
							}
						});
					});
				});
			}

			//打开选择产品模式窗口
			ProductWindow.select = function (option) {
				ProductWindow.option = option;
				//刷新产品列表
				ProductWindow.doRefreshProducts(false, function (productclasses) {
					// //刷新操作菜单
					// $scope.setActionMenus(ProductWindow.actions,true);
					if (!ProductWindow._selectView) {
						// 创建模态对话框
						$ionicModal.fromTemplateUrl('templates/select.product.html', {
							scope: $scope
						}).then(function (modal) {
							ProductWindow._selectView = modal;
							ProductWindow._selectView.show();
						});
					} else {
						ProductWindow._selectView.show();
					}
				});
			};

			//关闭产品模式窗口
			ProductWindow.hideselect = function () {
				//清除订购标记
				setOrderProducts([]);
				//隐藏模态窗口
				if (ProductWindow._selectView) {
					ProductWindow._selectView.hide();
					delete ProductWindow._selectView;
				}
			};

			//打开选择产品模式窗口
			ProductWindow.manage = function () {
				//刷新产品列表
				ProductWindow.doRefreshProducts(false, function (productclasses) {
					// //刷新操作菜单
					// $scope.setActionMenus(ProductWindow.actions,true);
					if (!ProductWindow._manageView) {
						// 创建模态对话框
						$ionicModal.fromTemplateUrl('templates/manage.product.html', {
							scope: $scope
						}).then(function (modal) {
							ProductWindow._manageView = modal;
							ProductWindow._manageView.show();
						});
					} else {
						ProductWindow._manageView.show();
					}
				});
			};

			//关闭产品模式窗口
			ProductWindow.hidemanage = function () {
				//清除订购标记
				setOrderProducts([]);
				//隐藏模态窗口
				if (ProductWindow._manageView) {
					ProductWindow._manageView.hide();
					delete ProductWindow._manageView;
				}
			};

			//刷新产品列表
			ProductWindow.doRefreshProducts = function (fromServer, cb) {
				fromServer = fromServer || false;
				$Product.getProducts(fromServer).then(function (productclasses) {
					ProductWindow._productClasses = productclasses;
					//整理已订购产品
					if (ProductWindow.option && ProductWindow.option.orderProducts) {
						setOrderProducts(ProductWindow.option.orderProducts);
					}
					if (cb && _.isFunction(cb)) {
						cb(productclasses);
					}
				}).finally(function () {
					if (fromServer) {
						$scope.$broadcast('scroll.refreshComplete');
					}
				});
			};

			//设置已订购产品
			ProductWindow.setOrderProducts = function (products) {
				setOrderProducts(products);
			};

			//当某产品类型下只有一个项目时,不显示项目类型,只显示收费项目
			ProductWindow.showType = function (producttype) {
				return producttype.products && producttype.products.length > 1;
			};

			//判断是否已经在订购项目中
			ProductWindow.getChecked = function (product) {
				return product.isordered;
			};

			//点击产品项目事触发
			ProductWindow.changeProduct = function (product) {

				if (product.isordered) {
					//调用配置中定义的增加产品回调函数
					if (ProductWindow.option && ProductWindow.option.onAddProduct && _.isFunction(ProductWindow.option.onAddProduct)) {
						ProductWindow.option.onAddProduct(product, function (orderproduct) {
							product.isordered = true;
							//计算显示单价和单位
							product.showPrice = orderproduct.price;
							product.showPledge = orderproduct.pledge;
							product.begintime = new Date(orderproduct.begintime);
							product.endtime = new Date(orderproduct.endtime);
							product.record = orderproduct.productrecord;
						}, function () {
							product.isordered = false;
						});
					}
				} else {
					//调用配置中定义的取消产品回调函数
					if (ProductWindow.option && ProductWindow.option.onCancelProduct && _.isFunction(ProductWindow.option.onCancelProduct)) {
						ProductWindow.option.onCancelProduct(product, function () {
							product.isordered = false;
							product.showPrice = undefined;
							product.showPledge = undefined;
							product.begintime = undefined;
							product.endtime = undefined;
							product.record = undefined;
						}, function () {
							product.isordered = true;
						});
					}
				}
			};

			//新增收费项目
			ProductWindow.newProduct = function (product) {
				ProductWindow.newproduct = {
					timelimit: '1M',
					feetype: DATALIST.PRODUCT_FEETYPE.MONTHLY
				};
				var productPopu = $ionicPopup.show({
					//template: template,
					templateUrl: 'templates/popup/new.product.popup.html',
					title: '新增收费项目',
					scope: $scope,
					buttons: [{
						text: '取消'
                    }, {
						text: '<b>确定</b>',
						type: 'button-positive',
						onTap: function (e) {
							return $scope.ProductWindow.newproduct;
						}
                    }, ]
				});

				productPopu.then(function (newproduct) {
					console.log('Tapped!', newproduct);
					productPopu.close();
					if (newproduct) {
						$Product.newProduct(newproduct).then(function (newproduct) {
							$Window.showAlert('完成', '新增收费项目:' + newproduct.name + ',完成!');
						}, function (err) {
							$Window.showAlert('抱歉', err.message);
						});
					}
				});
			};

			//编辑收费项目
			ProductWindow.editProduct = function (product) {
				var productPopu = null;
				ProductWindow.editproduct = _.cloneDeep(product);
				//系统项目只能查看
				if (product.inner) {
					productPopu = $ionicPopup.show({
						//template: template,
						templateUrl: 'templates/popup/view.product.popup.html',
						title: '查看' + (product.name ? product.name : '收费项目'),
						scope: $scope,
						buttons: [{
							text: '<b>确定</b>',
							type: 'button-positive',
							onTap: function (e) {
								return null;
							}
                        }, ]
					});
				} else {
					productPopu = $ionicPopup.show({
						//template: template,
						templateUrl: 'templates/popup/edit.product.popup.html',
						title: '修改' + (product.name ? product.name : '收费项目'),
						scope: $scope,
						buttons: [{
							text: '取消'
                        }, {
							text: '<b>确定</b>',
							type: 'button-positive',
							onTap: function (e) {
								return $scope.ProductWindow.editproduct;
							}
                        }, ]
					});
				}

				productPopu.then(function (editproduct) {
					console.log('Tapped!', editproduct);
					productPopu.close();
					if (editproduct) {
						$Product.editProduct(editproduct).then(function (newproduct) {
							$ionicListDelegate.closeOptionButtons();
							$Window.showAlert('完成', '修改收费项目完成!');
						}, function (err) {
							$ionicListDelegate.closeOptionButtons();
							$Window.showAlert('抱歉', err.message);
						});
					}
				});
			};

			//删除产品
			ProductWindow.deleteProduct = function (product) {
				$Window.showAlert('警告', '收费项目删除后无法恢复<br>请确认该收费项目未被任一房间订购!').then(function (ok) {
					if (ok) {
						$Product.deleteProduct(product).then(function () {
							$Window.showAlert('完成', '成功删除收费项目!');
						}, function (err) {
							$ionicListDelegate.closeOptionButtons();
							$Window.showAlert('抱歉', err.message);
						});
					}
				});
			};

			//一次性收费项目?
			ProductWindow.isOnceProduct = function (product) {
				return product.feetype === DATALIST.PRODUCT_FEETYPE.ONCE;
			};
			//按月固定收费项目?
			ProductWindow.isMonthlyProduct = function (product) {
				return product.feetype === DATALIST.PRODUCT_FEETYPE.MONTHLY;
			};
			//按量收费项目?
			ProductWindow.isAmountProduct = function (product) {
				return product.feetype === DATALIST.PRODUCT_FEETYPE.AMOUNT || product.feetype === DATALIST.PRODUCT_FEETYPE.STEP;
			};
			//按面积收费项目?
			ProductWindow.isAreaProduct = function (product) {
				return product.feetype === DATALIST.PRODUCT_FEETYPE.AREA;
			};
			//按面积收费项目?
			ProductWindow.isPersonProduct = function (product) {
				return product.feetype === DATALIST.PRODUCT_FEETYPE.PERSON;
			};
			//获取金额字符串:金额or单价?
			ProductWindow.getPriceString = function (product) {
				return product.feetype > DATALIST.PRODUCT_FEETYPE.MONTHLY ? '单价' : '金额';
			};
			//获取计费类型
			ProductWindow.getFeeTypeString = function (product) {
				return _.findKey(ProductWindow.feetypes, function (type) {
					return type === product.feetype;
				});
			};
			//获取时长
			ProductWindow.getTimeLimitString = function (product) {
				return _.findKey(ProductWindow.timelimits, function (type) {
					return type === product.timelimit;
				});
			};
		})($scope.ProductWindow);

		/***租客管理***/
		//租客管理(新增,修改,删除)
		$scope.CustomerWindow = {};
		(function (thisWindow) {
			//模态窗体
			thisWindow._view = undefined;
			thisWindow._editView = undefined;
			//配置环境
			thisWindow.option = undefined;
			thisWindow.mode = undefined;

			//变量
			var defaultPic = 'http://bzptech.com/img/background5.jpg';
			//证件图像数组
			thisWindow.credentialsPic = [];

			//公共方法
			//获取租客证件图片
			var getCredentialsPic = function (customer) {
				thisWindow.credentialsPic = [];
				var scope = {
					customer: customer
				};
				thisWindow.credentialsPic = [defaultPic, defaultPic];
				if (customer.credentialspic && customer.credentialspic.length > 0) {
					_.forEach(customer.credentialspic, function (fileId, index) {
						if (index >= thisWindow.credentialsPic.length) {
							thisWindow.credentialsPic.push(defaultPic);
						}
						//避免处理默认图片地址
						if (defaultPic === fileId) {
							thisWindow.credentialsPic[index] = defaultPic;
						} else {
							$Rfs.getFile('credentials', fileId, scope).then(function (file) {
								thisWindow.credentialsPic[index] = file;
								//$Window.showAlert('提示', '发现文件:' + file);
							}, function (err) {
								console.log(err);
								//$Window.showAlert('抱歉', '下载文件失败!');
							}, function (progress) {
								console.log(progress.loaded, progress.total);
							});
						}
					});
				}
			};
			//设置正在上传的图片
			var showLocalCredentialsPic = function (index, imageURI) {
				index = index || 0;
				var customer = thisWindow.customer;
				if (index >= thisWindow.credentialsPic.length) {
					thisWindow.credentialsPic.push(imageURI);
				} else {
					thisWindow.credentialsPic[index] = imageURI;
				}

			};
			//设置租客对象
			var setCustomer = function (customer) {
				thisWindow.customer = customer;
				getCredentialsPic(customer);
			};

			//拍照上传身份证相片
			thisWindow.captureCredentialsPic = function (index) {
				index = index || 0;
				//只支持cordova环境中使用照相机
				if (!navigator.camera) {
					return;
				}
				var customer = thisWindow.customer;
				$cordovaCamera.getPicture({
					destinationType: Camera.DestinationType.FILE_URI
				}).then(function (imageURI) {
					if (!customer.credentialspic) {
						customer.credentialspic = [];
					}
					if (index >= customer.credentialspic.length) {
						index = customer.credentialspic.length;
					}
					//显示本地图片
					showLocalCredentialsPic(index, imageURI);
					//上传图片
					var scope = {
						customer: customer
					};
					$Rfs.uploadFile('credentials', index, imageURI, scope).then(function (data) {
						$Window.showToast('上传成功!');
						//上传成功,复制本地文件到目标缓存位置
						if (_.isArray(data) && data.length > index) {
							try {
								var fileId = data[index];
								var settings = $Rfs.getModuleSettings('credentials', fileId, scope);
								var oldFilePath = imageURI.substr(0, imageURI.lastIndex('/'));
								var oldFileName = imageURI.substr(imageURI.lastIndex('/') + 1);
								var newFilePath = settings.dir;
								var newFileName = settings.filename;
								$cordovaFile.copyFile(oldFilePath, oldFileName, newFilePath, newFileName).then(function (file) {
									console.log(file);
								}, function (err) {
									console.log(err);
								});
							} catch (e) {

							}
						}
						//刷新界面
						customer.credentialspic = data;
						//customer.credentialspic = [imageURI];
						setCustomer(customer);
					}, function (err) {
						console.log(err);
						$Window.showAlert('抱歉', '上传失败!');
					}, function (progress) {
						console.log(progress.loaded, progress.total);
					});
				}, function (err) {
					$Window.showAlert('警告', '拍照失败，原因：' + err);
				});
			};

			//上传身份证相片
			thisWindow.selectCredentialsPic = function (index) {
				index = index || 0;
				// TODO: 目前只支持cordova环境中选在文件上传
				if (!navigator.camera) {
					return;
				}
				var customer = thisWindow.customer;
				$cordovaCamera.getPicture({
					destinationType: Camera.DestinationType.FILE_URI,
					sourceType: Camera.PictureSourceType.PHOTOLIBRARY
				}).then(function (imageURI) {
					if (!customer.credentialspic) {
						customer.credentialspic = [];
					}
					if (index >= customer.credentialspic.length) {
						index = customer.credentialspic.length;
					}
					//显示本地图片
					showLocalCredentialsPic(index, imageURI);
					//上传图片
					var scope = {
						customer: customer
					};
					$Rfs.uploadFile('credentials', index, imageURI, scope).then(function (data) {
						customer.credentialspic = data;
						setCustomer(customer);
						$Window.showAlert('恭喜', '上传成功!');
					}, function (err) {
						console.log(err);
						$Window.showAlert('抱歉', '上传失败!');
					}, function (progress) {
						console.log(progress.loaded, progress.total);
					});
				}, function (err) {
					$Window.showAlert('警告', '选取相片失败，原因：' + err);
				});
			};

			//打开选择模式窗口
			thisWindow.new = function (room, option) {
				if (!room) {
					$Window.showAlert('提示', '只能针对房间增加租客!');
					return false;
				}
				thisWindow.mode = '新增';
				thisWindow.option = option;
				thisWindow.room = room;
				setCustomer({
					credentialstype: '身份证'
				});
				//显示新增租客窗口
				if (!thisWindow._view) {
					// 创建模态对话框
					$ionicModal.fromTemplateUrl('templates/customer.html', {
						scope: $scope
					}).then(function (modal) {
						thisWindow._view = modal;
						thisWindow._view.show();
					});
				} else {
					thisWindow._view.show();
				}
			};

			//打开编辑模式窗口
			thisWindow.edit = function (room, customer, option) {
				if (!room || !customer) {
					$Window.showAlert('提示', '只能修改特定房间的租客!');
					return false;
				}
				thisWindow.mode = '修改';
				thisWindow.option = option;
				thisWindow.room = room;
				setCustomer(customer);
				//显示新增租客窗口
				if (!thisWindow._view) {
					// 创建模态对话框
					$ionicModal.fromTemplateUrl('templates/customer.html', {
						scope: $scope
					}).then(function (modal) {
						thisWindow._view = modal;
						thisWindow._view.show();
					});
				} else {
					thisWindow._view.show();
				}
			};

			//关闭模式窗口
			thisWindow.hide = function () {
				//隐藏模态窗口
				if (thisWindow._view) {
					thisWindow._view.hide();
					delete thisWindow._view;
				}
				thisWindow.mode = '';
			};

			//保存
			thisWindow.save = function () {
				//新增
				function newCustomer() {
					var continuesave = true;
					//调用配置中定义的准备保存方法
					if (thisWindow.option && thisWindow.option.onBeforNew && _.isFunction(thisWindow.option.onBeforNew)) {
						continuesave = thisWindow.option.onBeforNew(thisWindow.customer);
					}
					if (continuesave === false) {
						return;
					}
					//保存新租客
					$Customer.newCustomer(thisWindow.room, thisWindow.customer).then(function (newCustomer) {
							//调用配置中定义的保存完成方法
							if (thisWindow.option && thisWindow.option.onAfterNew && _.isFunction(thisWindow.option.onAfterNew)) {
								thisWindow.option.onAfterNew(newCustomer);
							}
							thisWindow.hide();
						})
						.catch(function (err) {
							$Window.showAlert('抱歉', err.message || err);
						});
				}
				//修改
				function editCustomer() {
					var continuesave = true;
					//调用配置中定义的准备保存方法
					if (thisWindow.option && thisWindow.option.onBeforEdit && _.isFunction(thisWindow.option.onBeforEdit)) {
						continuesave = thisWindow.option.onBeforEdit(thisWindow.customer);
					}
					if (continuesave === false) {
						return;
					}
					//保存新租客
					$Customer.editCustomer(thisWindow.customer._id, thisWindow.customer).then(function (customer) {
							//调用配置中定义的保存完成方法
							if (thisWindow.option && thisWindow.option.onAfterEdit && _.isFunction(thisWindow.option.onAfterEdit)) {
								thisWindow.option.onAfterEdit(thisWindow.customer);
							}
							thisWindow.hide();
						})
						.catch(function (err) {
							$Window.showAlert('抱歉', err.message || err);
						});
				}

				//判断当前模式
				if (thisWindow.mode === '新增') {
					newCustomer();
				} else {
					editCustomer();
				}
			};

			//点击项目事触发
			thisWindow.delete = function () {

			};

		})($scope.CustomerWindow);


		/***楼房管理***/
		$scope.BuildingWindow = {};
		(function (thisWindow) {
			const EDIT_MODE = '修改';
			const ADD_MODE = '新增';
			//统一收租选项
			thisWindow.rentdateSelect = _.range(0, 32);
			thisWindow.delaysSelect = _.range(1, 16);
			thisWindow.beforeSelect = _.range(1, 11);
			//模态窗体
			thisWindow._addview = undefined;
			thisWindow._editView = undefined;
			//配置环境
			thisWindow.building = undefined;
			thisWindow.option = undefined;
			thisWindow.mode = undefined;


			thisWindow.changeFloorRooms = function (building) {
				var oldlen = thisWindow.building.floorrooms.length,
					newValue = thisWindow.building.floors;
				var i, j, len;
				//自动创建房间时,动态设置楼层数组
				if (thisWindow.building.createrooms) {
					if (newValue > oldlen) {
						for (i = oldlen, len = newValue; i < len; i++) {
							thisWindow.building.floorrooms.push({
								floorid: i + 1,
								rooms: 0,
								auto: true
							});
						}
					} else if (newValue < oldlen) {
						for (i = newValue, len = oldlen; i < len; i++) {
							thisWindow.building.floorrooms.pop();
						}
					}
				}
				//判断是否需要自动设置房间数
				if (thisWindow.building.rooms === undefined || thisWindow.building.rooms < thisWindow.building.floors) {
					return;
				}
				if (thisWindow.building.floorrooms.length !== thisWindow.building.floors) {
					return;
				}
				//动态设置(去除用户手动设置的楼层,自动根据房间数计算每层楼的房间数)
				//1,计算剩余楼层和房间数
				var autofloors = 0,
					autorooms = thisWindow.building.rooms;
				for (i = 0, len = newValue; i < len; i++) {
					if (thisWindow.building.floorrooms[i].auto) {
						autofloors++;
					} else {
						autorooms = autorooms - thisWindow.building.floorrooms[i].rooms;
					}
				}
				thisWindow.building.createroomserr = (autorooms < 0) || (autofloors > 0 && autorooms === 0); //如果小于0,则表示超过房间总数
				//正在修改,略过计算
				if (autorooms * autofloors === 0) return;
				//可以被整除?则平均设置楼层房间数
				if(autorooms % autofloors === 0){
					var rpf = autorooms / autofloors;
					for (i = newValue, j = 0; i > j; i--) {
						if (thisWindow.building.floorrooms[i - 1].auto === false) continue;
						thisWindow.building.floorrooms[i - 1].rooms = rpf;
					}
					return;
				}
				//2,自动设置楼层房间数(优先双数房间)
				var roomsL = Math.floor(autorooms / autofloors); //少房间数
				var roomsU = roomsL, //多房间数
					roomsP = 0; //多房间楼层的数量
				var lastrooms = autorooms;
				if (roomsL % 2 !== 0 && roomsL > 1) {
					roomsL--;
					roomsU = roomsL + 2;
				}
				roomsP = Math.ceil((autorooms - roomsL * autofloors) / 2); //此处向上取整,如果不能被整除,在第三部做调整

				for (i = newValue, j = 0; i > j; i--) {
					if (thisWindow.building.floorrooms[i - 1].auto === false) continue;
					if (roomsP > 0) {
						thisWindow.building.floorrooms[i - 1].rooms = roomsU;
						lastrooms = lastrooms - roomsU;
						roomsP--;
					} else {
						thisWindow.building.floorrooms[i - 1].rooms = roomsL;
						lastrooms = lastrooms - roomsL;
					}
				}
				//3,最下一层调整差数(当分配后有剩余房间或者多分配了房间数时)
				if (lastrooms > 0) {
					for (i = newValue, j = 0; i > j; i--) {
						if (thisWindow.building.floorrooms[i-1].auto === false) continue;
						var curfloor = thisWindow.building.floorrooms[i-1];
						var addrooms = 1;
						if(curfloor.rooms % 2 === 0 && lastrooms >= 2){
							addrooms = 2;
						}
						curfloor.rooms += addrooms;
						lastrooms -= addrooms;
						// thisWindow.building.floorrooms[i-1].rooms += lastrooms;
						// break;
						if(lastrooms === 0){
							break;
						}
					}
				}else if(lastrooms < 0){  //多分配了房间,需要在第一层调整
					for (i = newValue, j = 0; i > j; j++) {
						if (thisWindow.building.floorrooms[j].auto === false) continue;
						thisWindow.building.floorrooms[j].rooms += lastrooms;
						break;
					}
				}
			};

			thisWindow.changeFloorRoomInput = function (floorobj) {
				floorobj.auto = false;
				thisWindow.changeFloorRooms();
			};
			//打开新增模式窗口
			thisWindow.new = function (building, option) {
				if (!building) {
					//新建房间实体
					thisWindow.building = {
						createrooms: true,
						floorrooms: [
							// {
							// 	floorid: 1,
							// 	rooms: 5,
							// 	auto: true
	            // }
						],
						defaultproducts: [],
						settings: {
							'before': 2,
							'delays': 5,
							'rentdate': 1
						}
					};
					//获取初始化默认收费项目
					$Product.getDefaultProducts(false).then(function (products) {
						_.forEach(products, function (product) {
							thisWindow.addProduct(product);
						});
					});
				} else {
					thisWindow.building = building;
				}
				thisWindow.mode = ADD_MODE;
				thisWindow.option = option;
				//显示窗口
				if (!thisWindow._addview) {
					// 创建模态对话框
					$ionicModal.fromTemplateUrl('templates/new.building.html', {
						scope: $scope
					}).then(function (modal) {
						thisWindow._addview = modal;
						thisWindow._addview.show();
					});
				} else {
					thisWindow._addview.show();
				}
			};

			//打开修改模式窗口
			thisWindow.edit = function (building, option) {
				if (!building) {
					$Window.showAlert('提示', '请指定需要变更设置的楼房!');
					return false;
				}
				thisWindow.mode = EDIT_MODE;
				thisWindow.option = option;
				thisWindow.building = building;
				//thisWindow.editObj = _.cloneDeep(building);
				//显示窗口
				if (!thisWindow._editView) {
					// 创建模态对话框
					$ionicModal.fromTemplateUrl('templates/edit.building.html', {
						scope: $scope
					}).then(function (modal) {
						thisWindow._editView = modal;
						thisWindow._editView.show();
					});
				} else {
					thisWindow._editView.show();
				}
			};

			//关闭模式窗口
			thisWindow.hide = function () {
				//隐藏模态窗口
				if (thisWindow.mode === ADD_MODE) {
					if (thisWindow._addview) thisWindow._addview.hide();
					delete thisWindow._addview;
				} else {
					if (thisWindow._editView) thisWindow._editView.hide();
					delete thisWindow._editView;
				}
				thisWindow.mode = '';
			};

			//保存
			thisWindow.save = function () {
				//新增
				function newBuilding() {
					var continuesave = true;
					//调用配置中定义的准备保存方法
					if (thisWindow.option && thisWindow.option.onBeforNew && _.isFunction(thisWindow.option.onBeforNew)) {
						continuesave = thisWindow.option.onBeforNew(thisWindow.building);
					}
					if (continuesave === false) {
						return;
					}
					//保存
					//console.log('Doing addBuilding', thisWindow.building);
					//修正floorrooms参数,方便传送到服务器
					var roomsarray = [],
						sendbody = angular.copy(thisWindow.building);
					for (var i = 0; i < thisWindow.building.floorrooms.length; i++) {
						roomsarray.push(thisWindow.building.floorrooms[i].rooms);
					}
					//sendbody.floorrooms = roomsarray.join('-');
					sendbody.floorrooms = roomsarray;
					sendbody.products = thisWindow.building.defaultproducts;
					sendbody.netarea = thisWindow.option.netareaId;

					$Building.addBuilding(sendbody).then(function (result) {

							//调用配置中定义的保存完成方法
							if (thisWindow.option && thisWindow.option.onAfterNew && _.isFunction(thisWindow.option.onAfterNew)) {
								thisWindow.option.onAfterNew(result);
							}
							thisWindow.hide();
						})
						.catch(function (err) {
							$Window.showAlert('抱歉', err.message || err);
						});
				}
				//修改
				function editBuilding() {
					var continuesave = true;
					//调用配置中定义的准备保存方法
					if (thisWindow.option && thisWindow.option.onBeforEdit && _.isFunction(thisWindow.option.onBeforEdit)) {
						continuesave = thisWindow.option.onBeforEdit(thisWindow.building);
					}
					if (continuesave === false) {
						return;
					}
					var hasUpdateMasterTables = [];
					_.forEach(thisWindow.building.defaultproducts, function (editProduct) {
						if (editProduct.feetype === DATALIST.PRODUCT_FEETYPE.AMOUNT || editProduct.feetype === DATALIST.PRODUCT_FEETYPE.STEP) {
							var orgProduct = _.find(thisWindow.building.defaultproducts, function (item) {
								return item._id === editProduct._id;
							});
							if (!orgProduct || orgProduct.masters !== editProduct.masters) {
								hasUpdateMasterTables.push(editProduct);
							}
						}
					});
					//保存
					$Building.editBuilding(thisWindow.building._id, thisWindow.building).then(function (building) {
							//有可能修改了总表数量,此处不检查,全部获取所有按量收费项目的抄表记录
							var tasks = [];
							_.forEach(hasUpdateMasterTables, function (uproduct) {
								tasks.push($RoomValue.getRoomValues(thisWindow.building, uproduct, true));
							});
							$q.all(tasks).then(function () {
								//调用配置中定义的保存完成方法
								if (thisWindow.option && thisWindow.option.onAfterEdit && _.isFunction(thisWindow.option.onAfterEdit)) {
									thisWindow.option.onAfterEdit(building);
								}
							}, function (err) {
								$Window.showAlert('抱歉', '更新总表数设置出错!');
							});
							thisWindow.hide();
						})
						.catch(function (err) {
							$Window.showAlert('抱歉', err.message || err);
						});
				}

				//判断当前模式
				if (thisWindow.mode === ADD_MODE) {
					newBuilding();
				} else {
					editBuilding();
				}
			};

			//删除
			thisWindow.delete = function (building, option) {
				thisWindow.option = option;
				var bid = building._id,
					bname = building.name;
				$Window.showConfirm('警告!', '删除楼房后,其所有房间信息和费用信息将全部清空!确认删除吗?', '确认删除', '取消').then(function (isok) {
					if (isok) {
						var continuesave = true;
						//调用配置中定义的准备保存方法
						if (thisWindow.option && thisWindow.option.onBeforDelete && _.isFunction(thisWindow.option.onBeforDelete)) {
							continuesave = thisWindow.option.onBeforDelete(thisWindow.building);
						}
						if (continuesave === false) {
							return;
						}
						$Window.showAlert('成功', bname + '成功删除!');
						$Building.deleteBuilding(bid).then(function (building) {
							//调用配置中定义的保存完成方法
							if (thisWindow.option && thisWindow.option.onAfterDelete && _.isFunction(thisWindow.option.onAfterDelete)) {
								thisWindow.option.onAfterDelete(building);
							}
						});
					}
				});
			};

			//新增产品
			thisWindow.addProduct = function (product, success, error) {
				var newproduct = {
					product: product._id,
					_id: product._id,
					name: product.name,
					unit: product.unit,
					feetype: product.feetype,
					price: product.price, //产品价格
					pledge: product.pledge, //押金
					minvalue: 0, //默认无最低消费
				};
				// if(thisWindow.mode === ADD_MODE){
				// 	//增加到签约项目
				// 	thisWindow.building.defaultproducts.push(newproduct);
				// }else{
				// 	//增加到签约项目
				// 	thisWindow.editObj.defaultproducts.push(newproduct);
				// }
				thisWindow.building.defaultproducts.push(newproduct);
			};
			//取消产品
			thisWindow.deleteProduct = function (product, success, error) {
				var defaultproducts;
				// if(thisWindow.mode === ADD_MODE){
				// 	//增加到签约项目
				// 	defaultproducts = thisWindow.building.defaultproducts;
				// }else{
				// 	//增加到签约项目
				// 	defaultproducts = thisWindow.editObj.defaultproducts;
				// }
				defaultproducts = thisWindow.building.defaultproducts;
				//从签约项目中删除
				_.remove(defaultproducts, function (item) {
					return item._id === product._id;
				});
			};
			//在产品列表中新增或取消产品
			thisWindow.selectProduct = function () {
				var orderProducts = thisWindow.building.defaultproducts;
				$scope.ProductWindow.select({
					orderProducts: orderProducts,
					onAddProduct: thisWindow.addProduct,
					onCancelProduct: thisWindow.deleteProduct
				});
			};
		})($scope.BuildingWindow);

		/***平台判断***/
		// 苹果平台
		$scope.isAndroid = function () {
			return window.cordova && cordova && cordova.platformId && (ionic.Platform.isIOS() || ionic.Platform.isIPad());
		};
		// 安卓平台
		$scope.isAndroid = function () {
			return window.cordova && cordova && cordova.platformId && !(ionic.Platform.isIOS() || ionic.Platform.isIPad());
		};
		// WEB平台
		$scope.isWeb = function () {
			return !window.cordova || !cordova || !cordova.platformId || !ionic.Platform.isWebView();
		};

		/***通讯功能***/
		// 拨打电话
		$scope.callPhone = function (phone) {
			document.location.href = 'tel:' + phone;
		};

		// 发送短信
		$scope.sendSms = function (phone, body) {
			//document.location.href = 'sms:'+phone+'?body='+body;
			var href = 'sms:' + phone;
			if (window.ionic.Platform.isIOS() && window.ionic.Platform.version() >= 8) {
				document.location.href = href + (body ? '&body=' + body : '');
			} else {
				document.location.href = href + (body ? '?body=' + body : '');
			}
		};


		// 打开网址
		$scope.openUrl =  function (url,requestOptions){
			if(!url){
				return ;
			}
			if(!requestOptions){
				requestOptions = {
					location: 'no',
				};
			}
			//判断当前平台
			if (window.cordova && cordova && cordova.platformId && cordova.platformId !== 'browser') {
				if(!requestOptions){
					requestOptions = {
						location: 'no',
					};
				}
				if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
					requestOptions.toolbarposition = 'bottom';
					return $cordovaInAppBrowser.open(url, '_blank', requestOptions);
				} else {
					requestOptions.mediaPlaybackRequiresUserAction = 'no';
					requestOptions.zoom = 'no';
					return $cordovaInAppBrowser.open(url, '_system', requestOptions);
				}
			} else {
				return window.open(url, '_blank');
			}
		};

		/***收费项目判断***/

		//是否一次性收费项目?
		$scope.isOnceProduct = function (product) {
			return product && product.feetype && product.feetype === 0;
		};
		//是否按月固定计费项目?
		$scope.isMonthProduct = function (product) {
			return product && product.feetype && product.feetype === 1;
		};
		//是否按量计费项目?
		$scope.isAmountProduct = function (product) {
			return product && product.feetype && (product.feetype === 2 ||
				product.feetype === 3);
		};
		//是否面积计费项目?
		$scope.isAreaProduct = function (product) {
			return product && product.feetype && product.feetype === 4;
		};
		//是否按入住人数计费项目?
		$scope.isPersonProduct = function (product) {
			return product && product.feetype && product.feetype === 5;
		};
		//是否收取押金计费项目?
		$scope.isPledgeProduct = function (product) {
			return product && product.pledge && product.pledge > 0;
		};

		//是否一次性计费项目
		$scope.isOnceFeeItem = $Invoice.isOnceFeeItem;
		//是否按月计费项目
		$scope.isMonthlyFeeItem = $Invoice.isMonthlyFeeItem;
		//是否按量计费项目
		$scope.isAmountFeeItem = $Invoice.isAmountFeeItem;
		//是否按面积计费项目
		$scope.isAreaFeeItem = $Invoice.isAreaFeeItem;
		//是否按人数计费项目
		$scope.isPersonFeeItem = $Invoice.isPersonFeeItem;
		//是否收取押金项目?
		$scope.isPledgeInvoiceItem = $Invoice.isPledgeInvoiceItem;
		//是否未收费单据?
		$scope.isUnFinanceInvoice = $Invoice.isUnFinanceInvoice;
		//是否已收费单据?
		$scope.isFinanceInvoice = $Invoice.isFinanceInvoice;
		//是否已收费单据?
		$scope.isDeleteInvoice = $Invoice.isDeleteInvoice;

		/********后台提交抄表数据线程*********/
		//缓存中共有多少条抄表记录未保存?
		$scope.getUnSavedValueLogCount = $RoomValue.getUnSavedValueLogCount;

		var threadSaveRoomValue = function () {
			//在非抄表界面中上传数据
			if (!$state.is('app.valuelog') && !$state.is('app.valueloghistorys')) {
				//批量上传
				var valuelogs = $RoomValue.getUnSavedValueLogs();
				if (!valuelogs || valuelogs.length === 0) {
					return;
				}
				$RoomValue.SaveRoomValue(valuelogs).then(function (newvaluelog) {
					//刷新界面
					if(!$scope.$$phase){
						$scope.$apply();
					}
				});
			}
			// //判断是否有未保存的抄表记录
			// var valuelog = $RoomValue.getUnSavedValueLog();
			// if (valuelog) {
			// 	//$Window.showAlert('提示','发现抄表记录!');
			// 	$RoomValue.SaveRoomValue(valuelog.buildingId, valuelog.productId, valuelog.roomId, valuelog.readtime, valuelog.value).then(function (newvaluelog) {
			// 		//清除抄表操作记录
			// 		//console.log('抄表记录保存完成:', valuelog);
			// 	});
			// }
		};
		//每隔0.5秒刷新
		var intervalSaveRoomValue = setInterval(function () {
			threadSaveRoomValue();
		}, 500);

		/********自动更新计时器*********/
		// $timeout(function () {
		// 	$Update.updateApp(true);
		// }, 5000, false);
		setTimeout(function () {
			$Update.updateApp(true);
		}, 15000);

		/********事件绑定*********/

		$scope.$on('$ionicView.enter', function (e) {
			//updateUserInfo();
		});

		$scope.$on(EVENTS.NET.NORESPONSE, function (event) {
			// if (!$scope.alertPopup) {
			// 	$scope.alertPopup = $ionicPopup.alert({
			// 		title: '无网络',
			// 		template: '无法连接网络，请稍后再试!'
			// 	}).then(function (res) {
			// 		$scope.alertPopup = null;
			// 	});
			// }

			$Window.showToast('网络有点不给力!');
			$Window.hideLoading();
		});

		$scope.$on(EVENTS.AUTH.NOTAUTHORIZED, function (event) {
			var alertPopup = $ionicPopup.alert({
				title: '操作被拒绝',
				template: '请与管理员联系!'
			});
			$ionicHistory.goBack();
		});

		$scope.$on(EVENTS.AUTH.NOTAUTHENTICATED, function (event) {
			$scope.logout();
		});

		$scope.$on(EVENTS.CACHE.CLEAR, function (event, data) {
			//继续向下传递事件
			//$scope.$broadcast(EVENTS.CACHE.CLEAR,data);
		});
		//进入后
		$scope.$on('$ionicView.afterEnter', function (e) {
			//加载语音设置
			//$Audio.loadAudios();
		});
		//退出时清理对象
		$scope.$on('$destroy', function () {
			clearInterval(intervalSaveRoomValue);
		});
	});
