
angular.module('bagu.controllers')
//租金单
.controller('RoomBackCtrl', function($scope, $stateParams, $ionicPopup, $http, $ionicHistory , $ionicLoading, $state, $ionicModal, _,
  $Window, $Cache, $Date, $Room, $Rent, $Product, $Print, $Building, $Invoice, DATALIST) {
  /***保存参数***/
  $scope.roomId = $stateParams.roomId;
  $scope.isRunBack = _.isEmpty($stateParams.isRunBack) || $stateParams.isRunBack === false ? false : true;
  $scope.hasChanged = false;
  //菜单定义
  var actions = [
  {id:1,text:'催缴',badge:0,class:'',href:undefined, click: function(data){
    return;
  }},
  {id:2,text:'已收费',badge:0,class:'',href:undefined, click: function(data){
    return;
  }},
  {id:3,text:'全部',badge:0,class:'',href:undefined, click: function(data){
    return;
  }}];
  var statusactions = [
    {status:0,text:'自住',buttons:['对外出租','抄表'],menus:['对外出租','抄表']},
    {status:1,text:'未出租',buttons:['推广','预订','出租'],menus:['推广','取消预订','出租','设为自住']},
    {status:2,text:'已预订',buttons:['推广','取消预订','出租'],menus:[]},
    {status:3,text:'已出租',buttons:['退房','收租'],menus:['退房','收租']},
    {status:4,text:'未收费',buttons:['退房','催缴','收租'],menus:[]},
    {status:5,text:'快到期',buttons:['退房','转让','续签'],menus:[]},
    {status:6,text:'退房中',buttons:['推广','退房','收租'],menus:[]},
  ];

  /***工具函数***/

  //重新你计算租金单金额
  function reCalcBackMoney(){
    var backinfo = $scope.backinfo;
    var backmoney = 0,pledgetotal = 0,deductiontotal = 0;
    //押金
    _.forEach(backinfo.pledge.items, function(item){
      pledgetotal += item.money;
    });
    backinfo.pledge.total = pledgetotal;
    //扣费
    _.forEach(backinfo.deduction.items, function(item){
      deductiontotal += item.money;
    });
    _.forEach(backinfo.deduction.deduother, function(item){
      deductiontotal += item.money;
    });
    backinfo.deduction.total = deductiontotal;
    //计算总金额
    backinfo.backmoney = backinfo.pledge.total + backinfo.deduction.total;
  }

  //是否一次计费项目
  $scope.isOnceFeeItem = $Invoice.isOnceFeeItem;
  //是否按月计费项目
  $scope.isMonthlyFeeItem = $Invoice.isMonthlyFeeItem;
  //是否按量计费项目
  $scope.isAmountFeeItem = $Invoice.isAmountFeeItem;
  //是否按面积计费项目
  $scope.isAreaFeeItem = $Invoice.isAreaFeeItem;
  //是否按人数计费项目
  $scope.isPersonFeeItem = $Invoice.isPersonFeeItem;
  //是否押金单扣费项目
  $scope.isPledgeItem = function(item){
    return item && item.itemtype && item.itemtype === DATALIST.INVOICE_ITEM_TYPE.PLEDGE;
  };
  //获取时间段
  $scope.getDateRangeString = function(d1,d2){
    var begindate = $Date.fixShortDate(d1);
    var enddate = $Date.fixShortDate(d2);
    if(begindate > enddate){
      $Date.addDays(enddate,1);
    }
    if(begindate < enddate){
      $Date.addDays(begindate,1);
    }
    if(begindate.getTime() === enddate.getTime()){
      return '0天';
    }else{
      return $Date.getDateRangeString(begindate,enddate);
    }
  };

  //退房时间发生变化,重新计算扣费金额和退还总金额
  $scope.doBackDateChange = function(){
    var backinfo = $scope.backinfo;
    _.forEach(backinfo.deduction.items, function(item){
      if($scope.isMonthlyFeeItem(item)){
        var begindate = $Date.fixShortDate(item.begindate);
        var enddate = $Date.fixShortDate(backinfo.backdate);
        if(begindate > enddate){
          $Date.addDays(enddate,1);
        }
        if(begindate < enddate){
          $Date.addDays(begindate,1);
        }
        //计算按月固定项目的金额(根据时间)
        item.enddate = backinfo.backdate;
        if(begindate.getTime() === enddate.getTime()){
          item.money = 0;
        }else{
          item.money = $Rent.calcProductMoney(DATALIST.PRODUCT_FEETYPE.MONTHLY, item.price, begindate, enddate, 0);
        }
      }
    });
    _.forEach(backinfo.deduction.deduother, function(item){
      if($scope.isMonthlyFeeItem(item)){
        var begindate = $Date.fixShortDate(item.begindate);
        var enddate = $Date.fixShortDate(backinfo.backdate);
        if(begindate > enddate){
          $Date.addDays(enddate,1);
        }
        if(begindate < enddate){
          $Date.addDays(begindate,1);
        }
        //计算按月固定项目的金额(根据时间)
        item.enddate = backinfo.backdate;
        if(begindate.getTime() === enddate.getTime()){
          item.money = 0;
        }else{
          item.money = $Rent.calcProductMoney(DATALIST.PRODUCT_FEETYPE.MONTHLY, item.price, begindate, enddate, 0);
        }
      }
    });
    //计算总金额
    reCalcBackMoney();
  };
  //扣费细目发生变化,更新总金额
  $scope.doDeduItemMoneyChange = function(item){
    var backinfo = $scope.backinfo;
    if($scope.isAmountFeeItem(item)){
      item.value.amount = item.value.current - item.value.init;
      item.money = Math.round(item.value.amount * item.price);
    }else if($scope.isMonthlyFeeItem(item)){
      var begindate = $Date.fixShortDate(item.begindate);
      var enddate = $Date.fixShortDate(backinfo.backdate);
      if(begindate > enddate){
        $Date.addDays(enddate,1);
      }
      if(begindate < enddate){
        $Date.addDays(begindate,1);
      }
      //计算按月固定项目的金额(根据时间)
      item.enddate = backinfo.backdate;
      if(begindate.getTime() === enddate.getTime()){
        item.money = 0;
      }else{
        item.money = $Rent.calcProductMoney(DATALIST.PRODUCT_FEETYPE.MONTHLY, item.price, begindate, enddate, 0);
      }
    }else if($scope.isPledgeItem(item)){
      item.money = item.backmoney * -1;
    }else if($scope.isAreaFeeItem(item) || $scope.isPersonFeeItem(item)){
      item.money = Math.round(item.value.amount * item.price);
    }else if($scope.isOnceFeeItem(item)){
      item.money = item.price;
    }
  };
  //押金发生变化,更新总金额
  $scope.doPledgeItemMoneyChange = function(item){
    return $scope.doDeduItemMoneyChange(item);
  };
  //修改扣费项目
  $scope.changeDeduItemMoney = function(item){
    $scope.PopupData = _.cloneDeep( item );
    //弹出对话框
    var popup = $ionicPopup.show({
      //template: template,
      templateUrl: 'templates/popup/change.item.back.popup.html',
      title: item.name ? item.name : '项目' ,
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>确定</b>',
        type: 'button-positive',
        onTap: function (e) {
          return $scope.PopupData;
        }
      }, ]
    });

    popup.then(function (itemdata) {
      console.log('Tapped!', itemdata);
      popup.close();
      if (itemdata) {
        _.assign(item,itemdata);
        //计算总金额
        reCalcBackMoney();
      }
    });
  };

  //修改押金项目
  $scope.changePledgeItemMoney = function(item){
    return $scope.changeDeduItemMoney(item);
  };

  //增加项目
  $scope.addItem = function(backinfo,isDeduItem){
    if(isDeduItem){
      $scope.PopupData = {
        name: '',
        feetype: DATALIST.PRODUCT_FEETYPE.ONCE,
        unit: '',
        price: 0,
        money: 0
      };
    }else{
      $scope.PopupData = {
        name: '',
        itemtype: DATALIST.INVOICE_ITEM_TYPE.PLEDGE,
        price: 0,
        backmoney: 0,
        money: 0
      };
    }
    //弹出对话框
    var popup = $ionicPopup.show({
      //template: template,
      templateUrl: 'templates/popup/new.item.back.popup.html',
      title: isDeduItem ? '新增收费项目' : '增加押金项目',
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>确定</b>',
        type: 'button-positive',
        onTap: function (e) {
          return $scope.PopupData;
        }
      }, ]
    });

    popup.then(function (itemdata) {
      console.log('Tapped!', itemdata);
      popup.close();
      if (itemdata) {
        if(isDeduItem){
          backinfo.deduction.deduother.push(itemdata);
        }else{
          backinfo.pledge.items.push(itemdata);
        }
        //计算总金额
        reCalcBackMoney();
      }
    });
  };

  //删除收费项目
  $scope.deleteItem = function(invoiceitem){
    $Window.showConfirm('删除确认','确认要删除'+invoiceitem.name+'项目吗?').then(function(isOk){
      if(isOk){
        _.remove( $scope.invoice.items,function(item){
          return item === invoiceitem;
        });
      }
    });
  };

  /***数据处理***/
  //执行退房操作
  $scope.doRoomBack = function(){
    $Rent.back($scope.buildingId,$scope.roomId,$scope.backinfo).then(function(response){
      $Window.showAlert('恭喜','退房成功!');
      $ionicHistory.goBackByState('app.room');
    },function(err){
      $Window.showAlert('糟糕','退房失败了,请稍后重试!');
    });
  };

  //刷新数据
  $scope.doRefreshBackInfo = function(isRefresh){
    $Rent.getBackInfo($scope.roomId,$scope.isRunBack).then(function(backinfo){
      //格式化日期
      backinfo.backdate = new Date(backinfo.backdate);
      _.forEach(backinfo.deduction.items, function(deitem){
        //格式化日期
        deitem.begindate = new Date(deitem.begindate);
        deitem.enddate = new Date(deitem.enddate);
        //补充项目的单位
        var itemproduct = $Product.getCacheProduct(deitem.product);
        if(itemproduct && itemproduct.unit){
          deitem.unit = itemproduct.unit;
        }
      });
      _.forEach(backinfo.deduction.deduother, function(deitem){
        //格式化日期
        deitem.begindate = new Date(deitem.begindate);
        deitem.enddate = new Date(deitem.enddate);
        //补充项目的单位
        var itemproduct = $Product.getCacheProduct(deitem.product,false);
        if(itemproduct && itemproduct.unit){
          deitem.unit = itemproduct.unit;
        }
      });
      //修正押金金额
      _.forEach(backinfo.pledge.items, function(plitem){
        plitem.backmoney = plitem.money * -1;
      });
      $scope.backinfo = backinfo;
    }).finally(function () {
      if (isRefresh) {
        $scope.$broadcast('scroll.refreshComplete');
      }
    });
  };

  /***初始化***/
  $scope.title = '收租单';
  $Room.getRoom($scope.roomId).then(function(room){
    $scope.room = room;
    $scope.title = '退房(' + room.code + ')';
    $scope.buildingId = room.building;
    $scope.doRefreshBackInfo(false);
    //获取楼房信息
    $Building.getBuilding($scope.buildingId,false).then(function(building){
      $scope.building = building;
    });
  });

  /***监听事件***/
  //进入视图事件
  $scope.$on('$ionicView.enter', function() {

  });
  //退出时清理模态对象
  $scope.$on('$destroy', function() {
  });
});
