
angular.module('bagu.controllers')
.controller('BaiduMapCtrl', function($scope, $http, $state) {
  
  /***百度地图***/
  //设置位置数据
  function setLocationData(address,lng,lat){
    if(!$scope.$$phase) { 
      $scope.$apply(function () {
        $scope.locationdata.address = address;
        $scope.locationdata.longitude = lng;
        $scope.locationdata.latitude =  lat;
      });
    } else {
      $scope.locationdata.address = address;
      $scope.locationdata.longitude = lng;
      $scope.locationdata.latitude =  lat;
    }
  }

  var longitude = 121.506191;
  var latitude = 31.245554;
  $scope.mapOptions = {
    center: {
      longitude: longitude,
      latitude: latitude
    },
    zoom: 17,
    city: 'ShangHai',
    markers: [{
      longitude: longitude,
      latitude: latitude,
      title: '定位',
      content: '点击并拖动红色定位标示',
      enableMessage: false,
      enableDragging: true,
      raiseOnDrag: true,
      onDragend: function(e, rc){
        console.log('onDragend',rc.address);
        setLocationData(rc.address,e.point.lng,e.point.lat);
      }
    }]
  };
  $scope.locationdata = {address:'', longitude:longitude, latitude: latitude};

  //将GPS坐标转换为百度坐标
  function convertToBaiduMapPoint(point){
    setLocationData('getCurrentPosition ok !'+ point.coords.latitude.toString() + ' ' + point.coords.longitude.toString(),0,0);
    //http://api.map.baidu.com/geoconv/v1/?ak=E4805d16520de693a3fe707cdc962045&output=json
    $http.get('http://api.map.baidu.com/geoconv/v1/',{
      params:{ //get方法传参数,必须带上params
        coords:point.coords.longitude+','+point.coords.latitude,
        ak:'MPebIjRfRPqmj07AFOVUI3fS',
        output:'json'
      }
    })
    .success(function(response) {
      if(response.status === 0 && response.result && response.result.length > 0){
        var tranpoint = response.result[0];
        $scope.mapOptions.center.longitude = tranpoint.x;
        $scope.mapOptions.center.latitude = tranpoint.y;
        $scope.mapOptions.markers[0].longitude = tranpoint.x;
        $scope.mapOptions.markers[0].latitude = tranpoint.y;
        setLocationData('gps ok!'+tranpoint.x+tranpoint.y,tranpoint.x,tranpoint.y);
      }
    })
    .error(function(data, status, headers, config){
      setLocationData('gps error!',0,0);
    });
  }

  //测试位置转换
  // var testpoint = {coords:{longitude:114.21892734521,latitude:29.575429778924}};
  // convertToBaiduMapPoint(testpoint);

  //获取当前位置
  navigator.geolocation.getCurrentPosition(convertToBaiduMapPoint,function(error){
    console.log(error);
    setLocationData(error.message,0,0);
  }); //定位 

  //关闭地图
  $scope.closeMap = function(){
    setLocationData('call close map!',0,0);
    $state.go('app.buildings');
  };

  //保存当前位置
  $scope.saveMap = function(){

  };


});