angular.module('bagu.controllers')
//房间列表
.controller('BatchRentCtrl', function ($scope, $stateParams, $ionicPopover, $ionicPopup, $ionicScrollDelegate,
  $http, $Cache, $state, _, DATALIST, $Window, $RoomValue, $Print, $Invoice, $Sms) {

  /***参数定义***/
  //过滤条件定义
  var INVOICE_FILTER = {
    UnFinance: [DATALIST.INVOICE_STATUS.CREATE,DATALIST.INVOICE_STATUS.CONFIRM,DATALIST.INVOICE_STATUS.PRINT],
    Finance: [DATALIST.INVOICE_STATUS.FINANCE],
    All: []
  };
  $scope.INVOICE_FILTER = INVOICE_FILTER;
  //菜单定义
  var actions = [
  {id:1,text:'未收费',badge:0,filter:'UnFinance',class:'',badgeclass:'badge-assertive',href:undefined, click: function(data){
    //设置标题为楼房名称
    $scope.title = this.text;
    $scope.filter = INVOICE_FILTER[this.filter];
    $scope.refreshData();
  }},
  {id:2,text:'已收费',badge:0,filter:'Finance',class:'',href:undefined, click: function(data){
    //设置标题为楼房名称
    $scope.title = this.text;
    $scope.filter = INVOICE_FILTER[this.filter];
    $scope.refreshData();
  }},
  {id:3,text:'全部',badge:0,filter:'All',class:'',href:undefined, click: function(data){
    //设置标题为楼房名称
    $scope.title = this.text;
    $scope.filter = INVOICE_FILTER[this.filter];
    $scope.refreshData();
  }}];
  //url参数
  $scope.buildingId = $stateParams.buildingId;
  //过滤条件
  $scope.filter = INVOICE_FILTER.UnFinance;
  //设置标题为楼房名称
  $scope.title = '未收费';

  /***工具函数***/
  //更新统计
  function refreshInvoiceCount(){
    $Invoice.getBuildingLastInvoicesCount($scope.buildingId,INVOICE_FILTER).then(function(countinfo){
      _.forEach(actions, function(action){
        _.forEach(countinfo, function(info,key){
          if(key === action.filter){
            action.badge = info.count;
          }
        });
      });
    });
  }
  //批量发送催缴短信
  $scope.doBatchSendSms = function () {
    var invoices = [];
    _.forEach($scope.cacheInvoices, function(invoice){
      invoices.push(invoice._id);
    });
    $Sms.sendInvoiceSms($scope.buildingId,invoices).then(function(result){
      var number = _.isArray( result ) ? result.length : invoices.length;
      $Window.showAlert('恭喜', number + '条租金单,催缴短信已发送!');
    },function(err){
      $Window.showAlert('失败', err.message || err);
    });
  };
  //批量打印租金单
  $scope.doBatchPrint = function () {
    var invoices = [];
    _.forEach($scope.cacheInvoices, function(invoice){
      invoices.push(invoice);
    });
    $Print.clearPrintData();
    $Print.addInvoiceData(invoices);
    $state.go('app.printer');
  };

  //刷新数据
  $scope.refreshData = function (fromServer) {
    //获取楼房租金单
    $Invoice.filterBuildingLastInvoices($scope.buildingId, $scope.filter, fromServer)
      .then(function (buildingInvoices) {
        //保存所有租金单,在当前实例中实现分页
        $scope.cacheInvoices = buildingInvoices;
        //默认读取第一页(5条记录)
        $scope.page = 1;
        $scope.buildingInvoices = $scope.cacheInvoices.slice(($scope.page-1)*5,$scope.page*5);
        $scope.hasMoreData = $scope.buildingInvoices.length !== $scope.cacheInvoices.length;
        //滚动视图
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.$getByHandle('BatchRentScroll').scrollTop();
        //更新统计
        refreshInvoiceCount();

      }).finally(function () {
        if (fromServer) {
          $scope.$broadcast('scroll.refreshComplete');
        }
      });
  };
  //界面下拉刷新
  $scope.doRefresh = function () {
    $scope.refreshData(true);
  };

  //加载更多
  $scope.loadMore = function(){
    //默认为1一页开始
    $scope.page = $scope.page ? $scope.page : 1;
    //增加计数
    $scope.page ++;
    $scope.buildingInvoices = $scope.buildingInvoices.concat($scope.cacheInvoices.slice(($scope.page-1)*5,$scope.page*5));
    $scope.hasMoreData = $scope.buildingInvoices.length !== $scope.cacheInvoices.length;
    $scope.$broadcast('scroll.infiniteScrollComplete');
  };

  //加载更多
  $scope.showAllInvoice = function(){
    //过滤条件
    $scope.filter = INVOICE_FILTER.All;
    //设置标题
    $scope.title = '全部';
    //更新数据
    $scope.refreshData();
  };

  /***初始化数据***/

  //默认收费方式
  $scope.feedata = {
    feetype: DATALIST.FINANCE_PAYTYPE.CASH,
    financeType: {0:'现金',1:'微信',2:'刷卡',3:'支付宝',4:'银行转账'}
  };

  console.log('Fetch nofee invoice');
  //获取楼房未打印的租金单
  $scope.refreshData(false);


  /**********事件**********/
  //返回到缓存页面
  $scope.$on('$ionicView.enter', function(e) {
    //设置菜单项目
    $scope.setActionMenus(actions);
    //将在其他页面变更状态的租金单隐藏
    _.forEach($scope.cacheInvoices, function(invoice){
      if(invoice && $scope.filter.length !== 0 && !_.contains( $scope.filter, invoice.invoicestatus)){
        //刷新显示列表
        _.remove($scope.buildingInvoices,function(item){
          return item._id === invoice._id;
        });
        //刷新缓存列表
        _.remove($scope.cacheInvoices, function(item){
          return item._id === invoice._id;
        });
        //更新统计
        refreshInvoiceCount();
      }
    });
  });
});
