angular.module('bagu.controllers')
  //租金单
  .controller('BatchSmsCtrl', function($q, $scope, $stateParams, $ionicPopup, $http, $ionicHistory, $ionicLoading, $state, $ionicModal, _,
    $Window, $Cache, $Date, $Room, $RoomValue, $Customer, $Rent, $Print, $Building, $Invoice, $Sms, $ionicPopover, DATALIST, SMS) {
    /***保存参数***/
    $scope.buildingId = $stateParams.buildingId;
    $scope.invoiceId = $stateParams.invoiceId;
    $scope.editmode = false;
    $scope.hasChanged = false;
    //当前状态
    $scope.values = {
      template: 0,
      example: '',
      msgTemplate: '',
      selectCount: 0,
      selectTemplates: $Room.getChooseTemplate(),
      allCustomer: false,
      contents: [],
      previewContent: null,
      msgCount: 0,
      activeTemplate: null,
      previewMobile: null
    };
    //下拉选项定义
    $scope.settings = {
      templates: SMS.templates
    };

    /***工具函数***/
    //获取已选择房间的数量
    var getChooseCount = function() {
      var count = 0;
      var selectRooms = $Room.getChooseRooms($scope.buildingId);
      if (selectRooms) {
        count = selectRooms.length;
      }
      return count;
    };
    //根据模板的值,获取模板对象
    var getTemplate = function(index){
      return _.find($scope.settings.templates, function(item) {
        return item.value.toString() === index.toString();
      });
    };
    //根据模板内容,生成短信内容
    var genSMSContent = function(){
      function doGen(smsScope,template){
        var msgContent = $Sms.genSMSContent(smsScope,template);
        if (msgContent) {
          $scope.values.contents.push(msgContent);
          $scope.values.msgCount += Math.ceil(msgContent.length / 70);
        }
      }
      //获取选择的房间
      var selectRooms = $Room.getChooseRooms($scope.buildingId);
      var thisbuilding = null, emptyRooms = null;
      if (selectRooms && $scope.values.activeTemplate) {
        $scope.values.contents = [];
        $scope.values.msgCount = 0;
        _.forEach(selectRooms, function(room){
          //按房间组织环境变量
          var smsScope = {};
          $q.all([
            //获取楼房对象
            $q(function(resolve, reject) {
              if(thisbuilding && emptyRooms){
                smsScope.building = thisbuilding;
                smsScope.emptyRooms = emptyRooms;
                resolve();
              }else{
                smsScope.building = null;
                smsScope.emptyRooms = [];
                //获取楼房对象
                $Building.getBuilding($scope.buildingId).then(function(building){
                  thisbuilding = building;
                  smsScope.building = building;
                  //保存管理员手机号码
                  $scope.values.previewMobile = building.managertel ? building.managertel : building.ownertel;
                  //保存未出租房间
                  $Room.getBuildingRooms($scope.buildingId).then(function(rooms){
                    emptyRooms = _.filter(rooms, function(item){
                      return _.contains([DATALIST.ROOM_STATUS.EMPTY,DATALIST.ROOM_STATUS.BACKING,],item.roomstatus);
                    });
                    smsScope.emptyRooms = emptyRooms;
                    resolve();
                  },function(err){
                    $Window.showToast('无法获取未出租房间!');
                    resolve();
                  });
                },function(err){
                  $Window.showToast('无法获取楼房对象!');
                  resolve();
                });
              }
            }),
            //获取房间\合同信息\对象
            $q(function(resolve, reject) {
              smsScope.room = null;
              smsScope.rent = null;
              smsScope.rentEndDate = null;
              smsScope.customers = [];
              $Room.getRoom(room).then(function(roomobj){
                smsScope.room = roomobj;
                smsScope.rent = roomobj.rent;
                if (smsScope.room && smsScope.room.rent && smsScope.room.rent.contract && _.isArray(smsScope.room.rent.contract.customers) && smsScope.room.rent.contract.customers.length > 0) {
                  //设置合同到期时间
                  smsScope.rentEndDate = smsScope.room.rent.contract.enddate.toLocaleDateString();
                  //获取租客信息
                  $Customer.getRoomCustomers(smsScope.room).then(function(customers) {
                    _.remove(customers, function(item) {
                      return !item || !item._id;
                    });
                    smsScope.customers = customers;
                    resolve();
                  },function(err){
                    $Window.showToast('无法获'+roomobj.code+'的租客数据!');
                    resolve();
                  });
                }else{
                  resolve();
                }
              },function(err){
                $Window.showToast('无法获房间数据!');
                resolve();
              });
            }),
            //获取最后租金单对象(未收费优先)
            $q(function(resolve, reject) {
              smsScope.invoice = null;
              smsScope.lastPayDate = null;
              $Invoice.getRoomLastInvoice($scope.buildingId,room).then(function(invoice){
                if (_.isArray(invoice) && invoice.length > 0) {
                  smsScope.invoice = invoice[0];
                }else{
                  smsScope.invoice = invoice;
                }
                //设置最后缴费日期
                if(smsScope.invoice){
                  var lastPayDate = new Date(invoice.enddate);
                  $Date.addDays(lastPayDate,smsScope.building.settings.delays);
                  smsScope.lastPayDate = lastPayDate.toLocaleDateString();
                }
                resolve();
              },function(err){
                if(smsScope.room){
                  $Window.showToast('无法获'+smsScope.room.code+'的租金单数据!');
                }
                resolve();
              });
            })
          ]).then(function(result){
            //有设置租客信息的才发送短信
            if(smsScope.customers && smsScope.customers.length > 0){
              //发送给房间的所有租客?
              if($scope.values.allCustomer){
                _.forEach(smsScope.customers, function(customer){
                  smsScope.customer = customer;
                  doGen(smsScope,$scope.values.activeTemplate.msgTemplate);
                });
              }else{
                smsScope.customer = smsScope.customers[0];
                doGen(smsScope,$scope.values.activeTemplate.msgTemplate);
              }
            }
          },function(err){
            console.log(err);
            $Window.showToast('无法生成短信内容,请联系管理员!');
          });
        });
      }
    };
    //刷新统计信息
    var refreshData = function() {
      //设置默认短信模板
      if(!$scope.values.activeTemplate){
        $scope.onSelectTemplate();
      }
      //更新统计数据
      $scope.values.selectCount = getChooseCount();
      //计算短信内容
      genSMSContent();
    };
    $scope.refreshData = refreshData;

    /***方法定义***/
    //模板变更事件
    $scope.onSelectTemplate = function() {
      $scope.values.activeTemplate = getTemplate($scope.values.template);
      //计算短信内容
      genSMSContent();
    };

    //是否正确电话号码
    $scope.isMobile = $Sms.isMobile;

    //短信预览
    $scope.showConfirm = function() {
      $scope.values.previewContent = $scope.values.contents[0];
      var confirmPopup = $ionicPopup.confirm({
        title: '<h4>短信预览</h4>',
        templateUrl: 'templates/popup/batchsms.preview.popup.html',
        scope: $scope,
        buttons: [{
          text: '关闭'
        }, {
          text: '发送',
          type: 'button-positive',
          onTap: function(e) {
            if (!$scope.values.previewMobile || !$scope.isMobile($scope.values.previewMobile)) {
              //如果没有输入正确的手机号码,不允许发送.
              e.preventDefault();
            } else {
              return $scope.values.previewMobile;
            }
          }
        }]
      });
      confirmPopup.then(function(res) {
        if (res) {
          console.log('发送');
          $Window.showLoading();
          $Sms.sendPreviewSms($scope.buildingId,$scope.values.previewContent,$scope.values.previewMobile).then(function(result){
            $Window.showAlert('恭喜','预览短信已发送,请检查!');
            console.log('发送');
          },function(err){
            $Window.showToast('发送预览短信出错!');
          }).finally(function () {
            $Window.hideLoading();
          });
        } else {
          console.log('关闭');
        }
        confirmPopup.close();
      });
    };

    //群发短信
    $scope.doBatchSms = function() {
      var selectRooms = $Room.getChooseRooms($scope.buildingId);
      var content = '';
      if($scope.values.activeTemplate && $scope.values.activeTemplate.msgTemplate){
        content = $scope.values.activeTemplate.msgTemplate;
      }else{
        $Window.showAlert('出错','请先正确设置短信模板!');
        return;
      }
      $Window.showLoading();
      $Sms.sendRoomsSms($scope.buildingId,selectRooms,$scope.values.allCustomer,content).then(function(result){
        $Window.showAlert('恭喜','群发短息成功!');
      },function(err){
        $Window.showToast('发送短信出错!');
      }).finally(function () {
        $Window.hideLoading();
      });
    };


    /***初始化***/
    $scope.title = '短信群发';

    /***监听事件***/
    //进入视图事件
    $scope.$on('$ionicView.enter', function() {
      refreshData();
    });
    //退出时清理模态对象
    $scope.$on('$destroy', function() {});
  });
