angular.module('bagu.controllers')
	//房间列表
	.controller('BuildingCtrl', function ($q, $scope, $Sms, $stateParams, $ionicPopover, $ionicModal, $ionicPopup, $state, $http, _, $Cache, $Window,
		$Rent, $Room, $Building, $Product, $Invoice, $PriceLog,
		$RoomValue, $Analysis, $ionicBackdrop, $ionicActionSheet, $ionicListDelegate, $Date, $filter, $Str,
		$Print, $Customer, DATALIST, EVENTS) {

		/***保存url参数***/
		//设置楼房ID
		$scope.buildingId = $stateParams.buildingId;
		$scope.VIEWTYPE = {
			STATUS: 0,
			PRICE: 1,
			MANAMGE: 2
		};
		//预订房间?? 应该不需要此变量?
		$scope.data = {
			money: 200,
			'date': new Date(),
			'credtype': '身份证',
			'expired': $Date.addDays(new Date(), 5)

		};
		$scope.nullrooms = 0;
		//设置显示价格模式
		$scope.showType = $scope.VIEWTYPE.STATUS;
		//是否房间管理模式
		$scope.isManageView = false;
		//房间操作层关闭状态
		$scope.modalClosed = true;
		/***右侧功能菜单***/
		//过滤条件定义
		var INVOICE_FILTER = {
			UnPrint: [DATALIST.INVOICE_STATUS.CREATE],
			UnFinance: [DATALIST.INVOICE_STATUS.CREATE, DATALIST.INVOICE_STATUS.CONFIRM,
                DATALIST.INVOICE_STATUS.PRINT
            ]
		};

		//菜单定义
		var actions = [{
			id: 1,
			text: '批量抄表',
			badge: 0,
			icon: 'ion-ios-speedometer-outline',
			badgeclass: 'badge-assertive',
			href: '#/app/valuelogs/' + $scope.buildingId + '/',
			click: function (data) {
				$scope.clearRoomPopup();
			}
		}, {
			id: 2,
			text: '批量打单',
			filter: 'UnPrint',
			badge: 0,
			icon: 'ion-ios-printer-outline',
			badgeclass: 'badge-assertive',
			href: '#/app/batchprint/' + $scope.buildingId,
			click: function (data) {
				$scope.clearRoomPopup();
			}
		}, {
			id: 3,
			text: '批量收租',
			filter: 'UnFinance',
			badge: 0,
			icon: 'ion-social-usd-outline',
			badgeclass: 'badge-assertive',
			href: '#/app/batchrent/' + $scope.buildingId,
			click: function (data) {
				$scope.clearRoomPopup();
			}
		}, {
			id: 4,
			text: '群发短信',
			badge: 0,
			visible: true,
			icon: 'ion-ios-chatboxes-outline',
			href: '#/app/batchsms/' + $scope.buildingId,
			click: function (data) {
				$scope.clearRoomPopup();
			}
		}, {
			id: 5,
			text: '扫一扫',
			badge: 0,
			visible: false,
			class: '',
			href: '#/app/building/' + $scope.buildingId + '/scan',
			click: function (data) {
				$scope.clearRoomPopup();
			}
		}, {
			id: 6,
			text: '初始化出租数据',
			badge: 0,
			icon: 'ion-ios-recording-outline',
			visible: function (data) {
				//当未设置状态的房间大于0时显示
				return data.nullrooms > 0 || data.roomcount === 0;
			},
			href: '#/app/building/' + $scope.buildingId + '/init',
			click: function (data) {
				$scope.clearRoomPopup();
			}
		}, {
			id: 7,
			text: '楼房设置',
			badge: 0,
			icon: 'ion-ios-cog-outline',
			href: undefined,
			click: function (data) {
				$scope.clearRoomPopup();
				$scope.editBuilding();
			}
		}];
		//房间颜色定义
		//enum:{0:'自住',1:'未租',2:'已订',3:'已租',4:'未缴',5:'到期',6:'退房',100:'未设置'}
		var ROOM_COLORS = {
			0: 'roomself',
			1: 'roomempty',
			2: 'roomorder',
			3: 'roomrent',
			4: 'roomfinance',
			5: 'roomexprie',
			6: 'roomback',
			100: 'roomnull'
		};
		$scope.feedata = {
			feetype: DATALIST.FINANCE_PAYTYPE.CASH,
			financeType: {
				0: '现金',
				1: '微信',
				2: '刷卡',
				3: '支付宝',
				4: '银行转账'
			}
		};

		function setRoom(room) {
			//如果为出租状态,则加载并分析产品记录
			if (room.roomstatus > DATALIST.ROOM_STATUS.ORDER && room.rent &&
				room.rent.contract) {
				$Product.fixOrderProducts(room.rent.contract.products);
			}
			//赋值,返回
			$scope.room = room;
		}
		var config = {
			actions: [{
				id: 0,
				text: '对外出租',
				class: '',
				icon: 'ion-ios-home-outline',
				href: undefined,
				click: function (room) {
					$Window.showConfirm('设置为出租房?', '设置为出租房后,系统将帮您进行推广.').then(
						function (ok) {
							if (ok) {
								$Rent.enableRent(room._id).then(function (response) {
									$Room.setRoomEmpty(room._id);
									setRoom(room);
									$scope.refreshRoomPopup(room);
									$Window.showAlert('恭喜', room.code +
										'已经重新对外出租!');
								}, function (err) {
									$Window.showAlert('抱歉', $scope.room.code + '对外出租失败,请稍后重试!');
								});
								$scope.room.roomstatus = DATALIST.ROOM_STATUS.EMPTY;
								return true;
							}
						});
				}
            }, {
				id: 1,
				text: '抄表',
				class: '',
				icon: 'ion-ios-speedometer-outline',
				href: undefined,
				click: function (room) {
					console.log('抄表', room);
					$state.go('app.valuelog', {
						buildingId: room.building,
						roomId: room._id,
						//productId: ''
					}); //"#/app/valuelog/{{room._id}}/{{product._id}}"
				}
            }, {
				id: 2,
				text: '推广',
				class: '',
				icon: 'ion-ios-medical-outline',
				href: undefined,
				click: function (room) {
					$Rent.popularize(room._id).finally(function (room) {
						console.log('popularize OK');
						if (room) {
							setRoom(room);
						}
						$Window.showAlert('恭喜', '我们已经开始为您推广该房间');
					});
				}
            }, {
				id: 3,
				text: '预订房间',
				class: '',
				icon: 'ion-ios-cart-outline',
				href: undefined,
				// click: function(room){
				//   $scope.orderRoom();
				// }
				click: function (room) {
					console.log('预订房间', room);
					if ($scope.modal) {
						$scope.modal.hide();
					}
					$state.go('app.roomorder', {
						roomId: room._id.toString(),
					});
				}
            }, {
				id: 4,
				text: '取消预订',
				class: '',
				icon: 'ion-ios-timer-outline',
				href: undefined,
				click: function (room) {
					$scope.cancelOrder();
				}
            }, {
				id: 5,
				text: '出租',
				class: '',
				icon: 'ion-ios-home-outline',
				// href: function(room) {
				//     return '#/app/contract/' + room._id.toString();
				// },
				click: function (room) {
					if ($scope.modal) {
						$scope.modal.hide();
					}
					$state.go('app.contract', {
						roomId: room._id.toString()
					});
				}
            }, {
				id: 6,
				text: '退房',
				class: '',
				icon: 'ion-ios-download-outline',
				click: function (room) {
					var buttons = [{
						text: '预约退房'
                    }, {
						text: '立即退房'
                    }];
					var buttonFun = function (index) {
						if (index === 0) {
							$scope.preBack();
						} else if (index === 1) {
							if ($scope.modal) {
								$scope.modal.hide();
							}
							$state.go('app.backroom', {
								roomId: room._id
							});
						}
						return true;
					};
					var destructive = '<div style="height:40px;">租客逃租<div>',
						destructiveFun = function () {
							$Window.showConfirm('确认是逃租?', '逃租的租客将会进入系统黑名单,影响租客的信誉度!<br>您确认租客属于逃租吗?').then(function (isok) {
								if (isok) {
									if ($scope.modal) {
										$scope.modal.hide();
									}
									$state.go('app.backroom', {
										roomId: room._id,
										isRunBack: true
									});
								}
							});
							return true;
						};
					$Window.showActionSheet('选择退房方式', buttons, buttonFun, destructive, destructiveFun);
				}
            }, {
				id: 7,
				text: '取消退房',
				class: '',
				icon: 'ion-ios-undo-outline',
				href: undefined,
				click: function (room) {
					$scope.cancelPreBack();
				}
            }, {
				id: 8,
				text: '收费',
				class: 'assertive',
				icon: 'ion-social-usd-outline',
				href: undefined,
				click: function (room) {
					$scope.feedata.money = $scope.invoice.money;
					var invoice = $scope.invoice;
					var myPopup = $ionicPopup.show({
						template: ' \
                      <div class="row"> <div class="col">应收金额:</div><div class="col col-50">{{::feedata.money}}元</div> </div>\
                      <div class="row"> <div class="col">收费方式:</div> <div class="col"></div></div>\
                      <div > \
                        <div class="button-bar"> \
                          <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 0}" ng-click="feedata.feetype = 0">{{feedata.financeType[0]}}</a> \
                          <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 1}" ng-click="feedata.feetype = 1">{{feedata.financeType[1]}}</a> \
                          <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 2}" ng-click="feedata.feetype = 2">{{feedata.financeType[2]}}</a> \
                        </div> \
                        <div class="button-bar"> \
                          <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 3}" ng-click="feedata.feetype = 3">{{feedata.financeType[3]}}</a> \
                          <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 4}" ng-click="feedata.feetype = 4">{{feedata.financeType[4]}}</a> \
                        </div> \
                      </div>',
						title: '确认收费',
						subTitle: '请仔细核对租金单费用,并选择收费方式',
						scope: $scope,
						buttons: [{
							text: '取消'
                        }, {
							text: '<b>确认</b>',
							type: 'button-positive',
							onTap: function (e) {
								return true;
							}
                        }]
					});
					myPopup.then(function (res) {
						//console.log('Tapped!', res);
						myPopup.close();
						if (res) {
							var noprint = invoice.invoicestatus < DATALIST.INVOICE_STATUS.PRINT;
							//设置收费状态
							$Invoice.updateInvoiceHasFee(invoice, $scope.feedata).then(function (response) { //获取楼房未打印的租金单
								var buildingId = invoice.building && invoice.building._id ? invoice.building._id : invoice.building;
								var roomId = invoice.room && invoice.room._id ? invoice.room._id : invoice.room;
								if (buildingId && roomId) {
									$RoomValue.updateRoomValue(buildingId, roomId).then(function (roomvalues) {});
								}
								$scope.refreshRoomPopup(room);
								//$scope.refreshData(false);
								//如果之前未打印单据,则提示是否打印单据,否则显示收费完成提示
								if (noprint) {
									$Window.showConfirm('恭喜', '收费完成,是否打印单据?').then(function (ok) {
										if (ok) {
											$scope.doPrintInvoice(invoice);
										}
									});
								} else {
									$Window.showAlert('恭喜', '收费完成!');
								}
							});
						}
					});
				}
            }, {
				id: 9,
				text: '费用历史',
				class: '',
				icon: 'ion-ios-list-outline',
				// href: function(room) {
				//     return '#/app/room/' + room._id.toString() + '/invoices';
				// },
				click: function (room, invoices) {
					if ($scope.modal) {
						$scope.modal.hide();
					}
					$state.go('app.invoices', {
						roomId: room._id.toString()
					});
				}
            }, {
				id: 10,
				text: '续约',
				class: '',
				icon: 'ion-ios-loop',
				href: undefined,
				click: function (room) {
					var buttons = [{
						text: '自动续约'
                    }, {
						text: '手动续约'
                    }];
					var buttonFun = function (index) {
						if (index === 0) {
							$scope.autoRenew(room);
						} else if (index === 1) {
							$scope.renew(room);
						}
						return true;
					};
					$Window.showActionSheet('选择续约方式', buttons, buttonFun);
				}
            }, {
				id: 11,
				text: '设为自住',
				class: '',
				icon: 'ion-happy-outline',
				href: undefined,
				click: function (room) {
					$Window.showConfirm('设置为自住房?', '设置为自住房后,将不参与出租.').then(
						function (ok) {
							if (ok) {
								$Rent.disableRent(room._id).then(function (data) {
									$Room.setRoomIsOwn(room._id, data.prerent);
									setRoom(room);
									$scope.refreshRoomPopup(room);
									$Window.showAlert('恭喜', room.code +
										'已经设置为自住房!');
								});
							}
						});
				}
            }, {
				id: 12,
				text: '删除',
				class: '',
				icon: 'ion-trash-a',
				href: undefined,
				visible: false,
				click: function (room) {

				}
            }, {
				id: 13,
				text: '催缴',
				class: 'assertive',
				icon: 'ion-ios-chatbubble-outline',
				href: undefined,
				click: function (room) {
					if (room && room.rent && (room.rent.contract.customers.length === 0 || (room.rent.contract.customers.length > 0 && room.rent.contract.mobiles === 0))) {
						$Window.showAlert('抱歉', '请先设置租客电话!');
					} else {
						$Sms.sendInvoiceSms($scope.invoice.building, $scope.invoice._id).then(function () {
							$Window.showAlert('恭喜', $scope.invoice.code + '房催缴短信已发送!');
						}, function (err) {
							$Window.showAlert('失败', err.message || err);
						});
					}
				}
            }, {
				id: 14,
				text: '打印单据',
				class: '',
				icon: 'ion-ios-paper-outline',
				href: undefined,
				click: function (room) {
					if ($scope.modal) {
						$scope.modal.hide();
					}
					$Print.clearPrintData();
					$Print.addInvoiceData([$scope.invoice]);
					$state.go('app.printer');
				}
            }, {
				id: 15,
				text: '修改资料',
				class: '',
				icon: 'ion-ios-compose-outline',
				href: undefined,
				click: function (room) {
					if ($scope.modal) {
						$scope.modal.hide();
					}
					if (room.roomstatus !== DATALIST.ROOM_STATUS.NULL) {
						$state.go('app.room', {
							roomId: room._id
						});
					}
				}
            }, {
				id: 16,
				text: '收租',
				class: '',
				icon: 'ion-social-usd-outline',
				href: undefined,
				click: function (room) {
					if ($scope.modal) {
						$scope.modal.hide();
					}
					if ($scope.invoice && $scope.invoice.invoicestatus < DATALIST.INVOICE_STATUS.FINANCE) {
						$state.go('app.rent', {
							roomId: room._id,
							invoiceId: $scope.invoice._id
						});
					} else { //新增一期收租记录
						$Window.showConfirm('新增租金单?', '是否新增新一期的租金单?').then(
							function (ok) {
								if (ok) {
									$Rent.newInvoice($scope.building._id, $scope.room._id).then(function (newinvoice) {
										//更新房间最后收租单
										$Invoice.saveRoomLastInvoice2Cache(newinvoice);
										$scope.invoice = newinvoice;
										//更新房间状态为为收费
										$scope.room.roomstatus = DATALIST.ROOM_STATUS.NOFEE;
										$Room.updateRoom2Cache($scope.room);
										//转跳到收租页面
										$state.go('app.rent', {
											roomId: room._id,
											invoiceId: newinvoice._id
										});
									}, function (err) {
										$Window.showAlert('噢噢', '新增收租记录出错!');
									});
								}
							});
					}
				}
            }, {
				id: 17,
				text: '转让',
				class: '',
				icon: 'ion-share',
				href: undefined,
				click: function (room) {}
            }, {
				id: 18,
				text: '换房',
				class: '',
				icon: 'ion-ios-shuffle',
				href: undefined,
				click: function (room) {}
            }, {
				id: 19,
				text: '调租',
				class: '',
				icon: 'ion-ios-shuffle',
				href: undefined,
				click: function (room) {
					$scope.changeRoomPrice();
				}
            }, ],
			statusactions: [{
				status: 0,
				text: '自住',
				buttons: ['对外出租', '修改资料', '退租']
            }, {
				status: 1,
				text: '未出租',
				buttons: ['修改资料', '出租', '预订房间', '推广', '费用历史', '设为自住']
            }, {
				status: 2,
				text: '已预订',
				buttons: function (room) {
					//房间处于退房中?
					if (room && room.rent && room.rent.back && room.rent.back.backstatus === DATALIST.RENT_BACK_STATUS.WILLBACK) {
						return ['取消预订', '退房', '修改资料', '费用历史'];
					} else {
						return ['出租', '取消预订', '修改资料', '费用历史'];
					}
				}
            }, {
				status: 3,
				text: '已出租',
				buttons: ['退房', '修改资料', '收租', '调租', '费用历史']
            }, {
				status: 4,
				text: '未收费',
				buttons: ['催缴', '打印单据', '收费', '退房', '修改资料', '调租', '费用历史']
            }, {
				status: 5,
				text: '快到期',
				buttons: ['续约', '退房', '收租', '修改资料', '调租', '费用历史']
            }, {
				status: 6,
				text: '退房中',
				buttons: ['推广', '预订房间', '退房', '收租', '取消退房', '修改资料', '调租', '费用历史']
            }, {
				status: 7,
				text: '未设置',
				buttons: ''
            }, ]
		};
		//根据状态,计算需要显示的按钮
		$scope.getButtons = function (room) {
			var status = room.roomstatus;
			var result = [];
			var statusconfig = _.find(config.statusactions, {
				'status': status
			});
			if (statusconfig && statusconfig.buttons) {
				var buttons;
				//如果buttons是函数定义,则运行函数,动态获取按钮
				if (_.isFunction(statusconfig.buttons)) {
					buttons = statusconfig.buttons(room);
				} else {
					buttons = statusconfig.buttons;
				}
				_.forEach(buttons, function (button) {
					var action = _.find(config.actions, {
						'text': button
					});
					if (action) {
						result.push(action);
					}
				});
			}
			return result;
		};
		//弹出层操作按钮点击事件
		$scope.doRoomAction = function (button, room) {
			return button.click && button.click(room);
		};
		//清除RoomPopup
		$scope.clearRoomPopup = function () {
			if ($scope.modal) {
				$scope.modal.hide().then(function () {
					$scope.modal.remove().then(function () {
						$scope.modal = undefined;
					});
				});
			}
		};

		//手动续约
		$scope.renew = function (room) {
			$scope.renewData = {
				//默认续半年
				enddate: $Date.addMonths(new Date(room.rent.contract.enddate), 6),
				//默认租金不变
				price: room.rent.contract.price
			};
			var myPopup = $ionicPopup.show({
				templateUrl: 'templates/popup/renew.popup.html',
				title: '房间续约',
				scope: $scope,
				buttons: [{
					text: '取消'
                }, {
					text: '<b>确定</b>',
					type: 'button-positive',
					onTap: function () {
						var room = $scope.room;
						$Rent.renew(room._id, $scope.renewData, $scope.buildingId).then(function (data) {
							console.log('手动续约', data);
							$scope.refreshRoomPopup(room);
							$Window.showAlert('恭喜', $scope.room.code + '续约成功!');
						}, function (err) {
							$Window.showAlert('失败', $scope.room.code + '续约失败!');
						});
					}
                }]
			});
		};
		/***工具函数***/
		//更新统计
		function refreshCountInfo(fromServer) {
			fromServer = fromServer || false;
			$Invoice.getBuildingLastInvoicesCount($scope.buildingId, INVOICE_FILTER, fromServer).then(
				function (countinfo) {
					_.forEach(actions, function (action) {
						_.forEach(countinfo, function (info, key) {
							if (key === action.filter) {
								action.badge = info.count;
							}
						});
					});
					$scope.unfinance = {
						name: '未收',
						count: countinfo.UnFinance.count || 0,
						money: countinfo.UnFinance.money || 0
					};
				});
			$Product.getValueProducts(fromServer).then(function (valueproducts) {
				var products = _.map(valueproducts, '_id');
				$RoomValue.getBuildingUnReadValueCount($scope.buildingId, products, fromServer).then(function (pvalues) {
					var menuitem = _.find(actions, function (action) {
						return action.text === '批量抄表';
					});
					if (menuitem) {
						menuitem.badge = 0;
						_.forEach(pvalues, function (pcount) {
							menuitem.badge += pcount.count;
						});
					}
				});
			});
		}

		/***整理房间列表到缓存***/
		function saveRoomList2Cache(building, rooms) {
			//清除该楼房的原有记录
			var table = $Cache.get('rooms');
			if (table) {
				var delRooms = _.reduce(table, function (result, room, key) {
					if (key !== '_ids' && room.building === building) {
						result.push(key);
					}
					return result;
				}, []);
				_.forEach(delRooms, function (roomid) {
					delete table[roomid];
				});
			}

			//插入新纪录与ids
			var roomids = [];
			_.forEach(rooms, function (room) {
				roomids.push(room._id);
				$Cache.addRecord('rooms', room._id, room);
			});
			$Cache.addRecord('rooms', '_ids', roomids);
			$Cache.saveTable('rooms');
		}

		//设置房间列表
		function setRooms(buildingId, rooms) {
			$scope.rooms = rooms;
			$scope.nullrooms = 0;
			$scope.roomcount = 0;
			//增加计算字段
			_.forEach($scope.rooms, function (room) {
				if (room.roomstatus === DATALIST.ROOM_STATUS.NULL) {
					$scope.nullrooms++;
				}
				$scope.roomcount++;
			});
			//整理楼层及房间
			$scope.floorrooms = $Room.groupRooms(buildingId, $scope.rooms);
		}

		//取消预订
		$scope.cancelOrder = function () {
			var room = $scope.room;
			$Rent.cancelOrder(room).then(function (data) {
				console.log(data);
				$Room.setRoomCancelOrder(room._id, data.roomstatus);
				$scope.refreshRoomPopup(room);
				$Window.showAlert('恭喜', $scope.room.code + '取消预订成功!');
			}, function (err) {
				console.log(err);
				$Window.showAlert('失败', $scope.room.code + '取消预订失败!');
			});
		};
		//自动续约
		$scope.autoRenew = function (room) {
			$Window.showConfirm('提示', '自动续约后将变为无固定期限模式,是否自动续约?').then(function (ok) {
				if (ok) {
					$Rent.autoRenew(room._id, $scope.buildingId).then(function (data) {
						console.log('自动续约', data);
						$scope.refreshRoomPopup(room);
						$Window.showAlert('恭喜', $scope.room.code + '续约成功!');
					}, function (err) {
						$Window.showAlert('失败', $scope.room.code + '续约失败,请稍后重试!');
					});
				}
			});
		};
		//租金单详情
		$scope.goInvoice = function (invoice) {
			if ($scope.modal) {
				$scope.modal.hide();
			}
			$state.go('app.rent', {
				roomId: invoice.room,
				invoiceId: invoice._id
			});
		};
		//合同详情
		$scope.contractDetail = function (room) {
			if ($scope.modal) {
				$scope.modal.hide();
			}
			$state.go('app.contractdetail', {
				roomId: room._id
			});
		};
		//增加租客
		$scope.addCustomer = function () {
			$scope.CustomerWindow.new($scope.room, {
				onBeforNew: null,
				onAfterNew: $scope.doNewCustomer
			});
			$ionicListDelegate.closeOptionButtons();
		};

		$scope.doNewCustomer = function (customer) {
			if ($scope.room.rent && $scope.room.rent.contract) {
				// $scope.room.rent.contract.customers.push(customer);
				$Room.addCustomer4Cache($scope.room._id, customer);
			}
		};

		//打开窗口
		$scope.editCustomer = function (customer) {
			$scope.CustomerWindow.edit($scope.room, customer, {
				onBeforEdit: null,
				onAfterEdit: $scope.doEditCustomer
			});
			$ionicListDelegate.closeOptionButtons();
		};

		//编辑租客
		$scope.doEditCustomer = function (customer, room) {
			//$scope.rentData.customers.push(customer);
			$Room.editCustomer4Cache($scope.room._id, customer);
		};
		//删除租客
		$scope.deleteCustomer = function (customer) {
			$Window.showConfirm('警告', '确认删除租客' + customer.realname + '?').then(function (ok) {
				if (ok) {
					$Customer.deleteCustomer(customer, $scope.room).then(function () {
						if ($scope.room.rent && $scope.room.rent.contract) {
							_.remove($scope.room.rent.contract.customers, function (item) {
								return item._id === customer._id;
							});
						}
						$Room.deleteCustomer4Cache($scope.room._id, customer);
						$ionicListDelegate.closeOptionButtons();
					});
				}
			});
		};

		//租客信息
		$scope.showCustomerAction = function (customer) {
			var btnclass = customer.mobile ? '' : 'MobileNumer';
			var buttons = [{
				text: '<span class="call"><b class ="' + btnclass + '"><i class="ion-ios-telephone"></i> 通话</b></span>'
            }, {
				text: '<span class="call"><b class ="' + btnclass + '"><i class="ion-ios-chatbubble"></i> 短信</b></span>'
            }, {
				text: '<i class="ion-ios-compose-outline"></i> 修改'
            }, ];
			var buttonFun = function (index, room, mobile) {
				if (index === 0) {
					$scope.callPhone(customer.mobile);
				} else if (index === 1) {
					$scope.sendSms(customer.mobile);
					if (customer.mobile) {
						$scope.active = false;
					}
				} else if (index === 2) {
					if ($scope.modal) {
						$scope.modal.hide();
					}
					$scope.editCustomer(customer);
				}
				return true;
			};
			var destructive = '<i class="ion-trash-a"></i> 删除',
				destructiveFun = function () {
					$scope.deleteCustomer(customer);
					return true;
				};
			$Window.showActionSheet(customer.realname, buttons, buttonFun, destructive, destructiveFun);
			//
			// //                    var hideSheet =
			// $ionicActionSheet.show({
			//     buttons: [{
			//         text: '通话 <i class="ion-ios-telephone"></i>'
			//     }, {
			//         text: '短信 <i class="ion-ios-chatbubble"></i>'
			//     }],
			//     destructiveText: '修改 <i class="ion-ios-compose-outline"></i>',
			//     titleText: '',
			//     cancelText: '取消',
			//     cancel: function() {
			//         // add cancel code..
			//     },
			//     buttonClicked: function(index) {
			//         return true;
			//     }
			// });

			//                    $timeout(function() {
			//                        hideSheet();
			//                    }, 2000);

		};

		//点击房间弹出层关闭按钮
		$scope.closeModal = function (hide) {
			$scope.modal.hide();
			$scope.modalClosed = true;
		};

		//刷新操作弹层的数据,返回Promise
		$scope.invoice = null;
		$scope.refreshRoomPopup = function (room) {
			var promises = [];
			//刷新按钮
			$scope.popupButtons = $scope.getButtons(room);
			//刷新显示标志
			$scope.isShowContract = room.rent && room.rent.contract && 1 === 1;
			$scope.isShowInovice = $scope.isShowContract;
			$scope.isShowCustomer = $scope.isShowContract;
			$scope.isShowadjustRent = $scope.isShowContract;
			$scope.isShowOrderInfo = room && room.roomstatus !== DATALIST.ROOM_STATUS.RENT && room.prerent && room.prerent.preinfo && 1 === 1;
			$scope.isShowWillBackTime = room.roomstatus === DATALIST.ROOM_STATUS.BACKING || (room.rent && room.rent.back && room.rent.back.backstatus === DATALIST.RENT_BACK_STATUS.WILLBACK);
			//刷新数据
			if (room.roomstatus !== DATALIST.ROOM_STATUS.NULL) {
				//如果已经出租,且不包含租客详细信息,则在此处完善
				if (room && room.rent && room.rent.contract && _.isArray(room.rent.contract.customers) && room.rent.contract.customers.length > 0) {
					promises.push($Customer.getRoomCustomers(room).then(function (customers) {
						_.remove(customers, function (item) {
							return !item || !item._id;
						});
						return customers;
					}, function (err) {
						return $q.reject(err);
					}));
				}
				//获取调租记录
				promises.push($PriceLog.getRoomPriceLog(room._id, false).then(function (
					pricelogs) {
					room.pricelogs = pricelogs;
					return pricelogs;
				}, function (err) {
					room.pricelogs = [];
					return $q.reject(err);
				}));
				//获取最后一期缴费数据
				if (!_.contains([DATALIST.ROOM_STATUS.OWN, DATALIST.ROOM_STATUS.EMPTY, DATALIST.ROOM_STATUS.NULL], room.roomstatus)) {
					promises.push($Invoice.getRoomLastInvoice(room.building, room._id, false).then(function (invoice) {
						if (!invoice) return;
						if (invoice.invoicestatus < DATALIST.INVOICE_STATUS.FINANCE) {
							invoice.statusstr = '未收费';
						} else {
							invoice.statusstr = DATALIST.getEnumStr(DATALIST.INVOICE_STATUS
								.enum, invoice.invoicestatus);
						}
						if (invoice.invoicestatus === DATALIST.INVOICE_STATUS.FINANCE && invoice.financelog) {
							invoice.paytype = DATALIST.getEnumStr(DATALIST.FINANCE_PAYTYPE.enum, invoice.financelog.paytype);
						} else {
							invoice.paytype = '';
						}
						invoice.mobile = invoice.customers && invoice.customers.length > 0 ? invoice.customers[
							0].mobile : '';

						$scope.invoice = invoice;
						return invoice;
					}, function (err) {
						return $q.reject(err);
					}));
				}
				//批量执行,返回promise
				return $q.all(promises);
			}
		};
		$scope.clickRoom = function (room) {
			if (room.roomstatus !== DATALIST.ROOM_STATUS.NULL) {
				$scope.room = room;
				$scope.refreshRoomPopup(room).then(function (results) {
					//显示操作弹层
					if (!$scope.modal) {
						$ionicModal.fromTemplateUrl('./templates/popup/room.popup.html', {
							scope: $scope,
							animation: 'slide-in-up'
						}).then(function (modal) {
							$scope.modal = modal;
							$scope.modalClosed = false;
							$scope.modal.show();
						});
					} else {
						$scope.modalClosed = false;
						//$scope.modal.animation = 'slide-in-up';
						$scope.modal.modalEl.className = $scope.modal.modalEl.className.replace('slide-in-left', 'slide-in-up');
						$scope.modal.show();
					}
				});
			} else {
				if ($scope.modal) {
					$scope.modal.hide();
				}
				var buttons = [{
					text: '<div class="assertive">未出租 (推广)</div>'
                }, {
					text: '<b>已出租</b>'
                }, {
					text: '自住'
                }];
				var buttonFun = function (index) {
					if (index === 2) {
						$Room.initRoom($scope.buildingId, room._id, {
							roomstatus: DATALIST.ROOM_STATUS.OWN
						});
					} else if (index === 0) {
						if ($scope.modal) {
							$scope.modal.hide();
						}
						$Room.initRoom($scope.buildingId, room._id, {
							roomstatus: DATALIST.ROOM_STATUS.EMPTY
						});
					} else if (index === 1) {
						if ($scope.modal) {
							$scope.modal.hide();
						}
						$state.go('app.initroom', {
							roomId: room._id
						});
					}
					return true;
				};
				$Window.showActionSheet('初始化房间状态', buttons, buttonFun);
			}
		};
		//获得总押金，房租押金，产品费用押金
		$scope.getPledgeStr = function (contract) {
			var result = '',
				money = 0,
				pledgestr = '';
			if (contract) {
				money = contract.pledge || 0;
				if (contract.products && contract.products.length > 0) {
					_.forEach(contract.products, function (product) {
						if (product.pledge && product.pledge > 0) {
							money += product.pledge;
						}
					});
				}
				result = money.toString();
			}
			return result;
		};
		$scope.changeRoomPrice = function () {
			var price = $scope.room.price;
			if (!price && $scope.room.rent && $scope.room.rent.contract) {
				price = $scope.room.rent.contract.price;
			}
			$scope.pricedata = {
				begindate: new Date(),
				price: price + 50
			};
			var rentday = $scope.building && $scope.building.settings ? $scope.building.settings.rentdate : 0;
			$scope.pricedata.begindate = $Date.getRentEndDay(new Date(), rentday);
			$Date.addDays($scope.pricedata.begindate, 1);
			// An elaborate, custom popup
			var productPopu = $ionicPopup.show({
				template: '\
            <label class="item item-input"><span class="input-label">生效日期</span> \
              <input class="nopadding" type="date" ng-model="pricedata.begindate"> \
            </label> \
            <label class="item item-input"><span class="input-label">租金调至</span> \
              <input class="nopadding" type="number" ng-model="pricedata.price"> \
            </label>',
				title: '调租',
				scope: $scope,
				buttons: [{
					text: '取消'
                }, {
					text: '<b>确定</b>',
					type: 'button-positive',
					onTap: function (e) {
						if (!$scope.pricedata.begindate && $scope.pricedata.price >
							0) {
							//除非输入生效日期和正确金额,否则不允许用户关闭对话框
							e.preventDefault();
						} else {
							return $scope.pricedata;
						}
					}
                }, ]
			});

			productPopu.then(function (pricedata) {
				console.log('Tapped!', pricedata);
				productPopu.close();
				if (pricedata) {
					console.log('Tapped!', pricedata);

					$PriceLog.addPriceLog($scope.room._id, pricedata).then(
						function (pricelog) {
							//将房屋价格保存到缓存
							if (new Date(pricelog.begindate) <= new Date()) {
								$scope.room.begindate = pricelog.begindate;
								$scope.room.price = pricelog.price;
								if ($scope.room.rent && $scope.room.rent.contract) {
									$scope.room.rent.contract.price = pricelog.price;

								}
								$scope.room.price = pricelog.price;
								$Room.updateRoom2Cache($scope.room);
							}
							//刷新界面
							var cachelog = _.find($scope.room.pricelogs, function (
								item) {
								return item.begindate === pricelog.begindate;
							});
							if (cachelog) {
								// if (!$scope.$phase) {
								//     $scope.$apply(function() {
								//         cachelog.price = pricelog.price;
								//     });
								// } else {
								//     cachelog.price = pricelog.price;
								// }
								cachelog.price = pricelog.price;
							} else {
								$scope.room.pricelogs.push(pricelog);
								$scope.room.pricelogs = _.sortBy($scope.room.pricelogs,
									function (item) {
										return new Date(item.begindate);
									});
							}
							$Window.showConfirm('调租完成', '是否发送短信通知租客?').then(
								function (ok) {
									if (ok) {
										$Sms.sendChangePriceSms($scope.room, pricelog).then(
											function () {
												$Window.showAlert('恭喜', '调租短信已发送成功!');
											});
									}
								});
						});
				}
			});
		};
		//取消调租
		$scope.deletePriceLog = function (pricelog) {
			$Window.showConfirm('取消调租', '是否取消' + $filter('date')(pricelog.begindate,
				'yy年MM月dd日') + '的调租?').then(function (ok) {
				if (ok) {
					$PriceLog.deletePriceLog(pricelog).then(function () {
						_.remove($scope.room.pricelogs, function (item) {
							return item._id === pricelog._id;
						});
						$Window.showAlert('恭喜', '取消调租成功!');
					});
				}
			});
		};
		/**********预约退房**********/
		$scope.preBack = function () {
			$scope.preBackData = {};
			//获取最后租金单信息
			$Invoice.getRoomLastInvoice($scope.room.building, $scope.room._id).then(function (invoice) {
				if (invoice && invoice.enddate && invoice.enddate > new Date()) {
					$scope.preBackData.backDay = invoice.enddate;
				} else {
					var rentday = $scope.building && $scope.building.settings ? $scope.building.settings.rentdate : 0;
					$scope.preBackData.backDay = $Date.getRentEndDay(new Date(), rentday);
				}
				var myPopup = $ionicPopup.show({
					template: '<input type="date" ng-model="preBackData.backDay">',
					title: '预计哪一天退房?',
					subTitle: '请选择租客预约退房的日期',
					scope: $scope,
					buttons: [{
						text: '取消'
                    }, {
						text: '<b>预约退房</b>',
						type: 'button-positive',
						onTap: function (e) {
							return $scope.preBackData.backDay;
						}
                    }]
				});

				myPopup.then(function (preBackDay) {
					if (preBackDay) {
						$Rent.preBack($scope.building._id, $scope.room._id, {
							backdate: preBackDay
						}).then(function (room) {
							$scope.refreshRoomPopup(room);
							$Window.showAlert('恭喜', '预约退房成功!<br>同时我们已经开始帮您推广该房间!');
						}, function (err) {
							$Window.showAlert('失败', err.message ? err.message : err.toString());
						});
					}
				});
			});
		};

		/**********取消预约退房**********/
		$scope.cancelPreBack = function () {
			$Rent.cancelPreBack($scope.building._id, $scope.room._id).then(function (room) {
				$scope.refreshRoomPopup(room);
				$Window.showAlert('恭喜', '取消成功!<br>该房间目前为正常出租状态!');
			}, function (err) {
				$Window.showAlert('失败', err.message ? err.message : err.toString());
			});
		};
		//预订房间合同显示
		$scope.orderDetail = function (room) {
			if ($scope.modal) {
				$scope.modal.hide();
			}
			$state.go('app.roomorder', {
				roomId: room._id
			});
		};
		//联系预定租客
		$scope.callOrderCustomer = function (mobile) {
			if (mobile) {
				$scope.callPhone(mobile);
			}
		};
		/***远程请求***/
		$scope.getBuildingRooms = function (buildingId, isRefresh) {
			isRefresh = isRefresh || false;
			$Room.getBuildingRooms(buildingId, isRefresh).then(function (roomlist) {
					setRooms(buildingId, roomlist);
					$Analysis.getBuildingCurrentAnalysis(buildingId, isRefresh).then(function (analysis) {
						$scope.analysis = analysis;
					});
					//刷新时同时获取该楼房的所有调租记录
					if (isRefresh) {
						$PriceLog.getBuildingPriceLogs(buildingId, isRefresh).then(function (pricelogs) {
							//console.log('Fetch pricelogs',pricelogs);
						});
					}
				})
				.finally(function () {
					// Stop the ion-refresher from spinning
					if (isRefresh) {
						$scope.$broadcast('scroll.refreshComplete');
					}
				});
		};
		//下拉更新
		$scope.doRefresh = function () {
			$scope.getBuildingRooms($scope.buildingId, true);
			//刷新统计信息
			refreshCountInfo(true);
		};

		$scope.getRoomColor = function (roomstatus) {
			return ROOM_COLORS[roomstatus] ? ROOM_COLORS[roomstatus] : ROOM_COLORS[100];
		};

		$scope.getStatusMsg = function (roomstatus) {
			return DATALIST.ROOM_STATUS.enum[roomstatus];
		};

		$scope.getPriceStr = function (roomstatus, price) {
			return roomstatus === DATALIST.ROOM_STATUS.OWN ? DATALIST.ROOM_STATUS.enum[roomstatus] : '¥' + price;
		};

		/***修改楼房***/
		$scope.editBuilding = function () {
			//显示修改楼房窗口
			$scope.BuildingWindow.edit(_.cloneDeep($scope.building),{
				onAfterEdit: function (result) {
					//设置菜单项目
					$scope.setActionMenus(actions);
					//设置菜单引用对象
					$scope.setActionData($scope);
				}
			});
		};

		/***显示财务统计***/
		$scope.showAnalysis = function () {
			$state.go('app.analysis', {
				buildingId: $scope.buildingId
			});
		};

		/***房间管理模式,点击房间***/
		$scope.onManageRoomClick = function (room) {
			var buttons = [{
				text: '<div style="height:40px;">设置房间信息<div>'
            }, {
				text: '复制房间'
            }];
			var buttonFun = function (index) {
				if (index === 0) {
					$state.go('app.room', {
						roomId: room._id
					});
				} else if (index === 1) {
					$scope.cloneRoom(room);
				}
				return true;
			};
			var destructive = '删除房间';
			var destructiveFun = function (index) {
				//房间未出租?
				if (room.roomstatus >= DATALIST.ROOM_STATUS.RENT || room.roomstatus === DATALIST.ROOM_STATUS.NULL) {
					$Window.showAlert('提示', '已出租房间无法删除,请先执行退房操作!');
				} else {
					$Window.showConfirm('警告', '删除房间后将无法恢复,确认删除吗?').then(function (isOk) {
						if (isOk) {
							$Room.deleteRoom($scope.buildingId, room._id).then(function (room) {
								$scope.getBuildingRooms($scope.buildingId, true);
								$Window.showAlert('恭喜', '操作成功!');
							});
						}
					});
				}
				return true;
			};
			$Window.showActionSheet('房间管理(' + room.code + ')', buttons, buttonFun, destructive, destructiveFun);
		};
		/***房间管理模式,新增房间***/
		$scope.addRoom = function (floor) {
			// function padLeft(str, length) {
			// 	if (str.length < length) {
			// 		str = '0' + str;
			// 		return padLeft(str, length);
			// 	} else {
			// 		return str;
			// 	}
			// }
			//
			// function getRightNumberIndex(str) {
			// 	var result = 0;
			// 	for (var i = str.length - 1; i >= 0; i--) {
			// 		var code = str.charCodeAt(i);
			// 		if (code >= 48 || code <= 57) {
			// 			continue;
			// 		} else {
			// 			result = i;
			// 			break;
			// 		}
			// 	}
			// 	return result;
			// }
			//
			// function getRightNumber(str) {
			// 	return str.substr(getRightNumberIndex(str));
			// }
			//
			// function incRightNumber(str) {
			// 	var index = getRightNumberIndex(str);
			// 	var rNum = getRightNumber(str);
			// 	var num = Number(rNum);
			// 	num++;
			// 	return str.substr(0, index - 1) + padLeft(num.toString(), rNum.length);
			// }
			//获取指定楼层的所有房间
			var floorRooms = _.filter($scope.rooms, function (item) {
				return item.floor.toString() === floor.toString();
			});
			//获取最大房间号
			var maxCode = floor.toString() + '01';
			var maxRoom = _.max(floorRooms, 'code');
			if (maxRoom && maxRoom.code) {
				maxCode = $Str.incRightNumber(maxRoom.code);
			}
			//新增房间
			var newroom = {
				_id: undefined,
				rent: undefined,
				prerent: undefined,
				floor: floor,
				code: maxCode
			};
			$Room.addRoom($scope.buildingId, newroom).then(function (room) {
				$scope.getBuildingRooms($scope.buildingId, true);
				//$Window.showAlert('恭喜', '操作成功!');
			});
		};
		/***房间管理模式,新增房间***/
		$scope.cloneRoom = function (room) {
			var newroom = _.cloneDeep(room);
			newroom = _.assign(newroom, {
				_id: undefined,
				rent: undefined,
				prerent: undefined
			});
			$Room.addRoom($scope.buildingId, newroom).then(function (room) {
				$scope.getBuildingRooms($scope.buildingId, true);
				//$Window.showAlert('恭喜', '操作成功!');
			});
		};

		/***初始化数据***/
		function refreshData() {
			//获取楼房信息
			$Building.getBuilding($scope.buildingId).then(function (building) {
				$scope.title = building.name;
				// _.forEach(building.defaultproducts, function(product){
				//   product._id = product.product;
				// });
				// $Product.fixOrderProducts(building.defaultproducts);
				$scope.building = building;
				//统一收租选项
				$scope.rentdateSelect = _.range(0, 32);
				$scope.delaysSelect = _.range(1, 16);
				$scope.beforeSelect = _.range(1, 11);

				//获取房间列表
				$scope.getBuildingRooms($scope.buildingId);
			});
		}
		refreshData();

		/***监听事件***/
		//房间状态发生变化
		// $scope.$on(EVENTS.CACHE.ROOMREFRESH, function(newroom) {
		//   newroom.statusmsg = DATALIST.ROOM_STATUS.enum[newroom.roomstatus];
		//   _.forEach($scope.floorrooms, function(floor) {
		//     _.forEach(floor.rooms, function(room) {
		//       if (room._id === newroom._id) {
		//         _.assign(room, newroom);
		//       }
		//     });
		//   });
		// });

		// 模态窗口关闭
		$scope.$on('modal.hidden', function () {
			//
		});
		//退出时清理菜单对象
		$scope.$on('$destroy', function () {

		});
		//返回到缓存页面
		$scope.$on('$ionicView.beforeEnter', function (e) {
			//设置菜单项目
			$scope.setActionMenus(actions);
			//设置菜单引用对象
			$scope.setActionData($scope);
			//是否需要刷新数据?
			$Room.getBuildingRooms($scope.buildingId, false).then(function (roomlist) {
				var roomcount = 0;
				_.forEach(roomlist, function(item){
					roomcount++;
				});
				if(roomcount !== $scope.roomcount){
					$scope.getBuildingRooms($scope.buildingId,false);
				}
			});
			//刷新统计信息
			refreshCountInfo();
			//显示弹出层?
			if ($scope.modal && !$scope.modalClosed) {
				$scope.modal.modalEl.className = $scope.modal.modalEl.className.replace('slide-in-up', 'slide-in-left');
				$scope.refreshRoomPopup($scope.room);
				$scope.modal.show();
			}
		});
	});
