angular.module('bagu.controllers')
	//区域列表+楼房列表
	.controller('BuildingsCtrl', function ($rootScope, $scope, $stateParams, $ionicHistory, $ionicModal, $http,
		//MapPosition,
		$ionicActionSheet, $state, _,
		EVENTS, $Window, DATALIST, $Cache, $Product, $Building, $Room, $Invoice, $Analysis) {
		/***定义变量***/
		//过滤条件定义
		var INVOICE_FILTER = {
			UnPrint: [DATALIST.INVOICE_STATUS.CREATE],
			UnFinance: [DATALIST.INVOICE_STATUS.CREATE, DATALIST.INVOICE_STATUS.CONFIRM,
        DATALIST.INVOICE_STATUS.PRINT
      ]
		};

		/***显示Http返回错误***/
		function showHttpError(data, status, headers, config) {
			//只处理业务错误,权限错误由appctrl处理
			if (status === 400) {
				var msg = data.message || '加载数据出错,请稍后重试!';
				$Window.showAlert('抱歉', msg).then(function (res) {
					$ionicHistory.goBack();
				});
			}
		}

		/***设置楼房列表***/
		function setBuildings(buildings) {
			// var buildingarray = [];
			// _.forEach(_.sortBy(buildings, 'createtime'), function(item){
			// 	buildingarray.push(item);
			// });
			// $scope.buildings = buildingarray;
			$scope.buildings = _.sortBy(buildings, 'createtime');
		}

		/***新增楼房***/
		$scope.addBuilding = function () {
			$scope.BuildingWindow.new(null, {
				onBeforNew: function (building) {
					if ($stateParams.netareaId) {
						building.netarea = $stateParams.netareaId;
						return true;
					}
				},
				onAfterNew: function (result) {
					//service自动将新增对象加入到缓存,自动反应到$scope.buildings中.无需再做操作.
					setBuildings($scope.buildings);
					$scope.doRefresh(false);
				}
			});
		};

		//打开百度地图定位
		$scope.openPostionMpa = function () {
			// MapPosition.show({
			//   longitude: 121.506191,
			//   latitude: 31.245554,
			//   templateUrl: 'templates/map.baidu.html',
			//   save: function(position){
			//     console.log('save position', position);
			//     $scope._buildingNew.address = position.address;
			//   },
			//   close: function(){
			//     console.log('close position');
			//   }
			// });
			console.log('open postion map');
		};

		$scope.isMapOpen = false;

		/**********增加收费项目**********/
		//更新列表
		$scope.doRefresh = function (fromServer) {
			fromServer = fromServer || false;
			setTimeout(function(){
				$Building.getBuildings(fromServer).then(function (buildings) {
					//缓存发生变化才进行更行
					if ($scope.buildings !== buildings) {
						setBuildings(buildings);
					}
					//如果不存在楼房数据,则认为新注册用户,提示是否新增楼房
					if (!buildings || (_.isArray(buildings) && buildings.length === 0) || (Object.getOwnPropertyNames(buildings).length === 0)) {
						$Window.showConfirm('新增楼房', '您还未初始化楼房信息,现在新增楼房?').then(function (isok) {
							if (isok) {
								$scope.addBuilding();
							}
						});
					} else {
						// //刷新界面
						// $scope.$digest();
						_.forEach(buildings, function (building) {
							building.statusinfo = {};
							$Room.getBuildingRoomStatusCount(building, fromServer).then(function (countinfo) {
								building.statusinfo.empty = (countinfo[DATALIST.ROOM_STATUS.EMPTY] || 0) + (countinfo[DATALIST.ROOM_STATUS.NULL] || 0);
								building.statusinfo.order = countinfo[DATALIST.ROOM_STATUS.ORDER] || 0;
								building.statusinfo.back = countinfo[DATALIST.ROOM_STATUS.BACKING] || 0;
								building.statusinfo.expire = countinfo[DATALIST.ROOM_STATUS.WILLEXPIRE] || 0;
								$Invoice.getBuildingLastInvoicesCount(building._id, INVOICE_FILTER, fromServer).then(function (countinfo) {
								  building.statusinfo.unfinance = {
	                  count: countinfo.UnFinance.count || 0,
	                  money: countinfo.UnFinance.money || 0
	                };
								});
								// //刷新界面
								// $scope.$digest();
							});
							$Analysis.getBuildingCurrentAnalysis(building, fromServer).then(function (analysis) {
								building.analysis = analysis;
								// //刷新界面
								// $scope.$digest();
							});
						});
					}
				}, function (err, status, headers, config) {
					if (status === 400) {
						showHttpError(err, status, headers, config);
					}
				}).finally(function () {
					if (fromServer) {
						$scope.$broadcast('scroll.refreshComplete');
					}
				});
			},10);
		};

		//长按楼房,出现操作列表:删除,设置
		$scope.onBuildingHold = function (building) {
			var buttons = [{
				text: '<div style="height:40px;">楼房设置<div>'
      }];
			var bid = building._id,
				bname = building.name;
			var buttonFun = function (index) {
				$scope.BuildingWindow.edit(_.cloneDeep(building), {
					onAfterEdit: function (building) {
						setBuildings($scope.buildings);
					}
				});
				return true;
			};
			var destructive = '删除楼房';
			var destructiveFun = function (index) {
				$scope.BuildingWindow.delete(building, {
					onAfterDelete: function (building) {
						_.remove($scope.buildings,function(item){
							return item._id === bid;
						});
						setBuildings($scope.buildings);
					}
				});
				return true;
			};
			$Window.showActionSheet(bname, buttons, buttonFun, destructive, destructiveFun);
		};


		/***初始化列表***/
		//console.log('Fetch buildings');
		// //缓存中读取产品列表
		// $scope.doRefreshProducts(false);
		//缓存中读取楼房列表
		$scope.doRefresh(false);

		//设置标题
		$scope.title = '主页';
		//统一收租选项
		$scope.rentdateSelect = _.range(0, 32);
		$scope.delaysSelect = _.range(1, 16);
		$scope.beforeSelect = _.range(1, 11);

		$scope.$on('$ionicView.enter', function (e) {

		});

		$scope.$on('$ionicView.afterEnter', function () {
			//缓存中读取楼房列表
			//$scope.doRefresh(false);
		});
	});
