angular.module('bagu.controllers')
  //房间费用历史
  .controller('CacheValueLogsCtrl', function($scope, $stateParams, $ionicPopover, $ionicPopup, $ionicScrollDelegate,
    $http, $Cache, $state, _, DATALIST, $Window, $Print, $Building, $Room, $Product, $RoomValue, $Invoice, $Sms) {

    /***参数定义***/
    //url参数
    //设置标题
    $scope.title = '离线抄表记录';
    //默认缓存抄表记录
    $scope.valuelogcachedb = [];

    /***工具函数***/
    //操作缓存抄表记录doValuelogClick
    $scope.doValuelogClick = function(valuelog) {
      var buttons = [{
        text: '<div style="height:40px;">优先处理<div>'
      }];
      var buttonFun = function(index) {
        $RoomValue.resetValueLogCacheRetry(valuelog);
        return true;
      };
      var destructive = '删除抄表记录';
      var destructiveFun = function(index) {
        $RoomValue.deleteValueLogCacheObj(valuelog);
        return true;
      };
      $Window.showActionSheet(valuelog.code, buttons, buttonFun, destructive, destructiveFun);
    };

    //刷新数据
    $scope.refreshData = function() {
      //获取缓存抄表记录
      var valuelogcachedb = $RoomValue.getValueLogCacheDB();
      //修正相关数据(楼房名,房间号,产品名,产品单位)
      _.forEach(valuelogcachedb.opdata, function(log) {
        //楼房名
        if (log.buildingId && !log.buildingname) {
          var cbuilding = $Building.getCacheBuilding(log.buildingId);
          if (cbuilding) {
            log.buildingname = cbuilding.name;
          }
        }
        //房间名
        if (log.roomId && !log.code) {
          $Room.getCacheRoom(log.roomId).then(function(croom) {
            if (croom) {
              log.code = croom.code;
            }
          });
        }
        //产品名,产品单位
        if (log.productId && (!log.productname || !log.unit)) {
          var cproduct = $Product.getCacheProduct(log.productId);
          if (cproduct) {
            log.productname = cproduct.name ? cproduct.name.replace('费', '表') : '';
            log.unit = cproduct.unit;
          }
        }
      });

      $scope.valuelogcachedb = valuelogcachedb;
    };
    /***初始化数据***/
    //获取楼房未打印的租金单
    $scope.refreshData();

    //返回到缓存页面
    var firstrun = true;
    $scope.$on('$ionicView.enter', function(e) {
      //需要刷新列表?
      if (firstrun) {
        firstrun = false;
        return;
      }
      if (!firstrun) {
        $scope.refreshData();
      }
    });
  });
