
angular.module('bagu.controllers')
//抄表
.controller('RoomContractCtrl', function($scope, $stateParams, $ionicPopup, $http, $ionicHistory , $ionicLoading, $state, $ionicModal, _,
  $Date, $Window, $Cache, $Invoice, $Rent, $Print, $Building, $Room, $RoomValue, $Product, $Customer, DATALIST, EVENTS) {
  /***保存参数***/
  $scope.roomId = $stateParams.roomId;
  $scope._customerNew = {credentialstype: '身份证'};

  /***工具函数***/

  //获取最后抄表记录数作为底表数 Cache -> buildingID -> productID -> roomID
  function fixProductValue(buildingId,product,roomId){
    product.value = 0;
    $RoomValue.getRoomValue(buildingId,product._id,roomId).then(function(valueitem){
      if(valueitem){
        if(_.isNumber(valueitem.value) && valueitem.value > 0){
          product.value = valueitem.value;
        }else if(_.isNumber(valueitem.lastvalue) && valueitem.lastvalue > 0){
          product.value = valueitem.lastvalue;
        }else{
          product.value = 0;
        }
      }
    });
  }

  //设置出租数据
  function setRentData(room){
    var begindate = new Date(),
        enddate = new Date();
    //判断room是否为空
    if(!room){
      return;
    }
    //从缓存中取抄表楼房默认收费项目信息
    $Building.getBuilding(room.building).then(function(building){
      //判断building是否为空
      building = building || {};

      //默认合同期限为1年
      enddate.setFullYear(begindate.getFullYear() + 1);
      //设置了统一收租日期? 自动计算合适的第一期收租截止日(大于15天)
      if(building && building.settings && building.settings.rentdate !== 0){
        enddate.setFullYear(enddate.getFullYear(),enddate.getMonth(),building.settings.rentdate);
        var days = parseInt((enddate-begindate)/(24*3600*1000));
        if(days<365){
          enddate.setFullYear(enddate.getFullYear(),enddate.getMonth()+1);
        }
        enddate.setFullYear(enddate.getFullYear(),enddate.getMonth(),building.settings.rentdate-1);
      }
      //修正默认收费项目数据
      var defaultproducts = [];
      if(building.defaultproducts && building.defaultproducts.length > 0){
        //复制数组
        defaultproducts = building.defaultproducts.concat();
        _.forEach(defaultproducts, function(product){
         product._id = product.product;
        });
        $Product.fixOrderProducts(defaultproducts);
      }
      //如果是按量计费项目,则获取最后抄表记录作为底数
      _.forEach(defaultproducts, function(defproduct){
        fixProductValue(building._id,defproduct,room._id);
      });

      //签约数据
      $scope.rentData = {
        contract: { //合同信息
          price: room.price,
          pledge: room.pledge,
          payment: room.payment,
          begindate: begindate,
          enddate: enddate,
          memo: ''
        },
        products: defaultproducts,
        customers:[]
      };
      //是否有预约数据?
      if(room.prerent && room.prerent.preinfo){
        $scope.rentData.contract.price = room.prerent.preinfo.price;
        $scope.rentData.contract.pledge = room.prerent.preinfo.price;
      }
      //$scope.title = room.code + ' - 出租';
      $scope.room = room;
      $scope.building = building;
    });
  }

  /***从服务器获取数据***/
  /***加载数据***/
  //取房间信息
  $Room.getRoom($scope.roomId).then(function(room){
    setRentData(room);
  });
  //默认标题
  $scope.title = '出租';

  $scope.financeData = {
    begindate: new Date(),
    enddate: $Date.getRentEndDay(new Date(),0),
    items: [],
    hasFinance : true,
    type: 0,
    money: 0,
    pledge: 0,
    financeType: DATALIST.FINANCE_PAYTYPE.list
  };

  //计算首次收租费用
  function calcMoney(rentData,begindate,enddate){
    //付款方式:银联\微信\支付宝\现金
    var fd = $scope.financeData;
    fd.begindate = begindate;
    fd.enddate = enddate;
    fd.money = 0;
    fd.pledge = rentData.contract.pledge;
    //增加租金押金项目
    fd.items = [];
    fd.items.push({
      name:'租金',
      itemtype: DATALIST.INVOICE_ITEM_TYPE.PLEDGE,
      price: rentData.contract.pledge,
      money: rentData.contract.pledge,
    });
    //增加其他押金项目
    _.forEach(rentData.products, function(product){
      if(product.pledge && product.pledge > 0){
        fd.items.push({
          name: product.name,
          itemtype: DATALIST.INVOICE_ITEM_TYPE.PLEDGE,
          price: product.pledge,
          money: product.pledge,
        });
        this.pledge += product.pledge;
      }
    },fd);
    //增加租金条目
    var rentmoney = $Rent.calcProductMoney(DATALIST.PRODUCT_FEETYPE.MONTHLY, rentData.contract.price, begindate, enddate, 0);
    fd.items.push({
      name:'租金',
      itemtype: DATALIST.INVOICE_ITEM_TYPE.NORMAL,
      feetype: DATALIST.PRODUCT_FEETYPE.MONTHLY,
      price: rentData.contract.price,
      money: rentmoney,
    });
    fd.money = rentmoney;
    //计算其他产品的金额和押金
    _.forEach(rentData.products, function(product){
      var value = 0,prmoney = 0;
      //非按量计费项目
      if(!$scope.isAmountProduct(product)){
        if($scope.isAreaProduct(product)){ //按面积计费
          value = $scope.room.area;
        }else if($scope.isPersonProduct(product)){ //按人数计费
          value = $scope.rentData.customers.length;
        }
        prmoney = $Rent.calcProductMoney(product.feetype, product.price, begindate, enddate, value);
        fd.items.push({
          name: product.name,
          itemtype: DATALIST.INVOICE_ITEM_TYPE.NORMAL,
          feetype: product.feetype,
          price: product.price,
          money: prmoney,
        });
        this.money += prmoney;
      }
    },fd);

    //返回
    return fd;
  }

  //改变租金时，调整押金与租金一致（默认押一个月）
  $scope.priceChange = function() {
    $scope.rentData.contract.pledge = $scope.rentData.contract.price;
  };

  // 提示是否收费?
  $scope.showFinancePopup = function() {
    //计算第一次收费的时间跨度按
    var begindate = $scope.rentData.contract.begindate;
    var rentdate = $scope.building && $scope.building.settings && $scope.building.settings.rentdate !== 0 ? $scope.building.settings.rentdate : 0;
    var enddate = $Date.getRentEndDay(begindate,rentdate);
    //计算金额并更新弹出层环境变量
    calcMoney($scope.rentData,begindate,enddate);
    $scope.changeFeeDate = function(){
      calcMoney($scope.rentData,$scope.financeData.begindate,$scope.financeData.enddate);
    };

    //创建弹出窗
    var productPopu = $ionicPopup.show({
      templateUrl: 'templates/popup/fee.contract.room.popup.html',
      title: '确认收费',
     //subTitle: '输入生效日期',
     scope: $scope,
     buttons: [
       { text: '取消' },
       {
         text: '<b>确定</b>',
         type: 'button-positive',
         onTap: function(e) {
          $scope.financeData.paytype = $scope.financeData.financeType[$scope.financeData.type];
           return $scope.financeData;
         }
       },
     ]
    });

    productPopu.then(function(financeData) {
      console.log('Tapped!', financeData);
      productPopu.close();
      if(financeData){
        $scope.rentData.finance = financeData;
        $scope.doContract();
      }
   });
  };
  //出租,签合同
  $scope.doContract = function(){
    //转换参数,使之符合API要求
    var postdata = _.clone($scope.rentData, true);
    //处理租客参数[Object]->[-id]
    postdata.customers = _.pluck(postdata.customers, '_id');
    //发起API请求
    $Rent.contract($scope.room._id,postdata).then(function(response){
      console.log(response);
      var rentinfo = response.rent;
      //更新房间出租信息,并保存到缓存
      $scope.room.prerent = undefined;
      $scope.room.rent = rentinfo;
      $scope.room.roomstatus = DATALIST.ROOM_STATUS.RENT;
      $scope.room.statusmsg = DATALIST.ROOM_STATUS.enum[DATALIST.ROOM_STATUS.RENT];
      $Room.fixRoom($scope.room);
      $Room.updateRoom2Cache($scope.room);
      //获取租金单信息
      $Invoice.getRoomLastInvoice($scope.room.building,$scope.room._id,true);
      //刷新抄表数据
      //$RoomValue.getRoomValue()
      //打印单据？
      $Window.showConfirm('恭喜','出租成功,是否打印单据?','打印', '暂不打印').then(function(res){
        if(res){
          $Print.addInvoiceData(response.invoice);
          $state.go('app.printer');
        }else{
          $ionicHistory.goBack();
        }
      },function(){
        $ionicHistory.goBack();
      });
    })
    .catch(function(err){
      $Window.showAlert('出错',err.message || err || '出租失败,请联系管理员!');
    });
  };

  /**********增加收费项目**********/
  // 获取收费项目列表,并显示模态窗口
  $scope.selectProduct = function () {
    var orderProducts = $scope.rentData.products;
    $scope.ProductWindow.select({
      orderProducts: orderProducts,
      onAddProduct: $scope.doAddProduct,
      onCancelProduct: $scope.doCancelProduct
    });
  };

  // 订购产品
  $scope.doAddProduct = function (product, success, error) {
    console.log('Doing addProduct', product);
    var newproduct = {
      _id: product._id,
      name: product.name,
      unit: product.unit,
      feetype: product.feetype,
      price: product.price, //产品价格
      value: 0,
      pledge: product.pledge, //押金
    };
    //去最后抄表记录作为底数
    fixProductValue($scope.building._id,newproduct,$scope.room._id);
    //增加到签约项目
    $scope.rentData.products.push(newproduct);
    if(success && _.isFunction( success )){
      success(newproduct);
    }
  };

  // 取消订购产品
  $scope.doCancelProduct = function (product, success, error) {
    console.log('Doing cancelProduct', product);
    //从签约项目中删除
    _.remove($scope.rentData.products, function(item) { return item._id === product._id; });
    if(success && _.isFunction( success )){
      success();
    }
  };

  //是否显示底表输入框(只有按量计费和按量阶梯计费的才出现)
  $scope.showValue = function(product){
    return product.feetype === DATALIST.PRODUCT_FEETYPE.AMOUNT || product.feetype === DATALIST.PRODUCT_FEETYPE.STEP;
  };

  //删除
  $scope.deleteCustomer = function(customer){
    $Customer.deleteCustomer(customer, $scope.room).then(function(){
      _.remove($scope.rentData.customers, function(item) { return item._id === customer._id; });
    });
  };

  //打开窗口
  $scope.addCustomer = function() {
    $scope.CustomerWindow.new($scope.room,{
      onBeforNew: null,
      onAfterNew: $scope.doNewCustomer
    });
  };

  //增加租客
  $scope.doNewCustomer = function(customer) {
    $scope.rentData.customers.push(customer);
  };

  //打开窗口
  $scope.editCustomer = function(customer) {
    $scope.CustomerWindow.edit($scope.room,customer,{
      onBeforEdit: null,
      onAfterEdit: $scope.doEditCustomer
    });
  };

  //编辑租客
  $scope.doEditCustomer = function(customer) {
    //$scope.rentData.customers.push(customer);
  };


  /***监听事件***/
  //退出时清理模态对象
  $scope.$on('$destroy', function() {
    // $scope.productnewmodal.remove();
    //$scope.customernewmodal.remove();
  });
});
