angular.module('bagu.controllers')
  //房间
  .controller('ContractDetailCtrl', function($scope, $state, $stateParams, $ionicModal,
    $http, $ionicPopover, $ionicPopup, $ionicLoading, $ionicHistory, $filter, $ionicListDelegate,
    $Cache, _, $Date,
    $Print, $Rent, $Building, $Room, $RoomValue, $Customer, $Product, $Window, $PriceLog, $Sms, $Invoice,
    DATALIST, LOCAL) {
    /***保存参数***/
    //$scope.roomId = $stateParams.roomId;
    // Form data for the add customer modal
    $scope._customerNew = {};
    //设置默认标题
    // $scope.title = '合同';
    /**********自定义方法**********/
    //设置房间
    function setRoom(room) {
      var _room = room;
      //如果为出租状态,则加载并分析产品记录
      if (_room.roomstatus > DATALIST.ROOM_STATUS.ORDER && _room.rent &&
        _room.rent.contract) {
        $Product.fixOrderProducts(_room.rent.contract.products);
      }
      //赋值,返回
      $scope.room = _room;
      $scope.title = _room.code + '合同信息';
      //获取楼房信息
      $Building.getBuilding($scope.room.building, false).then(function(building) {
        $scope.building = building;
      });
    }

    /**********操作定义**********/

    //增加价格单位的价格信息
    $scope.getProductPrice = function(product) {
      try{
        var result = product.price.toString();
        switch (product.feetype) {
          case DATALIST.PRODUCT_FEETYPE.ONCE: //一次性收费
            result += '元';
            break;
          case DATALIST.PRODUCT_FEETYPE.MONTHLY: //按月固定
            result += '元/月';
            break;
          case DATALIST.PRODUCT_FEETYPE.AMOUNT: //按量
          case DATALIST.PRODUCT_FEETYPE.STEP: //按量阶梯
            result += '元/' + product.unit;
            break;
          case DATALIST.PRODUCT_FEETYPE.AREA: //按面积
            result += '元/平米/月';
            break;
          case DATALIST.PRODUCT_FEETYPE.PERSON: //人数
            result += '元/人/月';
            break;
          default: //错误的feetype
            break;
        }
        return result;
      }catch(err){
        return '0元';
      }
    };

    //获取按量收费的表底信息
    $scope.getProductInitValue = function(product) {
      var result = '';
      switch (product.feetype) {
        case DATALIST.PRODUCT_FEETYPE.AMOUNT: //按量
        case DATALIST.PRODUCT_FEETYPE.STEP: //按量阶梯
          result += product.value.toString() + product.unit;
          break;
        default: //错误的feetype
          break;
      }
      return result;
    };

    //获得总押金，房租押金，产品费用押金
    $scope.getPledgeStr = function(contract) {
      var result = '',
        money = 0,
        pledgestr = '';
      if (contract) {
        money = contract.pledge || 0;
        if (contract.products && contract.products.length > 0) {
          _.forEach(contract.products, function(product) {
            if (product.pledge && product.pledge > 0) {
              money += product.pledge;
            }
          });
        }
        result = money.toString() + '元';
      }
      return result;
    };

    //增加产品时,计算应收费金额
    $scope.calcOrderMoney = function(productData) {
      if(!productData || !productData.product){
        //错误的参数
        return;
      }
      var product = productData.product;
      switch (product.feetype) {
        case DATALIST.PRODUCT_FEETYPE.ONCE:
          productData.money = productData.price;
          break;
        case DATALIST.PRODUCT_FEETYPE.MONTHLY: //按月固定
          productData.money = productData.price + productData.pledge;
          break;
        case DATALIST.PRODUCT_FEETYPE.AMOUNT: //按量
        case DATALIST.PRODUCT_FEETYPE.STEP: //按量阶梯
          productData.money = productData.pledge;
          break;
        default:
          productData.money = productData.pledge;
      }
    };

    $scope.onChangePrice = function(){
      $scope.redPrice = $scope.room.pricelogs && $scope.room.pricelogs.length > 0 && $scope.orgroom.rent.contract && $scope.room.rent.contract.price !== $scope.orgroom.rent.contract.price;
    };

    /**********增加收费项目**********/

    // 获取收费项目列表,并显示模态窗口
    $scope.addProduct = function() {
      var orderProducts = [];
      if ($scope.room && $scope.room.rent) {
        orderProducts = $scope.room.rent.contract.products;
      }
      $scope.ProductWindow.select({
        orderProducts: orderProducts,
        onAddProduct: $scope.showAddProductPopup,
        onCancelProduct: $scope.showCancelProductPopup
      });
    };

    // 订购产品
    $scope.doAddProduct = function(productdata, success, error) {
      console.log('Doing addProduct', productdata);
      $Product.addRoomProduct($scope.room, productdata).then(function(newProduct) {
        if ($scope.room && $scope.room.rent && $scope.room.rent.contract) {
          //由于此处采用cloneDeep复制了对象,故需要刷新
          $scope.room.rent.contract.products.push(newProduct);
          $Room.addProduct4Cache($scope.room._id, newProduct);
        }
        $scope.showAddProductAlert(newProduct, productdata);
        if (success) success(newProduct);
      }, function(err) {
        $scope.errormessage = err.message;
        if (error) error(err);
      });
    };

    // 取消订购产品
    $scope.doCancelProduct = function(productdata, success, error) {
      console.log('Doing cancelProduct', productdata);
      $Product.cancelRoomProduct($scope.room, productdata).then(function() {
        //修改订购记录,由于此处采用cloneDeep复制了对象,故需要刷新
        _.remove($scope.room.rent.contract.products, function (rc) {
          return rc.productrecord === productdata.record;
        });
        $Room.deleteProduct4Cache($scope.room._id, productdata);
        $scope.showCancelProductAlert();
        if (success && _.isFunction(success)) {
          success();
        }
      }, function(err) {
        $Window.showAlert('抱歉', err.message || err);
        if (error && _.isFunction(error)) {
          error();
        }
      });
    };

    // 显示添加产品对话框
    $scope.showAddProductPopup = function(product, success, error) {
      $scope.productdata = {
        product: product._id,
        begintime: new Date(),
        paytype: DATALIST.FINANCE_PAYTYPE.CASH,
        pricestr: '',
        hastimelimit: false,
        haslastvalue: false,
        haspledge: false,
        haspaytype: false,
        paytypes: DATALIST.FINANCE_PAYTYPE.list
      };
      $scope.productdata.endtime = $Product.calcProductEndTime($scope.productdata
        .begintime, product.timelimit);
      $scope.productdata.price = product.price;
      $scope.productdata.lastvalue = 0;
      $scope.productdata.pledge = product.pledge;

      switch (product.feetype) {
        case DATALIST.PRODUCT_FEETYPE.ONCE:
          $scope.productdata.pricestr = '金额';
          $scope.productdata.hastimelimit = true;
          $scope.productdata.haspaytype = true;
          $scope.productdata.money = product.price;
          break;
        case DATALIST.PRODUCT_FEETYPE.MONTHLY:
          $scope.productdata.pricestr = '金额(元/月)';
          $scope.productdata.haspledge = true;
          $scope.productdata.money = product.pledge;
          break;
        case DATALIST.PRODUCT_FEETYPE.AMOUNT:
        case DATALIST.PRODUCT_FEETYPE.STEP:
          $scope.productdata.pricestr = '价格(元/' + product.unit + ')';
          $scope.productdata.haslastvalue = true;
          $scope.productdata.haspledge = true;
          $scope.productdata.money = product.pledge;
          break;
        case DATALIST.PRODUCT_FEETYPE.AREA:
          $scope.productdata.pricestr = '价格(元/平方)';
          $scope.productdata.haspledge = true;
          $scope.productdata.money = product.pledge;
          break;
        case DATALIST.PRODUCT_FEETYPE.PERSON:
          $scope.productdata.pricestr = '价格(元/人)';
          $scope.productdata.haspledge = true;
          $scope.productdata.money = product.pledge;
          break;
      }
      var productPopu = $ionicPopup.show({
        //template: template,
        templateUrl: 'templates/popup/order.product.popup.html',
        title: '增加' + (product.name ? product.name : '收费项目'),
        scope: $scope,
        buttons: [{
          text: '取消'
        }, {
          text: '<b>确定</b>',
          type: 'button-positive',
          onTap: function(e) {
            return $scope.productdata;
          }
        }, ]
      });

      productPopu.then(function(productdata) {
        console.log('Tapped!', productdata);
        productPopu.close();
        if (productdata) {
          $scope.doAddProduct(productdata, function(res) {
            if (success && _.isFunction(success)) {
              success(res);
            }
          }, function(res) {
            if (error && _.isFunction(error)) {
              error();
            }
            product.isordered = false;
          });
        } else {
          product.isordered = false;
        }
      });
    };

    // 显示取消产品对话框
    $scope.showCancelProductPopup = function(product, success, error) {
      $scope.productdata = {
        product: product._id,
        record: product.record,
        begintime: product.begintime,
        endtime: product.endtime,
        price: product.showPrice,
        pledge: product.showPledge,
        willbackmoney: 0,
        backmoney: 0,
        isonceproduct: false
      };
      //一次性收费项目,并且尚未过期
      if (product.feetype === DATALIST.PRODUCT_FEETYPE.ONCE && product.endtime >= new Date()) {
        var mdaydiff1 = $Date.dayDiff(product.begintime, product.endtime);
        var mdaydiff2 = $Date.dayDiff(new Date(), product.endtime);
        $scope.productdata.isonceproduct = true;
        $scope.productdata.lavedays = mdaydiff1.toString() + '天';
        $scope.productdata.willbackmoney = (Math.round(mdaydiff1 / mdaydiff2) * product.showPrice);
      }
      //有押金的项目
      if (product.feetype !== DATALIST.PRODUCT_FEETYPE.ONCE && product.showPledge > 0) {
        $scope.productdata.ispledgeproduct = true;
        $scope.productdata.willbackmoney += product.showPledge;
      }
      $scope.productdata.backmoney = $scope.productdata.willbackmoney;
      //如果无需退费则提示确认
      if ($scope.productdata.backmoney === 0) {
        $Window.showConfirm('确认取消?', '取消收费项目前,请确认所有费用均已结算完成!').then(function(ok) {
          if (ok) {
            $scope.doCancelProduct($scope.productdata, function(res) {
              if (success && _.isFunction(success)) {
                success(res);
              }
            }, function(res) {
              if (error && _.isFunction(error)) {
                error();
              }
              product.isordered = true;
            });
          } else {
            product.isordered = true;
          }
        });
      } else { //需要退费
        //弹出对话框
        var productPopu = $ionicPopup.show({
          //template: template,
          templateUrl: 'templates/popup/cancel.product.popup.html',
          title: '取消' + (product.name ? product.name : '收费项目'),
          scope: $scope,
          buttons: [{
            text: '取消'
          }, {
            text: '<b>确定</b>',
            type: 'button-positive',
            onTap: function(e) {
              return $scope.productdata;
            }
          }, ]
        });

        productPopu.then(function(productdata) {
          console.log('Tapped!', productdata);
          productPopu.close();
          if (productdata) {
            $scope.doCancelProduct(productdata, function(res) {
              if (success && _.isFunction(success)) {
                success(res);
              }
            }, function(res) {
              if (error && _.isFunction(error)) {
                error();
              }
              product.isordered = true;
            });
          } else {
            product.isordered = true;
          }
        });
      }
    };

    // 提示
    $scope.showAddProductAlert = function(product, productdata) {
      var productname = product.name ? product.name : '收费项目';
      var message = '增加' + productname + '成功';
      $Window.showAlert('恭喜', message);
    };

    // 提示
    $scope.showCancelProductAlert = function() {
      $Window.showAlert('恭喜', '取消收费项目成功');
    };


    /**********获取房间数据**********/

    //获取房间
    $scope.getRoom = function(roomId, isRefresh) {
      isRefresh = isRefresh || false;
      $Room.getRoom(roomId, isRefresh).then(function(orgroom) {
        $scope.orgroom = orgroom;
        var room = _.cloneDeep(orgroom);
          //console.log('room', room);
          //数据无更新?
          // if($scope.room === room && $scope.room.$ver === room.$ver){
          //   return ;
          // }
          //如果已经出租,且不包含租客详细信息,则在此处完善
          if (room && room.rent && room.rent.contract && _.isArray(room.rent.contract.customers) && room.rent.contract.customers.length > 0) {
            $Customer.getRoomCustomers(room).then(function(customers) {
              //console.log('get room customers', room);
              _.remove( customers, function(item){
                return !item || !item._id;
              });
            });
          }
          //获取调租记录
          $PriceLog.getRoomPriceLog(roomId, isRefresh).then(function(
            pricelogs) {
            // var logs = _.filter(pricelogs, function (pricelog) {
            //   return new Date(pricelog.begindate) >= new Date();
            // });
            room.pricelogs = pricelogs;
          }, function(err) {
            room.pricelogs = [];
          });
          //设置房间(新房间对象)
          setRoom(room);
        })
        .catch(function(err) {
          console.log('load room error:', err);
        })
        .finally(function() {
          // Stop the ion-refresher from spinning
          if (isRefresh) {
            $scope.$broadcast('scroll.refreshComplete');
          }
        });

    };

    //下拉更新
    $scope.doRefreshRoom = function() {
      $scope.getRoom($stateParams.roomId, true);
    };

    //加载房间数据
    // console.log('Show room', $scope.isAuthenticated(), $stateParams.roomId,
    //   $stateParams.roomCode);
    $scope.getRoom($stateParams.roomId);

    /**********保存修改**********/
    //公用方法
    $scope.doRoomSave = function(room, callback) {
      //console.log('Doing save room', room);
      $Room.editRoom($scope.room._id, room).then(function(room) {
        $scope.showSaveAlert();
        callback();
      }, function(err) {
        $scope.errormessage = (err && err.message) ? err.message :
          '未知错误';
      });
    };

    // An alert dialog
    $scope.showSaveAlert = function() {
      var showProductAlert = $ionicPopup.alert({
        title: '恭喜',
        template: '保存成功!',
        scope: $scope,
      });
      showProductAlert.then(function(res) {
        console.log('保存完成');
      });
    };

    // 保存合同信息
    $scope.doSaveContract = function() {
      function doSave(){
        var contract = $scope.room.rent.contract;
        var cdata = {
          begindate: contract.begindate,
          enddate: contract.enddate,
          price: contract.price,
          pledge: contract.pledge,
          memo: contract.memo,
          products: contract.products
        };
        $Rent.editContract($scope.room._id, cdata).then(function(contract) {
          //修改本地缓存
          $Room.getRoom($scope.room._id).then(function(room) {
            if(room && room.rent && room.rent.contract){
              room.rent.contract = contract;
              $Room.updateRoom2Cache(room);
            }
          });
          $Window.showAlert('恭喜', '保存成功!');
          $ionicHistory.goBack();
        },function(err){
          $Window.showAlert('抱歉', '保存失败,请稍后再试!');
        });
      }
      //数据异常?
      if (!$scope.room || !$scope.room.rent || !$scope.room.rent.contract) {
        return;
      }
      //是否有修改租金,并且存在调租记录?
      if($scope.room.pricelogs && $scope.room.pricelogs.length > 0 && $scope.orgroom.rent.contract && $scope.room.rent.contract.price !== $scope.orgroom.rent.contract.price){
        $Window.showConfirm('温馨提示','此处只针对合同内容进行修改,调整租金请使用调租功能!是否继续?').then(function(isOk){
          if(isOk){
            doSave();
          }
        });
      }else{
        doSave();
      }
    };

    /**********事件**********/
    var firstrun = true;
    $scope.$on('$ionicView.enter', function(e) {
      //$Window.showAlert('enter','building');
      if(firstrun){
        firstrun = false;
      }else{
        //缓存中读取楼房列表
        $scope.getRoom($stateParams.roomId);
      }
    });

  });
