angular.module('bagu.controllers')
	//房间
	.controller('BuildingInitCtrl', function ($scope, $state, $stateParams, $ionicHistory, $q, _,
		$cordovaInAppBrowser, $Rfs, $Window,
		DATALIST, LOCAL, $Room, $Analysis, $PriceLog, $Building) {
		/***保存参数***/
		$scope.buildingId = $stateParams.buildingId;
		$scope.roomId = $stateParams.roomId;
		/***常量***/
		var MODULE_NAME = 'init';
		var WEBSITE_URL = 'http://rent.bagu.mobi/';

		$scope.upfile = null;
		$scope.uploadUrl = '';
		$scope.initResult = null;
		$scope.showInfo = false;

		//下载Excel模板
		$scope.doDownload = function () {
			var url = WEBSITE_URL + 'init.xlsx';
			$scope.openUrl(url);
		};
		//上传并初始化
		$scope.doUpload = function () {
			if (!$scope.upfile || !$scope.upfile.name) {
				$Window.showAlert('抱歉', '请先选择需要上传的Excel文件!');
				return;
			}
			// $scope.showInfo = true;
			// return ;
			console.log($scope.upfile);
			$scope.initResult = null;
			$Window.showLoading({
				template: '读取文件...'
			});
			//上传
			var scope = {
				building: $scope.building
			};
			$Rfs.uploadFile(MODULE_NAME, $scope.upfile.name, $scope.upfile, scope)
				.then(function (data) {
					$scope.initResult = data;
					$Window.showLoading({
						template: '正在刷新数据...'
					});
					return $scope.getBuildingRooms();
				}, function (err) {
					console.log(err);
					$Window.showAlert('抱歉', '上传失败!');
					return $q.reject(err);
				}, function (progress) {
					if (progress.loaded !== progress.total) {
						$Window.showLoading({
							template: '正在上传' + progress.loaded + '/' + progress.total
						});
					} else {
						$Window.showLoading({
							template: '正在初始化...'
						});
					}
					console.log(progress.loaded, progress.total);
				})
				.then(function () {
					if (_.isArray($scope.initResult) && $scope.initResult.length === 0) {
						$Window.showAlert('恭喜', '初始化完成!').then(function () {
							$ionicHistory.goBack();
						});
					} else if (_.isArray($scope.initResult) && $scope.initResult.length > 0) {
						$Window.showAlert('喔噢', '初始化完成,但出现警告信息!').then(function () {
							$scope.showInfo = true;
						});
					}
				}, function (err) {
					console.log(err);
					$Window.showAlert('抱歉', '上传失败!');
				})
				.finally(function () {
					$Window.hideLoading();
				});
		};
		//刷新初始化后的数据
		$scope.getBuildingRooms = function () {
			var buildingId = $scope.buildingId;
			return $Room.getBuildingRooms(buildingId, true).then(function (roomlist) {
				$Analysis.getBuildingCurrentAnalysis(buildingId, true).then(function (analysis) {
					$scope.analysis = analysis;
				});
				$PriceLog.getBuildingPriceLogs(buildingId, true).then(function (pricelogs) {
					//console.log('Fetch pricelogs',pricelogs);
				});
				return roomlist;
			});
		};
		//关闭信息窗口
		$scope.closeInfo = function () {
			$scope.showInfo = false;
		};

		//返回到缓存页面
		$scope.$on('$ionicView.afterEnter', function (e) {
			//绑定上传事件
			var xlf = document.getElementById('xlf');

			function handleFile(e) {
				var files = e.target.files;
				$scope.upfile = files[0];
				// var reader = new FileReader();
				// reader.readAsArrayBuffer(f);
			}
			if (xlf.addEventListener) xlf.addEventListener('change', handleFile, false);

			//获取楼房信息
			$Building.getBuilding($scope.buildingId).then(function (building) {
				$scope.building = building;

				var scope = {
					building: $scope.building
				};
				//获取并计算模块设置
				var msettings = null;
				try {
					msettings = $Rfs.getModuleSettings(MODULE_NAME, 0, scope);
					$scope.uploadUrl = msettings.encodeUpUri;
				} catch (e) {
					return console.log('模块未配置或配置错误,请联系管理员!');
				}
			});
		});

	});
