
angular.module('bagu.controllers')
//抄表
.controller('RoomInitCtrl', function($scope, $stateParams, $ionicPopup, $http, $ionicHistory , $ionicLoading, $state, $ionicModal, _,
  $Window, $Cache, $Date, $Invoice, $Rent, $Print, $Building, $Room, $RoomValue, $Product, $Customer, DATALIST, EVENTS) {
  /***保存参数***/
  $scope.roomId = $stateParams.roomId;
  $scope._customerNew = {credentialstype: '身份证'};
  $scope.rentdate = 0;

  /***工具函数***/

  //获取最后抄表记录数作为底表数 Cache -> buildingID -> productID -> roomID
  function fixProductValue(buildingId,product,roomId){
    product.value = 0;
    $RoomValue.getRoomValues(buildingId,product._id).then(function(roomvalues){
      var valueitem = _.find( roomvalues, function(item){
        return item._id === roomId;
      });
      if(valueitem){
        if(_.isNumber(valueitem.value) && valueitem.value > 0){
          product.value = valueitem.value;
        }else if(_.isNumber(valueitem.lastvalue) && valueitem.lastvalue > 0){
          product.value = valueitem.lastvalue;
        }else{
          product.value = 0;
        }
      }
    });
  }

  //根据开始日期自动计算合同结束日期(有设置统一收租日,则自动补齐到收租日前一天)
  function calcEndDate(begindate,rentdate){
    var enddate = $Date.addYears(new Date(begindate),1);
    if(rentdate > 0){
      enddate.setFullYear(enddate.getFullYear(),enddate.getMonth(),rentdate);
      var days = $Date.dayDiff(begindate,enddate);
      if(days<365){
        enddate.setFullYear(enddate.getFullYear(),enddate.getMonth()+1);
      }
    }
    //enddate.setFullYear(enddate.getFullYear(),enddate.getMonth(),rentdate-1);
    enddate = $Date.addDays(enddate,-1);
    return enddate;
  }

  //当前日期所在租金周期的最后一天(判断统一收租日)
  //如:2016-1-1对应2016-1-31;2016-1-28也对应2016-1-31
  function calcLastFeeDate(begindate,rentdate){
    var lastdate = new Date();
    //如果未设置统一收租日,则按照begindate的日期
    if(!rentdate || rentdate <= 0){
      rentdate = begindate.getDate();
    }
    lastdate.setFullYear(lastdate.getFullYear(),lastdate.getMonth(),rentdate);
    var days = $Date.dayDiff(new Date(),lastdate);
    if(days<=0){
      lastdate = $Date.addMonths(lastdate,1);
    }
    lastdate = $Date.addDays(lastdate,-1);
    return lastdate;
  }

  //设置出租数据
  function setRentData(room){
    var begindate = new Date(),
        enddate = new Date(),
        initfeedate = new Date();
    //判断room是否为空
    if(!room){
      return;
    }
    //从缓存中取抄表楼房默认收费项目信息
    $Building.getBuilding(room.building).then(function(building){
      //判断building是否为空
      building = building || {};
      //设置了统一收租日期? 自动计算合适的第一期收租截止日(大于15天)
      $scope.rentdate = building && building.settings && building.settings.rentdate ? building.settings.rentdate : 0;
      //计算合同结束
      enddate = calcEndDate(begindate,$scope.rentdate);
      //计算最后收费截止日期
      initfeedate = calcLastFeeDate(begindate,$scope.rentdate);
      //
      // enddate.setFullYear(begindate.getFullYear() + 1);
      // if(rentdate !== 0){
      //   enddate.setFullYear(enddate.getFullYear(),enddate.getMonth(),building.settings.rentdate);
      //   var days = parseInt((enddate-begindate)/(24*3600*1000));
      //   if(days<365){
      //     enddate.setFullYear(enddate.getFullYear(),enddate.getMonth()+1);
      //   }
      //   enddate.setFullYear(enddate.getFullYear(),enddate.getMonth(),building.settings.rentdate-1);
      // }
      // //设置默认最后收费截止日期
      // initfeedate = $Date.getRentEndDay(initfeedate,rentdate);
      //修正默认收费项目数据
      var defaultproducts = [];
      if(building.defaultproducts && building.defaultproducts.length > 0){
        //复制数组
        defaultproducts = building.defaultproducts.concat();
        _.forEach(defaultproducts, function(product){
          product._id = product.product;
        });
        $Product.fixOrderProducts(defaultproducts);
      }
      //如果是按量计费项目,则获取最后抄表记录作为底数
      _.forEach(defaultproducts, function(defproduct){
        fixProductValue(building._id,defproduct,room._id);
      });

      //签约数据
      $scope.rentData = {
        roomstatus: DATALIST.ROOM_STATUS.RENT,
        contract: { //合同信息
          price: room.price,
          pledge: room.pledge,
          payment: room.payment,
          begindate: begindate,
          enddate: enddate,
          customername: '', //主要租客姓名,冗余customer对象中的realname
      		customertel: '', //租客主要联系电话
          initfeedate: initfeedate, //收费截止日期
          memo: ''
        },
        products: building.defaultproducts,
        customers:[]
      };
      //$scope.title = room.code + ' - 出租';
      $scope.room = room;
      $scope.building = building;
    });
  }

  /***从服务器获取数据***/
  /***加载数据***/
  //取房间信息
  $Room.getRoom($scope.roomId).then(function(room){
    setRentData(room);
  });
  //默认标题
  $scope.title = '初始化合同';

  //改变租金时，调整押金与租金一致（默认押一个月）
  $scope.priceChange = function() {
    $scope.rentData.contract.pledge = $scope.rentData.contract.price;
  };

  //出租,签合同
  $scope.initRent = function(){
    //发起API请求
    $Room.initRoom($scope.room.building,$scope.room._id,$scope.rentData).then(function(response){
      console.log(response);
      //获取租金单信息
      $Invoice.getRoomLastInvoice($scope.room.building,$scope.room._id,true);
      var buildingId = $scope.room.building;
      var roomId = $scope.room._id;
      if (buildingId && roomId) {
        $RoomValue.updateRoomValue(buildingId, roomId).then(function(roomvalues) {});
      }
      $ionicHistory.goBack();
    })
    .catch(function(err){
      $Window.showAlert('出错',err.message || err || '初始化失败,请联系管理员!');
    });
  };

  /**********增加收费项目**********/
  // 获取收费项目列表,并显示模态窗口
  $scope.selectProduct = function () {
    var orderProducts = $scope.rentData.products;
    $scope.ProductWindow.select({
      orderProducts: orderProducts,
      onAddProduct: $scope.doAddProduct,
      onCancelProduct: $scope.doCancelProduct
    });
  };

  // 订购产品
  $scope.doAddProduct = function (product, success, error) {
    console.log('Doing addProduct', product);
    var newproduct = {
      _id: product._id,
      name: product.name,
      unit: product.unit,
      feetype: product.feetype,
      price: product.price, //产品价格
      value: 0,
      pledge: product.pledge, //押金
    };
    //去最后抄表记录作为底数
    fixProductValue($scope.building._id,newproduct,$scope.room._id);
    //增加到签约项目
    $scope.rentData.products.push(newproduct);
    if(success && _.isFunction( success )){
      success(newproduct);
    }
  };

  // 取消订购产品
  $scope.doCancelProduct = function (product, success, error) {
    console.log('Doing cancelProduct', product);
    //从签约项目中删除
    _.remove($scope.rentData.products, function(item) { return item._id === product._id; });
    if(success && _.isFunction( success )){
      success();
    }
  };

  $scope.changeBeginDate = function(){
    $scope.rentData.contract.enddate = calcEndDate($scope.rentData.contract.begindate,$scope.rentdate);
    $scope.rentData.contract.initfeedate = calcLastFeeDate($scope.rentData.contract.begindate,$scope.rentdate);
  };

  // //是否显示底表输入框(只有按量计费和按量阶梯计费的才出现)
  // $scope.showValue = function(product){
  //   return product.feetype === DATALIST.PRODUCT_FEETYPE.AMOUNT || product.feetype === DATALIST.PRODUCT_FEETYPE.STEP;
  // };

  /***监听事件***/
  //退出时清理模态对象
  $scope.$on('$destroy', function() {
    // $scope.productnewmodal.remove();
    //$scope.customernewmodal.remove();
  });
});
