angular.module('bagu.controllers')
  //房间费用历史
  .controller('InvoiceHistoryCtrl', function($scope, $stateParams, $ionicPopover, $ionicPopup, $ionicScrollDelegate,
    $http, $Cache, $state, _, DATALIST, $Window, $Print, $RoomValue, $Invoice, $Sms) {

    /***参数定义***/
    //url参数
    $scope.roomId = $stateParams.roomId;
    //设置标题为楼房名称
    $scope.title = '费用历史';

    /***工具函数***/

    //编辑出租单
    $scope.doRoomRent = function(invoice) {
      $state.go('app.rent', {
        roomId: invoice.room,
        invoiceId: invoice._id
      });
    };

    //发送单个催缴短信
    $scope.doSendSms = function(invoice) {
      $Sms.sendInvoiceSms($scope.buildingId, invoice._id).then(function() {
        $Window.showAlert('恭喜', invoice.code + '房催缴短信已发送!');
      }, function(err) {
        $Window.showAlert('失败', err.message || err);
      });
    };
    // //打印单个租金单
    // $scope.doPrintInvoice = function(invoice) {
    //   //写入租金单数据
    //   $Print.clearPrintData();
    //   $Print.addInvoiceData([invoice]);
    //   $state.go('app.printer');
    // };
    //设置单个租金单为已收费状态
    $scope.doSetFee = function(invoice) {
      $scope.feedata.money = invoice.money;
      var myPopup = $ionicPopup.show({
        template: ' \
        <div class="row"> <div class="col">应收金额:</div><div class="col col-50">{{::feedata.money}}元</div> </div>\
        <div class="row"> <div class="col">收费方式:</div> <div class="col"></div></div>\
        <div > \
          <div class="button-bar"> \
            <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 0}" ng-click="feedata.feetype = 0">{{feedata.financeType[0]}}</a> \
            <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 1}" ng-click="feedata.feetype = 1">{{feedata.financeType[1]}}</a> \
            <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 2}" ng-click="feedata.feetype = 2">{{feedata.financeType[2]}}</a> \
          </div> \
          <div class="button-bar"> \
            <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 3}" ng-click="feedata.feetype = 3">{{feedata.financeType[3]}}</a> \
            <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 4}" ng-click="feedata.feetype = 4">{{feedata.financeType[4]}}</a> \
          </div> \
        </div>',
        title: '确认收费',
        subTitle: '请仔细核对租金单费用,并选择收费方式',
        scope: $scope,
        buttons: [{
          text: '取消'
        }, {
          text: '<b>确认</b>',
          type: 'button-positive',
          onTap: function(e) {
            return true;
          }
        }]
      });
      myPopup.then(function(res) {
        console.log('Tapped!', res);
        myPopup.close();
        if (res) {
          //设置收费状态
          $Invoice.updateInvoiceHasFee(invoice, $scope.feedata).then(function(response) { //获取楼房未打印的租金单
            var buildingId = invoice.building && invoice.building._id ? invoice.building._id : invoice.building;
            var roomId = invoice.room && invoice.room._id ? invoice.room._id : invoice.room;
            if(buildingId && roomId){
              $RoomValue.updateRoomValue(buildingId, roomId).then(function (roomvalues) {
              });
            }
            //$scope.refreshData(false);
            $Window.showAlert('恭喜', '收费完成!');
            //刷新列表
            //$scope.refreshData();
            invoice.invoicestatus = DATALIST.INVOICE_STATUS.FINANCE;
          });
        }
      });
    };

    //作废单据
    $scope.doDeleteInvoice = function(invoice) {
      $Window.showConfirm('警告', '是否确认作废该单据?').then(function(isok) {
        if (isok) {
          $Invoice.deleteInvoice(invoice).then(function(invoice) {
            //刷新显示列表
            _.remove($scope.invoices, function(item) {
              return item._id === invoice._id;
            });
            //刷新按量计费项目的最后抄表记录(表底数)
            $RoomValue.updateRoomValue(invoice.building, invoice.room).then(function (roomvalues) {
            });
            $Window.showAlert('恭喜', '作废单据完成!');
          }, function(err) {
            $Window.showAlert('失败', err.message || err);
          });
        }
      });
    };

    $scope.onRemove = function(invoice){
      _.remove($scope.invoices, function(item){
        return invoice === item;
      });
    };

    //刷新数据
    $scope.refreshData = function() {
      //获取楼房租金单
      $Invoice.getRoomInvoices($scope.roomId)
        .then(function(invoices) {
          _.forEach(invoices, function(invoice) {
            // if (invoice.invoicestatus < DATALIST.INVOICE_STATUS.FINANCE) {
            //   invoice.statusstr = '未收费';
            // } else {
            //   invoice.statusstr = DATALIST.getEnumStr(DATALIST.INVOICE_STATUS
            //     .enum, invoice.invoicestatus);
            // }
            // invoice.typestr = DATALIST.getEnumStr(DATALIST.INVOICE_TYPE
            //   .enum, invoice.invoicetype);
            // //退房时,显示退费
            // if(invoice.invoicetype === DATALIST.INVOICE_TYPE.BACK){
            //   invoice.statusstr = invoice.statusstr.replace('收费','退费');
            // }
            // if (invoice.invoicestatus === DATALIST.INVOICE_STATUS.FINANCE && invoice.financelog) {
            //   invoice.paytype = DATALIST.getEnumStr(DATALIST.FINANCE_PAYTYPE.enum, invoice.financelog.paytype);
            // } else {
            //   invoice.paytype = '';
            // }
            // invoice.mobile = invoice.customers && invoice.customers.length > 0 ? invoice.customers[
            //   0].mobile : '';
            invoice.selected = true;
          });
          //保存所有租金单,在当前实例中实现分页
          // TODO: 此处要处理分页
          $scope.invoices = invoices;
        }).finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };
    //界面下拉刷新
    $scope.doRefresh = function() {
      $scope.refreshData();
    };

    /***初始化数据***/
    console.log('Fetch nofee invoice');
    //获取楼房未打印的租金单
    $scope.refreshData(false);

    //返回到缓存页面
    var firstrun = true;
    $scope.$on('$ionicView.enter', function(e) {
      //需要刷新列表?
      if(firstrun){
        firstrun = false;
        return ;
      }
      if(!firstrun){
        $scope.refreshData();
      }
    });

    //默认收费方式
    $scope.feedata = {
      feetype: DATALIST.FINANCE_PAYTYPE.CASH,
      financeType: {
        0: '现金',
        1: '微信',
        2: '刷卡',
        3: '支付宝',
        4: '银行转账'
      }
    };

  });
