angular.module('bagu.controllers')
  //租金单
  .controller('AnalysisMonthlyCtrl', function($scope, $stateParams, $ionicPopup, $http, $ionicHistory, $ionicLoading, $state, $ionicModal, _,
    $Window, $Cache, $Date, $Room, $RoomValue, $Rent, $Print, $Building, $Invoice, $Analysis, DATALIST) {
    /***保存参数***/
    $scope.buildingId = $stateParams.buildingId;
    $scope.year = $stateParams.year;
    $scope.month = $stateParams.month;
    //菜单定义
    var config = {};
    /***工具函数**/
    //显示统计图表
    $scope.showChart = function(){
      $scope.tabindex = 0;
    };
    //显示明细租金单列表
    $scope.showDetail = function(){
      $scope.tabindex = 1;
      if(!$scope.invoices){
        $Invoice.getBuildingMonthlyInvoices($scope.buildingId,$scope.year,$scope.month).then(function(invoices){
          $scope.invoices = invoices;
        });
      }
    };
    //显示统计图表
    $scope.doRefresh = function(fromServer){
      fromServer = fromServer || false;
      function showData(analysis){
        _.forEach(analysis.paytypes, function(item){
          item.name = DATALIST.FINANCE_PAYTYPE.list[item.paytype];
        });
        $scope.analysis = analysis;
        $scope.invoices = null;
        if($scope.tabindex === 1){
          $scope.showDetail();
        }
      }
      $scope.building = $Building.getCacheBuilding($scope.buildingId);
      if(!$scope.year || !$scope.month){
        $Analysis.getBuildingCurrentAnalysisMonthly($scope.building).then(function(monthly){
          $scope.year = monthly.year;
          $scope.month = monthly.month;
          $Analysis.getBuildingAnalysis($scope.building,$scope.year,$scope.month,fromServer).then(showData);
        }).finally(function(){
          if(fromServer){
            $scope.$broadcast('scroll.refreshComplete');
          }
        });
      }else{
        $Analysis.getBuildingAnalysis($scope.building,$scope.year,$scope.month,fromServer).then(showData).finally(function(){
          if(fromServer){
            $scope.$broadcast('scroll.refreshComplete');
          }
        });
      }
    };
    //显示上一月的统计数据
    $scope.showPrevMonth = function(){
      if($scope.month === 1){
        $scope.month = 12;
        $scope.year--;
      }else{
        $scope.month--;
      }
      $scope.doRefresh();
    };
    //显示下一月的统计数据
    $scope.showNextMonth = function(){
      if($scope.month === 12){
        $scope.month = 1;
        $scope.year++;
      }else{
        $scope.month++;
      }
      $scope.doRefresh();
    };

    //打印财务统计
    $scope.doPrint = function(){
      $scope.doPrintAnalysis($scope.analysis);
    };



    /***初始化***/
    //$scope.title = '财务统计';
    $scope.tabindex = 0;
    $scope.doRefresh();

    /***监听事件***/
    //进入视图事件
    $scope.$on('$ionicView.enter', function() {
    });
    //退出时清理模态对象
    $scope.$on('$destroy', function() {});
  });
