
angular.module('bagu.controllers')
//区域列表+楼房列表
.controller('NetAreasCtrl', function($scope, $stateParams, $ionicModal, $http, SERVER_SETTINGS, $ionicActionSheet, $state) {

  /***右侧功能菜单***/
  // Triggered on a button click, or some other target
  $scope.showMenu = function() {
    //如果是顶级区域,不能新增楼房
    if($stateParams.netareaId  === undefined){
      $scope.addNetArea();
      return;
    }
    //否则显示ActionSheet
    var _menubuttons = [{ text: '新增区域' },{ text: '新增楼房' }];
    // Show the action sheet
    var hideSheet = $ionicActionSheet.show({
      buttons: _menubuttons,
      titleText: '选择操作',
      cancelText: '取消',
      cancel: function() {
          // add cancel code..
      },
      buttonClicked: function(index) {
        hideSheet();
        if(index === 0){
          $scope.addNetArea();
        } else if(index === 1){
          $scope.addBuilding();
        }
      }
    });
  };

  /***新增区域***/
  // Form data for the add netarea modal
  $scope._netareaNew = {};

  // Create the add netarea modal that we will use later
  $ionicModal.fromTemplateUrl('templates/netareas.netarea.new.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.netareanewmodal = modal;
  });

  // Triggered in the modal to close it
  $scope.closeNetAreaAdd = function() {
    $scope.netareanewmodal.hide();
  };

  // Open the add netarea modal
  $scope.addNetArea = function() {
    $scope._netareaNew = {};
    if($stateParams.netareaId){
      $scope._netareaNew.parent = $stateParams.netareaId;
      //$scope._netareaNew.name = $stateParams.netareaName;
    }
    $scope.netareanewmodal.show();
  };

  // Perform the add netarea action when the user submits the add netarea form
  $scope.doNetAreaAdd = function() {
    console.log('Doing addNetArea', $scope._netareaNew);

    var url = '/netareas'+ ($stateParams.netareaId ? '/' +$stateParams.netareaId : '' );
    $http.post(url, $scope._netareaNew)
    .success(function (response) {
      $scope.netareas.push(response);
      $scope.closeNetAreaAdd();
    }).error(function (response){
      $scope.errormessage = response.message;
    });
  };

  /***新增楼房***/
  // Form data for the add building modal
  $scope._buildingNew = {};

  // Create the add building modal that we will use later
  $ionicModal.fromTemplateUrl('templates/netareas.building.new.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.buildingnewmodal = modal;
  });

  // Triggered in the modal to close it
  $scope.closeBuildingAdd = function() {
    $scope.buildingnewmodal.hide();
  };

  // Open the add building modal
  $scope.addBuilding = function() {
    $scope._buildingNew = {createrooms:false,floorrooms:[{floorid:1,rooms:5,auto:true}]};
    if($stateParams.netareaId){
      $scope._buildingNew.netarea = $stateParams.netareaId;
    }
    $scope.buildingnewmodal.show();
  };

  // Perform the add building action when the user submits the add building form
  $scope.doBuildingAdd = function() {
    console.log('Doing addBuilding', $scope._buildingNew);
    //修正floorrooms参数,方便传送到服务器
    var roomsarray = [],sendbody=angular.copy($scope._buildingNew);
    for(var i = 0; i<$scope._buildingNew.floorrooms.length; i++){
      roomsarray.push($scope._buildingNew.floorrooms[i].rooms);
    }
    //sendbody.floorrooms = roomsarray.join("-");
    sendbody.floorrooms = roomsarray;
    sendbody.settings = {rentdate:5,delays:15,before:2};
    sendbody.products = [{id:'55883a173004bf2b2e7fc76b',price:250}];
    sendbody.netarea = $stateParams.netareaId;

    $http.post('/init/building',sendbody)
    .success(function (response) {
      $scope.buildings.push(response);
      $scope.closeBuildingAdd();
    }).error(function (response){
      $scope.errormessage = response.message;
    });
  };

  $scope.changeFloorRooms = function () {
    var oldlen = $scope._buildingNew.floorrooms.length,
        newValue = $scope._buildingNew.floors;
    //自动创建房间时,动态设置楼层数组
    if($scope._buildingNew.createrooms){
      if(newValue > oldlen){
        for (var i = oldlen, len = newValue; i < len; i++) {
          $scope._buildingNew.floorrooms.push({floorid:i+1,rooms:0,auto:true});
        }
      }else if(newValue < oldlen){
        for (var i = newValue, len = oldlen; i < len; i++) {
          $scope._buildingNew.floorrooms.pop();
        }
      }
    }
    //判断是否需要自动设置房间数
    if($scope._buildingNew.rooms === undefined || $scope._buildingNew.rooms < $scope._buildingNew.floors){
      return;
    }
    if($scope._buildingNew.floorrooms.length != $scope._buildingNew.floors){
      return;
    }
    //动态设置(去除用户手动设置的楼层,自动根据房间数计算每层楼的房间数)
    //1,计算剩余楼层和房间数
    var autofloors=0,autorooms=$scope._buildingNew.rooms;
    console.log($scope._buildingNew.floorrooms);
    for (var i = 0, len = newValue; i < len; i++) {
      console.log(i,$scope._buildingNew.floorrooms[i]);
      if($scope._buildingNew.floorrooms[i].auto){
        autofloors++;
      }else {
        autorooms = autorooms - $scope._buildingNew.floorrooms[i].rooms;
      }
    }
    $scope._buildingNew.createroomserr = (autorooms < 0) || (autofloors > 0 && autorooms === 0); //如果小于0,则表示超过房间总数
    if(autorooms*autofloors == 0) return;
    //2,自动设置楼层房间数(优先双数房间)
    var roomsL=Math.floor(autorooms/autofloors), //少房间数
        roomsU= 0, //多房间数
        roomsP= 0; //多房间楼层的数量
    if(roomsL%2 !== 0){
      roomsL--;
    }
    roomsU = roomsL + 2;
    roomsP= Math.ceil((autorooms - roomsL*autofloors) / 2); //此处向上取整,如果不能被整除,在第三部做调整

    for (var i = newValue, j = 0; i > j; i--) {
      if($scope._buildingNew.floorrooms[i-1].auto === false) continue;
      if(roomsP > 0){
        $scope._buildingNew.floorrooms[i-1].rooms = roomsU;
        roomsP--;
      }else {
        $scope._buildingNew.floorrooms[i-1].rooms = roomsL;
      }
    }
    //3,最下一层调整差数(当余数不能被2整除时)
    if((autorooms - roomsL*autofloors) % 2 > 0){
      for (var i = 0, j = newValue; i < j; i++) {
        if($scope._buildingNew.floorrooms[i].auto === false) continue;
        $scope._buildingNew.floorrooms[i].rooms--;
        break;
      }
    }
  }

  $scope.changeFloorRoomInput = function (floorobj) {
    floorobj.auto = false;
    $scope.changeFloorRooms();
  }

  /***初始化列表***/
  console.log('Fetch netares', $scope.authentication, $stateParams.netareaId, $stateParams.netareaName);
  var _url = '/netareas';
  if($stateParams.netareaId){
    _url = _url + '/' + $stateParams.netareaId;
  }
  $http({
      method: 'GET',
      url: _url
  }).success(function (response) {
    $scope.netareas = response.netareas;
    $scope.buildings = response.buildings;
  }).error(function(data, status, headers, config) {
    if(status === 401){
       $state.go('login');
    };
  });
  //设置标题
  if($stateParams.netareaName)
  {
    $scope.title = $stateParams.netareaName;
  } else {
    $scope.title = '区域';
  }
});
