angular.module('bagu.controllers')
  //区域列表+楼房列表
  .controller('PrinterCtrl', function($scope, $ionicHistory, $q, $http, $ionicPopup, $ionicPlatform,
    $cordovaBluetoothSerial, $cordovaToast, $ionicLoading,
    $Print, $state, _, $Window, $Cache) {

    /***全局变量***/
    //打印机列表
    $scope.printers = [];
    //是否正在搜索蓝牙设备?
    $scope.searching = false;
    //是否正在搜索蓝牙设备?
    $scope.settings = {};
    //当前选择的打印机
    $scope.selectprinter = null;
    //菜单对象
    var actions = [{
			id: 1,
      type: 'toggle',
			text: '租客联',
			icon: '',
      checked: true,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印租金单时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.invoices > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.invoice.customer = checked;
        $Print.saveLocalSetting();
			}
		}, {
			id: 2,
      type: 'toggle',
			text: '房东联',
			icon: '',
      checked: false,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印租金单时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.invoices > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.invoice.owner = checked;
        $Print.saveLocalSetting();
			}
		},{
			id: 3,
      type: 'toggle',
			text: '状态统计',
			icon: '',
      checked: true,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印财务统计时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.analysises > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.analysis.opration = checked;
        $Print.saveLocalSetting();
			}
		}, {
			id: 4,
      type: 'toggle',
			text: '收费项目统计',
			icon: '',
      checked: false,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印财务统计时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.analysises > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.analysis.product = checked;
        $Print.saveLocalSetting();
			}
		},{
			id: 5,
      type: 'toggle',
			text: '收款方式统计',
			icon: '',
      checked: true,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印财务统计时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.analysises > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.analysis.paytype = checked;
        $Print.saveLocalSetting();
			}
		}, {
			id: 6,
      type: 'toggle',
			text: '租金单明细(简单)',
			icon: '',
      checked: false,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印财务统计时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.analysises > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.analysis.basedetail = checked;
  			$scope.settings.analysis.detail = !checked;
        var action = _.find(actions, function(item){
          return item.text === '租金单明细(详细)';
        });
        if(action){
          action.checked = $scope.settings.analysis.detail;
        }
        $Print.saveLocalSetting();
			}
		}, {
			id: 7,
      type: 'toggle',
			text: '租金单明细(详细)',
			icon: '',
      checked: false,
			visible: function (data) {
        var _printer = $Print.thisPrinter();
				//POS蓝牙打印机,打印财务统计时显示
				return _printer && _printer.isBluetoothPrinter && data && data.taskcount && data.taskcount.analysises > 0;
			},
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.analysis.detail = checked;
  			$scope.settings.analysis.basedetail = !checked;
        var action = _.find(actions, function(item){
          return item.text === '租金单明细(简单)';
        });
        if(action){
          action.checked = $scope.settings.analysis.basedetail;
        }
        $Print.saveLocalSetting();
			}
		}, {
			id: 8,
      type: 'toggle',
			text: '自动切纸',
			icon: '',
      checked: false,
			visible: true,
			href: undefined,
			click: undefined,
      change: function (checked) {
				$scope.settings.cut = checked;
        $Print.saveLocalSetting();
			}
		}];

    /***工具函数***/
    //显示Http返回错误
    function showHttpError(data, status, headers, config) {
      //只处理业务错误,权限错误由appctrl处理
      if (status === 400) {
        var msg = data.message || '加载数据出错,请稍后重试!';
        $Window.showAlert('抱歉', msg,
          function(res) {
            $ionicHistory.goBack();
          }
        );
      }
    }
    //返回
    var goBack = function() {
      return $ionicHistory.goBackByState('app.room', 'app.batchrent', 'app.batchprint', 'app.invoices');
    };
    //初始化菜单状态
    var initActions = function(){
      //获取缓存设置
      $scope.settings = $Print.getLocalSetting();
      var action;
      //判断租金单设置
      action = _.find(actions, function(item){
        return item.text === '租客联';
      });
      if(action){
        action.checked = $scope.settings.invoice.customer;
      }
      action = _.find(actions, function(item){
        return item.text === '房东联';
      });
      if(action){
        action.checked = $scope.settings.invoice.owner;
      }
      //判断月度租金统计表
      action = _.find(actions, function(item){
        return item.text === '状态统计';
      });
      if(action){
        action.checked = $scope.settings.analysis.opration;
      }
      action = _.find(actions, function(item){
        return item.text === '收费项目统计';
      });
      if(action){
        action.checked = $scope.settings.analysis.product;
      }
      //判断租金单设置
      action = _.find(actions, function(item){
        return item.text === '收款方式统计';
      });
      if(action){
        action.checked = $scope.settings.analysis.paytype;
      }
      action = _.find(actions, function(item){
        return item.text === '租金单明细(简单)';
      });
      if(action){
        action.checked = $scope.settings.analysis.basedetail;
      }
      action = _.find(actions, function(item){
        return item.text === '租金单明细(详细)';
      });
      if(action){
        action.checked = $scope.settings.analysis.detail;
      }
      //判断是否有切刀
      action = _.find(actions, function(item){
        return item.text === '自动切纸';
      });
      if(action){
        action.checked = $scope.settings.cut;
      }
    };

    /***整理楼房排列***/
    /* 默认规则
      每行三个
    */
    $scope.sortPrinters = function(printers, num) {
      num = num || 2;
      var i = 0,
        resultlist = [],
        tmplist = [];
      _.forEach(printers, function(printer) {
        i++;
        tmplist.push(printer);
        if (num <= i && i % num === 0) {
          resultlist.push(tmplist);
          tmplist = [];
        }
      });
      if (tmplist.length > 0) {
        while (tmplist.length !== num) {
          tmplist.push({
            _id: '',
            name: ''
          });
        }
        resultlist.push(tmplist);
      }
      $scope.printers = resultlist;
      //console.log($scope.printers);
    };

    /***选择打印机***/
    $scope.selectPrinter = function(printer) {
      $Window.showLoading({
        template: '正在连接打印机...'
      });
      $Print.selectPrinter(printer).then(function(data){
        return data;
      },function(err){
        if(printer && printer.isBluetoothPrinter){
          $Window.showAlert('错误','无法连接蓝牙打印机,请检查设备电源是否开启!');
        }
        return $q.reject(err);
      }).finally(function(){
        $Window.hideLoading();
      });
    };

    /***远程请求云打印机列表***/
    //下拉更新
    $scope.doRefreshPrinters = function(fromServer) {
      fromServer = fromServer || false;
      var cachePrinters = [];
      $Print.getPrints(fromServer).then(function(printers) {
        if(fromServer){
          var printercount = printers.length,toastmsg = '未找到新设备!';
          if(printercount > 0){
            toastmsg = '共发现'+printercount+'个设备!';
          }
          $Window.showToast(toastmsg);
        }
        //排序打印机
        //$scope.sortPrinters(printers);
      },function(err){
        console.log(err);
      },function(printer){
        var cacheprinter = _.find(cachePrinters, function (item) {
          return item.address === printer.address;
        });
        if (cacheprinter) {
          cacheprinter = _.assign(cacheprinter, printer);
        } else {
          cacheprinter = printer;
          cachePrinters.push(cacheprinter);
        }
        //排序打印机
        $scope.sortPrinters(cachePrinters);
        //有上次连接的打印机
        if(printer.selected){
          $Print.selectPrinter(printer).then(function(data){
            //console.log(data);
          },function(err){
            printer.selected = false;
          });
        }
      }).finally(function() {
        if (fromServer) {
          $scope.$broadcast('scroll.refreshComplete');
        }
      });
    };

    /***发送打印命令***/
    $scope.doPrint = function() {
      if (!$Print.thisPrinter()) {
        return $Window.showAlert('提示', '请指定打印机!');
      }
      //console.log('发送打印命令');
      $Print.print().then(function() {
        $Print.clearPrintData();
        var msg = '打印数据已发送!';
        if($Print.thisPrinter() && $Print.thisPrinter().isBluetoothPrinter){
          msg = '打印完成!';
        }
        $Window.showAlert('恭喜', msg).then(function() {
          goBack();
        });
      },function(err){
        $Window.showAlert('出错', '无法发送打印数据,请稍后再试!');
      });
    };

    //取消打印
    $scope.cancelPrint = function() {
      var count = $Print.getPrintDataCount().all || 0;
      if(count){
        $Window.showConfirm('确认取消?', '是否取消打印' + count + '张单据?!').then(function(isOk) {
          if (isOk) {
            $Print.clearPrintData();
            goBack();
          }
        });
      }
    };

    //搜索蓝牙打印机
    $scope.doSearch = function() {
      // $Window.showLoading({
      //   template: '正在搜索打印机...'
      // });
      $scope.searching = true;
      var toastmsg = '未找到新设备!';
      var searchPrinters = [];
      //保留云打印机和当前连接的蓝牙打印机
      _.forEach($scope.printers, function(row){
        _.forEach(row, function(printer){
          if(!_.isEmpty(printer.name) && (!printer.isBluetoothPrinter || printer.selected)){
            searchPrinters.push(printer);
          }
        });
      });
      //返回结果中会包含云打印机和蓝牙打印机
      $Print.getBluetoothPrinters(true).then(function(printers) {
        console.log(printers);
        //$scope.sortPrinters(printers);
        var printercount = printers.length;
        if(printercount > 0){
          toastmsg = '共发现'+printercount+'个设备!';
        }
        $Window.showToast(toastmsg);
      },function(err){
        $Window.showToast('出现错误,请稍后再试!');
      },function(printer){
        var cacheprinter = _.find(searchPrinters, function (item) {
          return item.address === printer.address;
        });
        if (cacheprinter) {
          cacheprinter = _.assign(cacheprinter, printer);
        } else {
          cacheprinter = printer;
          searchPrinters.push(cacheprinter);
        }
        //排序打印机
        $scope.sortPrinters(searchPrinters);
        //有上次连接的打印机
        if(printer.selected){
          //是否蓝牙打印机?
          if(printer.isBluetoothPrinter){
            $Print.selectPrinter(printer);
          }
          // else{
          //   //判断云打印机是否在线
          //
          // }
          return false;
        }
      })
      .finally(function() {
        //$Window.hideLoading();
        $scope.searching =false;
      });
    };

    //初始化云打印机
    $scope.$on('$ionicView.afterEnter', function(e) {
      //初始化菜单项目
      initActions();
      //设置菜单项目
      $scope.setActionMenus(actions);
			//设置菜单引用对象
			$scope.setActionData($scope);
      //缓存中读取印机列表
      $scope.doRefreshPrinters();
      //当前打印任务数
      $scope.taskcount = $Print.getPrintDataCount();
    });
  });
