
angular.module('bagu.controllers')
.controller('RegisterCtrl', function($scope, $state, $interval, $http, $ionicSideMenuDelegate, AuthService) {

  // Form data for the login modal
  $scope.data = {hasSendSms:false,mobile:null,verifycode:null,password:null,confirm:null};

  $scope.registermessage = '';
  $scope.timevalue = 0;

  $scope.onMobileChanged = function(){
    $scope.registermessage = undefined;
  };

  $scope.sendVerifyCode = function(){
    //console.log('Doing sendVerifyCode');
    AuthService.verifycode($scope.data.mobile).then(function(){
      $scope.data.hasSendSms = true;
      $scope.setInterval();
    },function(err){
      $scope.registermessage = err.message;
    });
  };

  $scope.canRegister = function(){
    return $scope.data.mobile && $scope.data.verifycode && $scope.data.password && $scope.data.password === $scope.data.confirm;
  };

  // Perform the login action when the user submits the login form
  $scope.doResister = function() {
    //console.log('Doing register', $scope.data);
    AuthService.register($scope.data.mobile,$scope.data.verifycode,$scope.data.password, $scope.data.confirm).then(function(authenticated) {
      $state.go('app.buildings');
      if($ionicSideMenuDelegate.isOpen()){
        $ionicSideMenuDelegate.toggleLeft(false);
      }
    }, function(err) {
      $scope.registermessage = err.message;
    });
  };

  //60秒倒计时
  var interval;

  $scope.setInterval = function(){
    //如果已经创建计时器,则直接退出
    if(angular.isDefined(interval)){
      return;
    }
    $scope.timevalue = 60;
    interval = $interval( function(){
      $scope.timevalue--;
      if($scope.timevalue === 0){
        $scope.clearInterval();
      }
    }, 1000);
  };

  $scope.clearInterval = function(){
    if(angular.isDefined(interval)){
      $interval.cancel(interval);
      interval = undefined;
    }
  };

  $scope.$on('$ionicView.enter', function() {
    $scope.registermessage = '';
  });

  $scope.$on('$destroy', function() {
    //销毁计时器
    $scope.clearInterval();
  });
});
