angular.module('bagu.controllers')
  //租金单
  .controller('RoomRentCtrl', function($scope, $stateParams, $ionicPopup, $http, $ionicHistory, $ionicLoading, $state, $ionicModal, _,
    $Window, $Cache, $Date, $Room, $RoomValue, $Rent, $Print, $Sms, $Building, $Invoice, DATALIST) {
    /***保存参数***/
    $scope.roomId = $stateParams.roomId;
    $scope.invoiceId = $stateParams.invoiceId;
    $scope.editmode = false;
    $scope.hasChanged = false;
    //菜单定义
    var config = {
      actions: [{
        id: 1,
        name: '修改',
        text: function(){
          return $scope.editmode ? '取消修改' : '修改';
        },
        class: '',
        href: undefined,
        visible: function(data) {
          return true;
        },
        disabled: function(data) {
          return data && angular.isNumber(data.invoicestatus) && data.invoicestatus === DATALIST.INVOICE_STATUS.DELETE;
        },
        click: function(data) {
          var action = this;
          if ($scope.editmode) {
            if ($scope.hasChanged) {
              $Window.showConfirm('取消修改?', '该单据数据已发生变更,是否取消修改?').then(function(isok) {
                if (isok) {
                  $scope.editmode = false;
                  //action.text = '修改';
                }
              });
            }else{
              $scope.editmode = false;
              //action.text = '修改';
            }
          } else {
            if (data.invoicestatus && data.invoicestatus === DATALIST.INVOICE_STATUS.FINANCE) {
              $Window.showConfirm('是否修改?', '该单据已经收费,请谨慎修改!').then(function(isok) {
                if (isok) {
                  $scope.editmode = true;
                  //action.text = '取消修改';
                }
              });
            }else{
              $scope.editmode = true;
            }
          }
        }
      }, {
        id: 2,
        text: '通话',
        badge: 0,
        class: '',
        href: undefined,
        visible: function(data) {
          return false;
        },
        click: function(data) {
          return;
        }
      }, {
        id: 3,
        text: '催缴',
        badge: 0,
        class: '',
        href: undefined,
        visible: function(data) {
          return true;
        },
        click: function(data) {
          var invoice = data;
          $Sms.sendInvoiceSms(invoice.building, invoice._id).then(function() {
            $Window.showAlert('恭喜', invoice.code + '房催缴短信已发送!');
          }, function(err) {
            $Window.showAlert('失败', err.message || err);
          });
        }
      }, {
        id: 4,
        text: '打单',
        badge: 0,
        class: '',
        href: undefined,
        visible: function(data) {
          return true;
        },
        click: function(data) {
          var invoice = data;
          //写入租金单数据
          $Print.clearPrintData();
          $Print.addInvoiceData([invoice]);
          $state.go('app.printer');
        }
      }, {
        id: 5,
        text: '作废',
        badge: 0,
        class: '',
        href: undefined,
        click: function(data) {
          var invoice = data;
          $Window.showConfirm('警告','是否确认作废该单据?').then(function(isok){
            if(isok){
              $Invoice.deleteInvoice(invoice).then(function(response){
                //刷新按量计费项目的最后抄表记录(表底数)
                $RoomValue.updateRoomValue(invoice.building, invoice.room).then(function (roomvalues) {
                });
                $Window.showAlert('恭喜', '作废单据完成!');
                $ionicHistory.goBack();
              },function(err){
                $Window.showAlert('失败', err.message || err);
              });
            }
          });
        }
      }, {
        id: 6,
        text: '彻底删除',
        badge: 0,
        class: '',
        href: undefined,
        click: function(data) {
          var invoice = data;
          $Window.showConfirm('警告','彻底删除的单据将不再显示,确认删除?').then(function(isok){
            if(isok){
              $Invoice.removeInvoice(invoice).then(function(response){
                $Window.showAlert('恭喜', '单据删除成功!');
                $ionicHistory.goBack();
              },function(err){
                $Window.showAlert('失败', err.message || err);
              });
            }
          });
        }
      }, ],
      //enum:{'已创建':0,'已确认':1,'已打印':2,'已收费':3,'已作废':4,'已存档':5}
      statusactions: [{
        status: [0, 1, 2],
        menus: ['修改', '催缴', '打单', '作废']
      }, {
        status: [3, 5],
        menus: ['修改', '打单', '作废']
      }, {
        status: [4],
        menus: ['通话','彻底删除']
      }]
    };
    //根据状态,计算需要显示的菜单项目
    $scope.getMenus = function(status) {
      var result = [];
      var statusconfig = _.find(config.statusactions, function(item) {
        return item.status === status || (_.isArray(item.status) && _.contains(item.status, status));
      });
      if (statusconfig && statusconfig.menus) {
        _.forEach(config.actions, function(item) {
          if (_.contains(statusconfig.menus, item.name) || _.contains(statusconfig.menus, item.text)) {
            result.push(item);
          }
        });
      }
      return result;
    };
    /***工具函数**/

    //重新你计算租金单金额
    function reCalcInvoiceMoney() {
      var invoice = $scope.invoice;
      //计算总金额
      invoice.detailmoney = _.reduce(invoice.items, function(result, item) {
        return result += item.money;
      }, 0);
      invoice.money = invoice.coupon && invoice.coupon.money ? invoice.detailmoney - invoice.coupon.money : invoice.detailmoney;
    }

    //是否一次计费项目
    $scope.isOnceFeeItem = $Invoice.isOnceFeeItem;
    //是否按月计费项目
    $scope.isMonthlyFeeItem = $Invoice.isMonthlyFeeItem;
    //是否按量计费项目
    $scope.isAmountFeeItem = $Invoice.isAmountFeeItem;
    //是否按面积计费项目
    $scope.isAreaFeeItem = $Invoice.isAreaFeeItem;
    //是否按人数计费项目
    $scope.isPersonFeeItem = $Invoice.isPersonFeeItem;
    //是否收取押金项目?
    $scope.isPledgeInvoiceItem = $Invoice.isPledgeInvoiceItem;

    //是否可以编辑日期
    $scope.canChangeDate = function() {
      return $scope.editmode;
    };
    //是否可以编辑总金额
    $scope.canChangeMoney = function() {
      return $scope.editmode;
    };
    //是否可以编辑收费项目金额
    $scope.canChangeItemMoney = function(item) {
      return $scope.editmode;
    };
    //是否可以编辑产品订购记录
    $scope.canChangeProduct = function() {
      return $scope.editmode;
    };
    //是否可以编辑备注
    $scope.canChangeMemo = function() {
      return $scope.editmode;
    };
    //是否可以保存租金单
    $scope.canSaveInvoice = function() {
      return $scope.editmode;
    };
    //获取时间段
    $scope.getDateRangeString = $Date.getDateRangeString;

    //租金单时间发生变化,重新计算租金和总金额
    $scope.doInvoiceDateChange = function() {
      var invoice = $scope.invoice;
      _.forEach(invoice.items, function(invoiceitem) {
        if ($scope.isMonthlyFeeItem(invoiceitem)) {
          //计算按月固定项目的金额(根据时间)
          invoiceitem.begindate = invoice.begindate;
          invoiceitem.enddate = invoice.enddate;
          invoiceitem.money = $Rent.calcProductMoney(DATALIST.PRODUCT_FEETYPE.MONTHLY, invoiceitem.price, invoiceitem.begindate, invoiceitem.enddate, 0);
        }
      }); //计算总金额
      reCalcInvoiceMoney();
    };

    //租金单实收金额发送变化
    $scope.doInvoiceMoneyChange = function(invoice) {
      //动态计算优惠额度
      if(!invoice.coupon){
        invoice.coupon = {
          code: 0, //手动优惠
          name: '手动优惠',
          money: 0
        };
      }
      invoice.coupon.money = invoice.detailmoney - invoice.money;
    };

    //费用细目发生变化,更新总金额
    $scope.doItemMoneyChange = function(invoiceitem) {
      if ($scope.isAmountFeeItem(invoiceitem)) {
        invoiceitem.value.amount = invoiceitem.value.current - invoiceitem.value.init;
        //判断是否有设置保底用量
        if ($scope.building && $scope.building.defaultproducts) {
          var defaultproduct = _.find($scope.building.defaultproducts, function(item) {
            return item._id === invoiceitem.product;
          });
          if (defaultproduct && defaultproduct.minvalue > 0 && invoiceitem.value.amount < defaultproduct.minvalue) {
            invoiceitem.value.amount = defaultproduct.minvalue;
            invoiceitem.isminvalue = true;
          }
        } else {
          invoiceitem.isminvalue = false;
        }
        invoiceitem.money = Math.round(invoiceitem.value.amount * invoiceitem.price);
      } else if ($scope.isMonthlyFeeItem(invoiceitem)) {
        invoiceitem.money = $Rent.calcProductMoney(DATALIST.PRODUCT_FEETYPE.MONTHLY, invoiceitem.price, invoiceitem.begindate, invoiceitem.enddate, 0);
      } else if ($scope.isOnceFeeItem(invoiceitem)) {
        invoiceitem.money = invoiceitem.price;
      } else if ($scope.isAreaFeeItem(invoiceitem) || $scope.isPersonFeeItem(invoiceitem)) {
        invoiceitem.money = Math.round(invoiceitem.value.amount * invoiceitem.price);
      }
    };
    //修改租金单明细金额(按月收费)
    $scope.changeTotalMoney = function(invoice) {
      $scope.PopupData = _.cloneDeep(invoice);
      //弹出对话框
      var popup = $ionicPopup.show({
        //template: template,
        templateUrl: 'templates/popup/change.money.invoice.popup.html',
        title: '调整实收金额',
        scope: $scope,
        buttons: [{
          text: '取消'
        }, {
          text: '<b>确定</b>',
          type: 'button-positive',
          onTap: function(e) {
            return $scope.PopupData;
          }
        }, ]
      });

      popup.then(function(popudata) {
        console.log('Tapped!', popudata);
        popup.close();
        if (popudata) {
          invoice.money = popudata.money;
          _.assign(invoice.coupon, popudata.coupon);
          //计算总金额
          reCalcInvoiceMoney();
        }
      });
    };
    //修改租金单明细金额(按月收费)
    $scope.changeItemMoney = function(invoiceitem) {
      $scope.PopupData = _.cloneDeep(invoiceitem);
      //弹出对话框
      var popup = $ionicPopup.show({
        //template: template,
        templateUrl: 'templates/popup/change.item.invoice.popup.html',
        title: (invoiceitem.name ? invoiceitem.name : '收费项目') + '调整',
        scope: $scope,
        buttons: [{
          text: '取消'
        }, {
          text: '<b>确定</b>',
          type: 'button-positive',
          onTap: function(e) {
            return $scope.PopupData;
          }
        }, ]
      });

      popup.then(function(popudata) {
        console.log('Tapped!', popudata);
        popup.close();
        if (popudata) {
          _.assign(invoiceitem, popudata);
          //计算总金额
          reCalcInvoiceMoney();
        }
      });
    };

    //增加产品
    $scope.addProduct = function(invoice) {
      $scope.PopupData = {
        begindate: invoice.begindate,
        enddate: invoice.enddate,
        name: '',
        feetype: DATALIST.PRODUCT_FEETYPE.ONCE,
        unit: '',
        price: 0,
        money: 0
      };
      //弹出对话框
      var popup = $ionicPopup.show({
        //template: template,
        templateUrl: 'templates/popup/new.item.invoice.popup.html',
        title: '新增收费项目',
        scope: $scope,
        buttons: [{
          text: '取消'
        }, {
          text: '<b>确定</b>',
          type: 'button-positive',
          onTap: function(e) {
            return $scope.PopupData;
          }
        }, ]
      });

      popup.then(function(productdata) {
        console.log('Tapped!', productdata);
        popup.close();
        if (productdata) {
          invoice.items.push(productdata);
          //计算总金额
          reCalcInvoiceMoney();
        }
      });
    };

    //删除收费项目
    $scope.deleteItem = function(invoiceitem) {
      $Window.showConfirm('删除确认', '确认要删除' + invoiceitem.name + '项目吗?').then(function(isOk) {
        if (isOk) {
          _.remove($scope.invoice.items, function(item) {
            return item === invoiceitem;
          });
          //计算总金额
          reCalcInvoiceMoney();
        }
      });
    };

    //长按编辑或删除项目
    $scope.onInvoiceItemHold = function(invoiceitem){
      if(!$scope.canChangeItemMoney(invoiceitem)){
        return false;
      }
      //如果是一次性计费项目,则可以删除,弹出操作选择层,否则直接打开调整界面
      if($scope.isOnceFeeItem(invoiceitem)){
        var buttons = [{ text: '<div style="height:40px;">调整项目<div>'}];
        var buttonFun = function(index){
          $scope.changeItemMoney(invoiceitem);
          return true;
        };
        var destructive = '删除项目';
        var destructiveFun = function(index){
          $scope.deleteItem(invoiceitem);
          return true;
        };
        $Window.showActionSheet(invoiceitem.name,buttons,buttonFun,destructive,destructiveFun);
      }else{
        $scope.changeItemMoney(invoiceitem);
      }
    };

    /***数据处理***/
    //保存数据
    $scope.doSaveInvoice = function() {
      $Invoice.updateInvoice($scope.invoice).then(function(invoice) {
        $scope.invoice = _.cloneDeep(invoice);
        //fixInvoice($scope.invoice);
        $Window.showAlert('恭喜', '保存成功!');
        $ionicHistory.goBack();
      }, function(err) {
        $Window.showAlert('糟糕', '保存失败了,请稍后重试!');
      });
    };

    //刷新数据
    $scope.doRefreshInvoice = function(fromServer) {
      $Invoice.getRoomInvoice($scope.buildingId, $scope.roomId, $scope.invoiceId, fromServer).then(function(invoice) {
        $scope.invoice = _.cloneDeep(invoice);
        $scope.editmode = $scope.invoice.invoicestatus < DATALIST.INVOICE_STATUS.FINANCE;
        //fixInvoice($scope.invoice);
        $scope.title = invoice.typestr + '(' + invoice.code + ')';
        //设置操作绑定的数据对象
        $scope.setActionData($scope.invoice);
        //设置操作菜单
        $scope.setActionMenus($scope.getMenus($scope.invoice.invoicestatus));
      }).finally(function() {
        if (fromServer) {
          $scope.$broadcast('scroll.refreshComplete');
        }
      });
    };

    /***初始化***/
    $scope.title = '租金单';
    $Room.getRoom($scope.roomId).then(function(room) {
      $scope.buildingId = room.building;
      $scope.doRefreshInvoice(false);
      //获取楼房信息
      $Building.getBuilding($scope.buildingId, false).then(function(building) {
        $scope.building = building;
      });
    });

    /***监听事件***/
    //进入视图事件
    $scope.$on('$ionicView.enter', function() {

    });
    //退出时清理模态对象
    $scope.$on('$destroy', function() {});
  });
