angular.module('bagu.controllers')
    //房间
    .controller('RoomOrderCtrl', function($scope, $state, $stateParams, $ionicModal,
        $http, $ionicPopover, $ionicPopup, $ionicLoading, $ionicHistory, $filter, $ionicListDelegate,
        $Cache, _, $Date,
        $Print, $Rent, $Building, $Room, $RoomValue, $Customer, $Product, $Window, $PriceLog, $Sms, $Invoice,
        DATALIST, LOCAL) {

        /***保存参数***/
        $scope.roomId = $stateParams.roomId;
        // Form data for the add customer modal
        $scope._customerNew = {};
        //设置默认标题
        $scope.title = '预订房间';
        $scope.data = {
             money: 200,
            'date': new Date(),
            'credtype': '身份证',
            'expired': $Date.addDays(new Date(),5)
        };

        /**********自定义方法**********/

        //设置房间
        function setRoom(room) { //设置标题
          //房间是否处于预定状态
          if(room.roomstatus === DATALIST.ROOM_STATUS.ORDER && room.prerent){
            $scope.data = room.prerent.preinfo;
            $scope.data.date = new Date($scope.data.date);
            $scope.data.expired = new Date($scope.data.expired);
            $scope.data.customer = $scope.data.customer;
            $scope.data.phone = $scope.data.phone;
            $scope.data.price = $scope.data.price;
            $scope.data.money = $scope.data.money;
          }else{
            $scope.data.price = room.rent && room.rent.contract ? room.rent.contract.price : room.price;
            //有预约退房?到期时间为预约退房日期的第二天
            if(room.rent && room.rent.back && room.rent.back.backdate){
              $scope.data.expired = $Date.addDays(new Date(room.rent.back.backdate),1);
            }else{
              $scope.data.expired = new Date($scope.data.expired);
            }
          }
          $scope.title = '预订' + room.code;
          $scope.room = room;
        }

        /**********获取房间数据**********/

        //获取房间
        $scope.getRoom = function(roomId, isRefresh) {
            isRefresh = isRefresh || false;
            $Room.getRoom(roomId, isRefresh).then(function(room) {
                    //设置房间
                    setRoom(room);
                })
                .catch(function(err) {
                    console.log('load room error:', err);
                })
                .finally(function() {
                    // Stop the ion-refresher from spinning
                    if (isRefresh) {
                        $scope.$broadcast('scroll.refreshComplete');
                    }
                });

        };

        //下拉更新
        $scope.doRefresh = function() {
            $scope.getRoom($stateParams.roomId, true);
        };

        //加载房间数据
        // console.log('Show room', $scope.isAuthenticated(), $stateParams.roomId,
        //   $stateParams.roomCode);
        $scope.getRoom($stateParams.roomId);

        /**********事件**********/
        var firstrun = true;
        $scope.$on('$ionicView.enter', function(e) {
            //$Window.showAlert('enter','building');
            if (firstrun) {
                firstrun = false;
            } else {
                //缓存中读取楼房列表
                $scope.getRoom($stateParams.roomId);
            }
        });

        //确认预订
        $scope.confirmOrder = function() {
            var room = $scope.room;
            //是否新增?
            if(!room.prerent){
              $Rent.order(room._id, $scope.data).then(function(data) {
                  console.log(data);
                  var preinfo = data && data.prerent && data.prerent.preinfo ? data.prerent.preinfo : undefined;
                  $Room.setRoomIsOrder(room._id, preinfo);
                  $Window.showAlert('恭喜',$scope.room.code + '预订成功!');
                  $ionicHistory.goBack();
              }, function(err) {
                  $Window.showAlert('失败', $scope.room.code + '预订失败!');
              });
            }else{ //修改
              $Rent.editOrder(room._id, $scope.data).then(function(data) {
                  console.log(data);
                  var preinfo = data;
                  $Room.setRoomIsOrder(room._id, preinfo);
                  $Window.showAlert('恭喜',$scope.room.code + '修改预订信息成功!');
                  $ionicHistory.goBack();
              }, function(err) {
                  $Window.showAlert('失败', $scope.room.code + '修改预订信息失败!');
              });
            }
        };
    });
