angular.module('bagu.controllers')
  .controller('SettingsCtrl', function($ionicPlatform, $rootScope, $scope, $state, $http, $Cache, $Window, $Update, $Local, SERVER_SETTINGS, EVENTS, LOCAL, _) {
    //获取本地缓存设置
    var localSetting = $Local.get();
    $scope.localSetting = localSetting;
    //服务器列表
    $scope.servers = SERVER_SETTINGS;
    //当前服务器
    if(localSetting && !localSetting.CUR_SERVER){
      localSetting.CUR_SERVER = localSetting && localSetting.CUR_SERVER ? localSetting.CUR_SERVER : SERVER_SETTINGS.CUR_SERVER;
      $Local.save();
    }
    //语音提示列表
    $scope.languages = LOCAL.AUDIO.LANGUAGES;
    //当前语言
    if(localSetting && (!localSetting.AUDIO || !localSetting.AUDIO.CUR_LANGUAGE)){
      localSetting.AUDIO = localSetting.AUDIO || {};
      localSetting.AUDIO.CUR_LANGUAGE = localSetting.AUDIO.DEFAULT_LANGUAGE ? localSetting.AUDIO.DEFAULT_LANGUAGE : LOCAL.AUDIO.DEFAULT_LANGUAGE;
      $Local.save();
    }
    //其他设置
    $scope.title = '系统设置';
    $scope.localVersion = '';

    /***函数接口方法***/
    //清理缓存
    $scope.clearCache = function() {
      $Cache.clear();
      // $rootScope.$broadcast(EVENTS.CACHE.CLEAR);
    };

    //选择语音设置
    $scope.doSelectLanguage = function(){
      $Local.save();
    };

    //选择服务器
    $scope.doSelectServer = function(server){
      SERVER_SETTINGS.CUR_SERVER = server;
      $Local.save();
    };

    //版本更新
    $scope.versionCheck = function() {
      $Update.updateApp();
    };

    //获取App版本号
    if(window.cordova && $ionicPlatform.is('Android')){
      $Update.getLocalVersion().then(function(ver){
        $scope.localVersion = ver;
      },function(err){
        $scope.localVersion = '';
      });
    }

    $scope.$on('$destroy', function() {});
  });
