angular.module('bagu.controllers')
  //抄表
  .controller('ValueLogCtrl', function($q, $rootScope, $scope, $stateParams, $ionicPopup,
    $ionicPlatform, $ionicNavBarDelegate, $Audio,
    $http, $ionicHistory, $ionicLoading, $state, $cordovaMedia, _,
    $Window, $Cache, $Building, $Room, $Product, $RoomValue, $Invoice) {
    /***保存参数***/
    $scope.buildingId = $stateParams.buildingId;
    $scope.productId = $stateParams.productId;
    $scope.roomId = $stateParams.roomId;
    /***全局变量***/
    $scope.audiostatus = {}; //多媒体对象的状态,用于控制重复数字播放问题
    $scope.minvalue = 0; //默认无保底数
    $scope.newValue = 0; //当前读数
    $scope.curAmount = 0; //当前用量
    $scope.curMoney = 0; //当前费用
    $scope.valueCheckInfo = { //信息
      isWarning: false, //是否存在警告
      warningMsg: '', //警告信息
      isError: false, //是否存在错误
      errorMsg: '', //错误信息
    };
    //按钮定义
    $scope.buttonConfig = [
      [{value:1,text:'1'},{value:2,text:'2'},{value:3,text:'3'}],
      [{value:4,text:'4'},{value:5,text:'5'},{value:6,text:'6'}],
      [{value:7,text:'7'},{value:8,text:'8'},{value:9,text:'9'}],
      [{value:'clear',text:'清'},{value:0,text:'0'},{value:'delete',text:'删'}]
    ];
    //菜单定义
    var actions = [];
    var productsKeyName = 'products';

    //判断是否由roomView跳转过来
    function fromRoomView() {
      var backview = $ionicHistory.backView();
      //如果是从房间信息页面切换过来,则标题显示抄表类型
      return backview && backview.stateName === 'app.room';
    }

    //保存抄表记录
    var savevaluelogfun = function(readdate, done) {
      // $Window.showLoading({
      //   template: '正在保存...'
      // });
      var roomId = $scope.curRoom._id !== $scope.buildingId ? $scope.curRoom._id : $scope.curRoom.masterindex;
      if ($RoomValue.savedValueLog2Cache($scope.buildingId, $scope.productId, roomId, readdate, $scope.newValue) > 0) {
        //重置修改状态
        $scope.hasChanged = false;
        //提示语音
        $Audio.preparePlay(['保存']).play();
        if (done) {
          done();
        }
      }
    };



    /***显示Http返回错误***/
    function showHttpError(data, status, headers, config) {
      //只处理业务错误,权限错误由appctrl处理
      if (status === 400) {
        var msg = data.message || '加载数据出错,请稍后重试!';
        $Window.showAlert('抱歉', msg).then(function(res) {
          $ionicHistory.goBack();
        });
      }
    }
    //计算金额
    var calcMoney = function() {
      $scope.curAmount = $scope.newValue - $scope.curRoom.lastvalue;
      //计算用量
      if ($scope.minvalue && $scope.minvalue > 0 && $scope.curAmount < $scope.minvalue) {
        $scope.curMoney = Math.round($scope.minvalue * $scope.price);
      } else {
        $scope.curMoney = Math.round($scope.curAmount * $scope.price);
      }
    };

    //检查数据合法性
    var checkValue = function(){
      var checkInfo = {
        isWarning: false, //是否存在警告
        warningMsg: '', //警告信息
        isError: false, //是否存在错误
        errorMsg: '', //错误信息
      };
      //计算金额
      calcMoney();
      //开始判断
      var curAmount = $scope.curAmount;
      var curMoney = $scope.curMoney;
      var curRate = $scope.curRoom.guessvalue !== $scope.curRoom.lastvalue ? ($scope.newValue - $scope.curRoom.guessvalue) / ($scope.curRoom.guessvalue - $scope.curRoom.lastvalue) : 0;
      //非抄表状态或者未抄表
      if(!$scope.curRoom || !$scope.hasChanged){
        $scope.valueCheckInfo = checkInfo;
        return;
      }
      //读数小于上个月
      if($scope.newValue < $scope.curRoom.lastvalue){
        checkInfo.isWarning = true;
        checkInfo.warningMsg = '读数小于上个月';
      }

      //读数上浮超过100%
      if(curMoney > 200 && curRate > 1){
        checkInfo.isError = true;
        checkInfo.isWarning = true;
        checkInfo.errorMsg = '用量不合理'+ ($scope.curRoom.lastamount ? ',上次用量'+$scope.curRoom.lastamount : '');
        //播放语音
        //$Audio.preparePlay(['bong','用量不合理','上次用量'],$scope.curRoom.lastamount,$scope.product.unit).play();
        $Audio.preparePlay(['bong','用量不合理']).play();
      } else
      //读数下浮超过80%
      if(curMoney > 50 && curRate < -0.8){
        checkInfo.isError = true;
        checkInfo.isWarning = true;
        checkInfo.errorMsg = '用量不合理'+ ($scope.curRoom.lastamount ? ',上次用量'+$scope.curRoom.lastamount : '');
        //播放语音
        //$Audio.preparePlay(['bong','用量不合理','上次用量'],$scope.curRoom.lastamount,$scope.product.unit).play();
        $Audio.preparePlay(['bong','用量不合理']).play();
      } else
      //读数上浮超过50%
      if(curMoney > 100 && curRate > 0.5){
        checkInfo.isWarning = true;
        checkInfo.warningMsg = '用量偏多'+ ($scope.curRoom.lastamount ? ',上次用量'+$scope.curRoom.lastamount : '');
        //播放语音
        //$Audio.preparePlay(['dong','用量偏多','上次用量'],$scope.curRoom.lastamount,$scope.product.unit).play();
        $Audio.preparePlay(['dong','用量偏多']).play();
      } else
      //读数下浮超过50%
      if(curMoney > 50 && curRate < -0.5){
        checkInfo.isWarning = true;
        checkInfo.warningMsg = '用量偏少'+ ($scope.curRoom.lastamount ? ',上次用量'+$scope.curRoom.lastamount : '');
        //播放语音
        //$Audio.preparePlay(['dong','用量偏少','上次用量'],$scope.curRoom.lastamount,$scope.product.unit).play();
        $Audio.preparePlay(['dong','用量偏少']).play();
      }

      //如果读数正常,并且有正常用量,则语音提示用量和金额
      if(!checkInfo.isWarning && !checkInfo.isError && curAmount >= 0){
        var amount = curAmount;
        if(curAmount < $scope.minvalue){
          amount = $scope.minvalue;
        }
        setTimeout(function () {
          $Audio.preparePlay(['用量'],amount,$scope.product.unit,['费用'],curMoney,'元').play();
        }, 500);
      }

      $scope.valueCheckInfo = checkInfo;
    };

    //询问是否保存
    function showSavePopup(save,unsave,cancel) {
      var amountstr = ($scope.newValue - $scope.curRoom.lastvalue).toString();
      var valuestr = $scope.newValue.toString();
      //播放语音
      $Audio.preparePlay(['dong','是否','保存']).play();
      var savepopup = $ionicPopup.show({
        template: '当前读数:' + valuestr + $scope.product.unit + ',用量:' +
          amountstr + $scope.product.unit,
        title: '是否保存?',
        subTitle: $scope.curRoom.code + '房间',
        scope: $scope,
        buttons: [{
          text: '取消',
          onTap: function(e) {
            return -1;
          }
        }, {
          text: '不保存',
          onTap: function(e) {
            return 0;
          }
        }, {
          text: '<b>保存</b>',
          type: 'button-positive',
          onTap: function(e) {
            return 1;
          }
        }, ]
      });

      savepopup.then(function(bsave) {
        savepopup.close();
        if (bsave === 1) {
          savevaluelogfun($scope.readdate, save);
        } else if (bsave === 0) {
          if(_.isFunction(unsave)){
            unsave();
          }else{ //如果未定义不保存的回调函数,则默认调用保存回调函数
            return save && save();
          }
        } else if (bsave === -1) {
          if(_.isFunction(cancel)){
            cancel();
          }
        }
      });
    }
    //更新抄表信息(初始化和切换房间时使用)
    function updateRoomValueInfo(roomvalue) {
      //设置标题
      //如果是从房间信息页面切换过来,则标题显示抄表类型
      if (fromRoomView()) {
        $scope.title = $scope.product.name.replace('费','表');
        $scope.backTitle = roomvalue.code;
      } else { //否则只显示房间号码
        $scope.title = roomvalue.code;
        $scope.backTitle = $scope.product.name.replace('费','表');
        //前一个抄表房间
        $scope.prevRoom = $RoomValue.getNextRoomValue($scope.buildingId, $scope
          .productId, roomvalue, -1);
        //后一个抄表房间
        $scope.nextRoom = $RoomValue.getNextRoomValue($scope.buildingId, $scope
          .productId, roomvalue);
      }
      //获取房间数据
      $Room.getCacheRoom(roomvalue._id, false).then(function(room) {
        $scope.room = room;
        $scope.roomId = room._id;
        /*** 更新产品价格 ****/
        //如果已出租,则使用合同中定义的单价
        if ($scope.room && $scope.room.rent && $scope.room.rent.contract && $scope.room.rent.contract.products) {
          var contractproduct = _.find($scope.room.rent.contract.products, function(item) {
            return item._id === $scope.productId;
          });
          $scope.price = contractproduct ? contractproduct.price : ($scope.defaultproduct && $scope.defaultproduct.price ? $scope.defaultproduct.price : $scope.product.price);
        }else
        if($scope.defaultproduct && $scope.defaultproduct.price){
          $scope.price = $scope.defaultproduct.price;
        }else{
          $scope.price = $scope.product.price;
        }
        //重置数据校验信息
        checkValue();
      });
      //当前抄表房间
      $scope.curRoom = roomvalue;
      //修正值
      if (!$scope.curRoom.value) {
        $scope.curRoom.value = 0;
      }
      //临时保存修改,提交成功后清空
      $scope.newValue = $scope.curRoom.cacheValue || $scope.curRoom.value;

      //重置修改状态
      $scope.hasChanged = false;
      //播放语音
      $Audio.preparePlay(roomvalue.code /*,['底数'],roomvalue.lastvalue,$scope.product.unit*/).play();
    }

    //获取需要抄表的费用类别
    function getProductList(done) {
      $Product.getValueProducts().then(function(products) {
        //未设置需要抄表的项目,提示并返回
        if (!_.isArray(products) || products.length === 0) {
          return $Window.showAlert('提示', '未设置按量计费的项目,无需抄表!').then(function(res) {
            $ionicHistory.goBack();
          });
        }
        $scope.products = products;
        //更新菜单项
        actions = [];
        var radioitems = [];
        _.forEach(products, function(item) {
          radioitems.push({
            id: item._id,
            text: item.name.replace('费','表'),
            badge: 0,
            value: item
          });
        });
        if(radioitems.length){
          actions.push({
            id: productsKeyName,
            type: 'radio',
            options: radioitems,
            value: products[0],
            class: '',
            badgeclass: 'badge-assertive',
            click: function(data, target) {
              $scope.changeProduct(target.value);
            }
          });
        }
        // _.forEach(products, function(item) {
        //   actions.push({
        //     id: item._id,
        //     text: item.name.replace('费','表'),
        //     badge: 0,
        //     class: '',
        //     badgeclass: 'badge-assertive',
        //     href: undefined,
        //     click: function(data) {
        //       $scope.changeProduct(item);
        //     }
        //   });
        // });
        //增加抄表顺序选项
        if(actions.length){
          actions.push({
            type: 'line'
          });
          actions.push({
            type: 'radio',
            options: [{
              text: '按楼层分组',
              value: 0
            },{
              text: '按房号分组',
              value: 1
            }],
            icon: 'ion-ios-checkmark',
            value: 0,
            class: '',
            badgeclass: 'badge-assertive',
            click: function(data,target) {
              $scope.changeOrder(target);
            }
          });
        }
        //是否设置$scope.productId?
        if(!$scope.productId){
          $scope.product = products[0];
          $scope.productId = $scope.product._id;
        }
        //设置菜单项目
        $scope.setActionMenus(actions);
        //返回
        if (done) {
          done($scope.products);
        }
      });
    }

    //刷新数据
    function refreshView(){
      //从缓存中取房间信息
      //$scope.room = $Cache.getRecord('rooms',$scope.roomId);
      $Room.getCacheRoom($scope.roomId).then(function(room) {
        $scope.room = room;
        // //如果缓存中找不到房间，则为总表，roomid值存储了buildingId
        // if (!$scope.room) {
        //   //楼房ID=roomId
        //   $scope.buildingId = $scope.roomId;
        // } else {
        //   //获取楼房ID
        //   $scope.buildingId = $scope.room.building;
        // }
        return room;
      }, function(err) {
        // //房间不存在,则为总表
        // //楼房ID=roomId
        // $scope.buildingId = $scope.roomId;
        return err;
      })
      //获取收费产品对象
      .then(function(obj) {
        $Product.getProduct($scope.productId).then(function(product) {
          $scope.product = product;
          //获取合同单价
          if ($scope.room && $scope.room.rent && $scope.room.rent.contract && $scope.room.rent.contract.products) {
            var contractproduct = _.find($scope.room.rent.contract.products, function(item) {
              return item._id === product._id;
            });
            $scope.price = contractproduct ? contractproduct.price : product.price;
          }
        });
        return obj;
      })
      //获取楼房对象
      .then(function(obj) {
        //是否需要加载楼房
        if(!$scope.building || $scope.building._id !== $scope.buildingId){
          $Building.getBuilding($scope.buildingId).then(function(building) {
            $scope.building = building;
            //获取保底数(楼房默认产品参数中minvalue)
            if (building && building.defaultproducts) {
              var defaultproduct = _.find(building.defaultproducts, function(item) {
                return item.product === $scope.product._id;
              });
              if (defaultproduct) {
                $scope.defaultproduct = defaultproduct;
                $scope.minvalue = defaultproduct.minvalue;
              }
              //如果未出租,则取楼房定义的默认单价,否则取产品定义的单价
              if((!$scope.room || !$scope.room.rent || !$scope.price) && defaultproduct){
                $scope.price = defaultproduct.price;
              }
            }
            //更新统计
            var productIds = _.map($scope.products, '_id');
            $RoomValue.getBuildingUnReadValueCount($scope.buildingId, productIds).then(function(pvalues) {
              //找到菜单项目
              var productMenuItem = _.find(actions, function(item){
                return item.id === productsKeyName;
              });
              if(productMenuItem){
                _.forEach(pvalues, function(pcount, key) {
                  var menuitem = _.find(productMenuItem.options, function(item) {
                    return item.id === key;
                  });
                  if (menuitem) {
                    menuitem.badge = pcount.count;
                  }
                });
              }
            });
          });
        }
        return obj;
      })
      //获取抄表记录
      .then(function(obj) {
        $RoomValue.getRoomValue($scope.buildingId, $scope.productId, $scope
          .roomId).then(function(roomvalue) {
          updateRoomValueInfo(roomvalue);
        });
      });
    }

    /***处理返回按钮***/
    // 点击返回按钮,判断是否需要保存
    var doBack = function() {
      if ($scope.hasChanged === true) {
        showSavePopup(function(response) {
          $ionicHistory.goBack();
        });
      }else{
        $ionicHistory.goBack();
      }
    };
    // override soft back
    // framework calls $rootScope.$ionicGoBack when soft back button is pressed
    var oldSoftBack = $rootScope.$ionicGoBack;
    $rootScope.$ionicGoBack = function() {
        doBack();
    };
    var deregisterSoftBack = function() {
        $rootScope.$ionicGoBack = oldSoftBack;
    };
    // override hard back
    // registerBackButtonAction() returns a function which can be used to deregister it
    var deregisterHardBack = $ionicPlatform.registerBackButtonAction(
        doBack, 101
    );

    /***定义变量***/
    //抄表时间
    $scope.readdate = new Date();

    /***定义函数***/
    //判断是否由roomView跳转过来
    $scope.fromRoomView = fromRoomView;
    //返回的回调函数
    $scope.doBack = doBack;

    //按钮点击事件
    $scope.buttonClick = function(col) {
      if (!$scope.hasChanged) {
        $scope.newValue = 0;
      }
      if (_.isNumber(col)) { //如果是数字0-9
        //播放声音
        //playaudio(col);
        $scope.audiostatus[col] = true;
        setTimeout(function () {
          $scope.audiostatus[col] = false;
        }, 500);
        $Audio.playNumber(col).finally(function(){
          $scope.audiostatus[col] = false;
        });
        //调整读数
        $scope.newValue = $scope.newValue * 10 + col;
      } else if (col === 'delete') { //如果是删除
        //播放声音
        $scope.audiostatus[col] = true;
        setTimeout(function () {
          $scope.audiostatus[col] = false;
        }, 500);
        $Audio.play('删除').finally(function(){
          $scope.audiostatus[col] = false;
        });
        //调整读数
        $scope.newValue = Math.floor($scope.newValue / 10);
      } else { //否则是清除
        //播放声音
        $scope.audiostatus[col] = true;
        setTimeout(function () {
          $scope.audiostatus[col] = false;
        }, 500);
        $Audio.play('清除').finally(function(){
          $scope.audiostatus[col] = false;
        });
        //调整读数
        $scope.newValue = 0;
      }
      $scope.hasChanged = $scope.newValue !== 0;
      //检查数据合理性
      checkValue();
    };
    //前一房间
    $scope.prevClick = function() {
      if ($scope.hasChanged === true) {
        showSavePopup(function(response) {
          updateRoomValueInfo($scope.prevRoom);
        });
      } else {
        updateRoomValueInfo($scope.prevRoom);
      }
    };
    //后一房间
    $scope.nextClick = function() {
      if ($scope.hasChanged === true) {
        showSavePopup(function(response) {
          updateRoomValueInfo($scope.nextRoom);
        });
      } else {
        updateRoomValueInfo($scope.nextRoom);
      }
    };
    //保存抄表记录
    $scope.saveClick = function(readdate) {
      savevaluelogfun(readdate, null);
    };

    //更改抄表项目
    $scope.changeProduct = function(product) {
      function doChange(){
        $scope.product = product;
        $scope.productId = product._id;
        $RoomValue.setCurValueProduct($scope.productId);
        //设置变量为null,让其重新刷新
        $scope.building = null;
        $scope.room = null;
        $scope.defaultproduct = null;
        refreshView();
      }
      if ($scope.hasChanged === true) {
        showSavePopup(function(response) {
          doChange();
        });
      } else {
        doChange();
      }
    };

    $scope.changeOrder = function(item){
      if(item && !_.isUndefined(item.value)){
        $RoomValue.setCurOrder($scope.buildingId, $scope.productId, item.value);
        //前一个抄表房间
        $scope.prevRoom = $RoomValue.getNextRoomValue($scope.buildingId, $scope
          .productId, $scope.curRoom, -1);
        //后一个抄表房间
        $scope.nextRoom = $RoomValue.getNextRoomValue($scope.buildingId, $scope
          .productId, $scope.curRoom);
      }
    };

    //查看抄表历史记录
    $scope.showValueHistory = function() {
      $state.go('app.valueloghistorys',{
        buildingId: $scope.buildingId,
        productId: $scope.productId,
        roomId: $scope.roomId,
      });
    };


    //隐藏返回按钮,采用自定义按钮
    $ionicNavBarDelegate.showBackButton(false);
    //读取声音文件
    //loadaudios();
    //获取按量收费产品
    getProductList(function(products){
      //刷新界面
      refreshView();
    });

    //处理点击返回按钮事件,判断是否有未保存数据
    $scope.$on('$ionicView.beforeLeave', function(event) {
      // if ($scope.hasChanged === true) {
      //   showSavePopup(function(response) {
      //     updateRoomValueInfo($scope.nextRoom);
      //   },null,function(){
      //     event.preventDefault();
      //   });
      // }
    });

    // cancel custom back behaviour
    $scope.$on('$destroy', function() {
        deregisterHardBack();
        deregisterSoftBack();
        $ionicNavBarDelegate.showBackButton(true);
    });
  });
