angular.module('bagu.controllers')
	//房间费用历史
	.controller('ValueLogHistorysCtrl', function ($scope, $stateParams, $ionicPopover, $ionicPopup, $ionicScrollDelegate,
		$http, $Cache, $state, _, DATALIST, $Window, $Print, $Building, $Room, $Product, $RoomValue, $Invoice, $Sms) {

		/***参数定义***/
		//url参数
		$scope.buildingId = $stateParams.buildingId;
		$scope.productId = $stateParams.productId;
		$scope.roomId = $stateParams.roomId;
		//设置标题
		$scope.title = '历史抄表记录';
		//设置标题
		$scope.subTitle = '历史抄表记录';
		//抄表记录
		$scope.valuelogs = [];

		/***工具函数***/

		//刷新数据
		$scope.refreshData = function (fromServer) {
			fromServer = fromServer || false;

			//获取产品信息
			$Product.getProduct($scope.productId).then(function (product) {
				$scope.product = product;
				//获取抄表历史
				$RoomValue.getValuelogHistorys($scope.productId, $scope.buildingId, $scope.roomId).then(function (valuelogs) {
					$scope.valuelogs = valuelogs;
          //修正相关数据(抄表日期)
          _.forEach(valuelogs, function (valuelog) {
            valuelog.readtime = new Date(valuelog.readtime);
          });
          //是否总表?
          var masterindex = Number($scope.roomId);
          if(!_.isNaN(masterindex)){
            $scope.subTitle = '总表'+(masterindex ? masterindex + 1 : '') +' - ' + product.name.replace('费', '表');
          }else{
  					//获取房间信息
  					$Room.getRoom($scope.roomId, fromServer).then(function (room) {
  						$scope.subTitle = room.code + ' - ' + product.name.replace('费', '表');
  						$scope.room = room;
  					});
          }
				});
			}).finally(function () {
				if (fromServer) {
					$scope.$broadcast('scroll.refreshComplete');
				}
			});
		};
		/***初始化数据***/
		//获取楼房未打印的租金单
		$scope.refreshData(false);

		//返回到缓存页面
		var firstrun = true;
		$scope.$on('$ionicView.enter', function (e) {
			//需要刷新列表?
			if (firstrun) {
				firstrun = false;
				return;
			}
			if (!firstrun) {
				$scope.refreshData();
			}
		});
	});
