angular.module('bagu.controllers')
  //抄表
  .controller('ValueLogsCtrl', function($scope, $stateParams, $ionicPopup, $http, $ionicHistory, $ionicLoading, $ionicPopover, $state, _,
    $Window, $Cache, $Date, $Room, $Product, $RoomValue) {

    /***保存参数***/
    $scope.buildingId = $stateParams.buildingId;
    $scope.productId = $stateParams.productId;

    //菜单定义
    var actions = [];
    var productsKeyName = 'products';

    /***显示Http返回错误***/
    function showHttpError(data, status, headers, config) {
      //只处理业务错误,权限错误由appctrl处理
      if (status === 400) {
        var msg = data.message || '加载数据出错,请稍后重试!';
        $Window.showAlert('抱歉', msg).then(function(res) {
          $ionicHistory.goBack();
        });
      }
    }

    //获取需要抄表的费用类别
    function getProductList(done) {
      $Product.getValueProducts().then(function(products) {
        //未设置需要抄表的项目,提示并返回
        if (!_.isArray(products) || products.length === 0) {
          return $Window.showAlert('提示', '未设置按量计费的项目,无需抄表!').then(function(res) {
            $ionicHistory.goBack();
          });
        }
        $scope.products = products;
        //更新菜单项
        actions = [];
        var radioitems = [];
        _.forEach(products, function(item) {
          radioitems.push({
            id: item._id,
            text: item.name.replace('费','表'),
            badge: 0,
            value: item
          });
        });
        if(radioitems.length){
          actions.push({
            id: productsKeyName,
            type: 'radio',
            options: radioitems,
            value: products[0],
            class: '',
            badgeclass: 'badge-assertive',
            click: function(data, target) {
              $scope.changeProduct(target.value);
            }
          });
        }
        //更新菜单项
        // actions = [];
        // _.forEach(products, function(item) {
        //   actions.push({
        //     id: item._id,
        //     text: item.name.replace('费','表'),
        //     badge: 0,
        //     class: '',
        //     badgeclass: 'badge-assertive',
        //     href: undefined,
        //     click: function(data) {
        //       $scope.changeProduct(item);
        //     }
        //   });
        // });
        //有设置过抄表产品?
        if (!$scope.product) {
          //参数有指定特定的抄表项目?
          if ($scope.productId) {
            $scope.product = _.find(products, function(item) {
              return item._id === $scope.productId;
            }) || products[0];
          } else {
            $scope.product = products[0];
            $scope.productId = $scope.product._id;
          }
          $scope.title = $scope.product.name.replace('费','表');
        }
        //更新统计
        var productIds = _.map(products, '_id');
        $RoomValue.getBuildingUnReadValueCount($scope.buildingId, productIds).then(function(pvalues) {
          _.forEach(pvalues, function(pcount, key) {
            var menuitem = _.find(actions, function(action) {
              return action.id === key;
            });
            if (menuitem) {
              menuitem.badge = pcount.count;
            }
          });
          //设置菜单项目
          $scope.setActionMenus(actions);
        });
        if (done) {
          done($scope.products);
        }
      });
    }

    //处理缓存记录,
    function processProducts(product, roomvalues) {
      // //获取缓存抄表数据
      // var valuelogcachedb = $RoomValue.getValueLogCacheDB();
      // if(valuelogcachedb && valuelogcachedb.opdata){
      //   var cacheValueLogs = _.filter(valuelogcachedb.opdata, function(item){
      //     return item.building === $scope.buildingId && item.product === $scope.productId;
      //   });
      //   _.forEach(roomvalues, function(item){
      //     item.cacheValue = undefined;
      //     var roomlog = _.findLast(cacheValueLogs, function(log){
      //       return log.room === item._id;
      //     });
      //     if(roomlog){
      //       item.cacheValue = roomlog.value;
      //     }
      //   });
      // }

      //整理数据方便显示(计算每层楼显示几行几列)
      $scope.roomlist = $Room.groupRooms($scope.buildingId, roomvalues);
    }

    //下拉更新抄表列表(从远程刷新产品数据和对应抄表数据)
    $scope.doRefreshSortRoomValues = function(isRefresh) {
      isRefresh = isRefresh || false;
      $RoomValue.getRoomValues($scope.buildingId, $scope.productId, isRefresh).then(function(roomvalues) {
          //处理抄表列表
          processProducts($scope.product, roomvalues);
        })
        .finally(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };

    //刷新数据，优先从缓存中读取数据，用于第一次进入页面，减少远程访问次数
    $scope.refreshView = function() {
      //当前抄表项目有变化?
      var curProduct = $RoomValue.getCurValueProduct();
      //从抄表页面返回?
      if(curProduct && curProduct !== $scope.productId){
        $scope.productId = curProduct;
        $scope.product = _.find($scope.products, function(item) {
          return item._id === $scope.productId;
        }) || $scope.products[0];
        $scope.title = $scope.product.name.replace('费','表');
      }
      $scope.doRefreshSortRoomValues(false);
      // //获取需要抄表的费用类别
      // getProductList(function() {
      //
      // });
    };

    //更改抄表项目
    $scope.changeProduct = function(product) {
      $scope.product = product;
      $scope.productId = product._id;
      $scope.title = product.name.replace('费','表');
      //刷新服务中记录的当前产品
      $RoomValue.setCurValueProduct($scope.productId);
      //刷新数据
      $scope.refreshView();
    };

    //显示缓存抄表记录
    $scope.getBackgroudClass = function(roomvalue) {
      if (roomvalue.cacheValue > roomvalue.value) {
        return 'hascachelog';
      } else if (roomvalue.value > roomvalue.lastvalue) {
        return 'hasvaluelog';
      }else if ($RoomValue.isUnReadValueRoom($scope.buildingId,roomvalue)) {
        return 'novaluelog';
      }
    };

    //显示缓存抄表记录
    $scope.showCacheValuelogs = function() {
      $state.go('app.cachevaluelogs');
    };

    //抄表
    $scope.doValueLog = function(roomvalue) {
      //是否总表?
      if(roomvalue._id === $scope.buildingId && _.isNumber(roomvalue.masterindex)){
        $state.go('app.valuelog',{
          buildingId: $scope.buildingId,
          productId: $scope.productId,
          roomId: roomvalue.masterindex,
        });
      }else{
        $state.go('app.valuelog',{
          buildingId: $scope.buildingId,
          productId: $scope.productId,
          roomId: roomvalue._id,
        });
      }
    };

    //获取数据
    getProductList(function() {
      //获取页面数据
      $scope.refreshView();
    });

    /***监听事件***/
    //退出时清理菜单对象
    $scope.$on('$destroy', function() {
      //$scope.moreMenu.remove();
    });

    //返回到缓存页面
    var firstrun = true;
    $scope.$on('$ionicView.beforeEnter', function(e) {
      //设置菜单项目
      $scope.setActionMenus(actions);
      if (firstrun) {
        firstrun = false;
      } else {
        //刷新数据
        $scope.refreshView();
      }
    });
  });
