angular.module('bagu')
  /******************
       静态常量定义
  *******************/
  //数据字典
  .constant('DATALIST', {
    //根据状态获取字符串的通用方法
    getEnumStr: function(enums, index) {
      var result = null;
      for (var name in enums) {
        if (enums[name] === index) {
          result = name;
          break;
        }
      }
      return result;
    },
    //用户来源
    COMM_USER_FROM: { //'0不指定,1APP；2WEB；3微信;4,桌面客户端',
      NORMAL: 0,
      APP: 1,
      WEB: 2,
      WECHAT: 3,
      DESKTOP: 4
    },
    //系统状态
    COMM_STATUS: { //'数据状态：-1删除；0正常；1锁定\N',
      DELETED: -1,
      NORMAL: 0,
      LOCK: 1
    },
    //房源配置
    COMM_DEPLOY: { //房源配置,可以整栋楼统一配置,亦可每间房单独配置
      '电梯': 1,
      '宽带': 2,
      '监控': 3,
      '有线': 4,
      '煤气': 5,
      '床': 7,
      '衣柜': 8,
      '空调': 13,
      '洗衣机': 10,
      '电视': 9,
      '冰箱': 11,
      '热水器': 12,
      '暖气': 6,
      '微波炉': 14
    },
    //短信类型
    SMS_CODE_TYPE: {
      REGISTER: '注册',
      WECHATBIND: '微信绑定',
      BANKBIND: '银行卡绑定',
      TAX: '租赁税账号绑定'
    },
    //租客拨号的反馈结果
    WECHAT_CALL_FEEBACK: {
      NULL: 0, //无反馈
      GOOD: 1, //很好,已预约看房
      LIKE: 2, //不错,收藏对比一下
      NOLIKE: 3, //不合适
      UNAVAILABLE: 4, //已出租
      INVALID: 5 //电话未接通
    },
    //提交房源的状态
    WECHAT_POSTROOMS_CHECKER_STATUS: {
      WAITING: 0, //待审核
      PASSED: 1, //审核通过
      SOMEPASSED: 2, //部分通过
      FAIL: 3 //审核不通过
    },
    //微信接口:房源搜索条件中生活配套
    WECHAT_SEARCH_AROUNDS: {
      '超市': 1,
      '幼儿园': 2,
      '菜市场': 3,
      '公园': 4,
      '地铁口': 5
    },
    //微信接口:房源搜索条件中房间配置组合
    WECHAT_SEARCH_DEPLOY: {
      '带家私': [7, 8],
      '带家电': [9, 10, 11, 12, 13, 14],
      '有宽带': 2,
      '有监控': 3,
      '电梯房': 1
    },

    //出租状态：0,自住; 1,未出租; 2,已预订; 3,已出租; 4,未收费; 5,快到期; 6,退房中; 100,未初始化;
    ROOM_STATUS: {
      OWN: 0, //自住
      EMPTY: 1, //未出租
      ORDER: 2, //已预订
      RENT: 3, //已出租
      NOFEE: 4, //未收费
      WILLEXPIRE: 5, //快到期
      BACKING: 6, //退房中
      NULL: 100, //未初始化
      enum: {
        0: '自住',
        1: '未出租',
        2: '已预订',
        3: '已出租',
        4: '未收费',
        5: '快到期',
        6: '退房中',
        100: '未设置'
      }
    },
    //房屋类型：0,单房; 1,一房一厅; 2,二房一厅; 3,三房一厅; 4,三房两厅; 5,其他;
    ROOM_TYPES: ['单房', '一房一厅', '二房一厅', '三房一厅', '三房两厅', '其他'],
    //房间对应的颜色样式名称,样式在style.css中定义
    ROOM_COLORS: {
			0: 'roomself',
			1: 'roomempty',
			2: 'roomorder',
			3: 'roomrent',
			4: 'roomfinance',
			5: 'roomexprie',
			6: 'roomback',
			100: 'roomnull'
		},
    //出租状态：0已预订；1已取消预订; 2已签合同；3即将退房；4已退房；5已转让；6已续签
    RENT_STATUS: {
      ORDER: 0, //已预订
      CANCELORDER: 1, //已取消预订
      RENT: 2, //已签合同
      WILLBACK: 3, //即将将退房
      BACK: 4, //已退房
      TRANSFER: 5, //已转让
      RERENT: 6 //已续签
    },
    //退房状体:0,不退房;1,预约退房;2,已退房;3,逃租
    RENT_BACK_STATUS: {
      NOBACK: 0, //不退房
      WILLBACK: 1, //预约退房
      BACK: 2, //已退房
      RUN: 3 //逃租
    },
    //租金类型.//类型: 0-签合同,1-月度,2-一次性收费,3-退费,4-其他
    INVOICE_TYPE: {
      RENT: 0,
      MONTHLY: 1,
      ONCE: 2,
      BACK: 3,
      OTHER: 4,
      enum: {
        '签合同': 0,
        '租金单': 1,
        '临时收费': 2,
        '退房': 3,
        '其他': 4
      }
    },
    //租金单状态.//收据状态: 0-创建,1-确认,2-打印,3-收费,4-作废,5-存档
    INVOICE_STATUS: {
      CREATE: 0,
      CONFIRM: 1,
      PRINT: 2,
      FINANCE: 3,
      DELETE: 4,
      ARCHIVE: 5,
      enum: {
        '已创建': 0,
        '已确认': 1,
        '已打印': 2,
        '已收费': 3,
        '已作废': 4,
        '已存档': 5
      }
    },
    //租金单明细类型:0:普通收费项目,1:临时收费项目(收租时),2押金项目,3:扣费项目(退租时)
    INVOICE_ITEM_TYPE: {
      NORMAL: 0,
      ADDITION: 1,
      PLEDGE: 2,
      DEDUCTION: 3
    },
    //订购记录状态: 0:已订购;1,已过期;2,已取消
    PRODUCT_RECORD_STATUS: {
      ORDER: 0,
      EXPIRED: 1,
      CANCEL: 2
    },
    //付款方式 '刷卡', '微信', '支付宝', '现金', '银行转账'
    FINANCE_PAYTYPE: {
      CASH: 0,
      WECHATPAY: 1,
      ALIPAY: 2,
      BANKCARD: 3,
      BANKTRANSFER: 4,
      enum: {
        '现金': 0,
        '微信': 1,
        '支付宝': 2,
        '刷卡': 3,
        '银行转账': 4
      },
      list: ['现金', '微信', '支付宝', '刷卡', '银行转账']
    },
    //计费方式，0,一次性，1，按月固定计费，2，按量计费，3，按量阶梯计费, 4,按房间面积计费, 5,按入住人数计费
    PRODUCT_FEETYPE: {
      ONCE: 0,
      MONTHLY: 1,
      AMOUNT: 2,
      STEP: 3,
      AREA: 4,
      PERSON: 5,
      enum: {
        '1:一次性': 0,
        '2:按月': 1,
        '3:按量': 2,
        '4:阶梯': 3,
        '5:面积': 4,
        '6:人数': 5
      },
      list: ['一次性', '按月固定计费', '按量计费', '按量阶梯计费', '按房间面积计费', '按入住人数计费']
    },
    ////产品时长，如：1Y代表一年，1M代表一个月，1D代表一天，0或''代表一次性消费
    PRODUCT_TIMELIMIT: {
      '1:一年': '1Y',
      '2:半年': '6M',
      '3:季度': '3M',
      '4:一月': '1M'
    },
    //打印状态:0:已创建,1:排队中,2:已打印,3:打印失败,4:拒绝打印
    PRINT_STATUS: {
      CREATE: 0,
      QUEUE: 1,
      SUCESS: 2,
      FAIL: 3,
      REJECT: 4
    },
    //用户楼房关联状态, 0:请求中;1,已关联
    USER_BUILDING_LINKED: {
      REQUEST: 0,
      LINKOK: 1
    },
    //地图类型:0,百度地图;1:高德地图;2:google地图
    SEARCH_MAPTYPE: {
      BAIDU: 0,
      GAODE: 1,
      GOOGLE: 2
    },
    //媒体状态:0,百度地图;1:高德地图;2:google地图
    MEDIA_STATUS: {
      MEDIA_NONE: 0,
      MEDIA_STARTING: 1,
      MEDIA_RUNNING: 2,
      MEDIA_PAUSED: 3,
      MEDIA_STOPPED: 4,
    }
  });
