angular.module('bagu.directive')
  .directive('stringToInt', function() {
    return {
      require: 'ngModel',
      link: function(scope, element, attrs, ngModel) {
        ngModel.$parsers.push(function(value) {
          return parseInt(value);
        });
        ngModel.$formatters.push(function(value) {
          return parseInt(value);
        });
      }
    };
  })
  //拥有输入焦点的对象,实现获取焦点选取全部内容
  //只需在HTML定义中,指定 select-On-Focus 属性
  .directive('selectOnFocus', function($timeout) {
    return {
      restrict: 'A',
      link: function(scope, element, attrs) {
        var focusedElement = null;

        element.on('focus', function() {
          var self = this;
          if (focusedElement !== self) {
            focusedElement = self;
            $timeout(function() {
              try {
                if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
                  self.setSelectionRange(0, self.value.length);
                } else {
                  self.select();
                }
              } catch (e) {
                //do nothing
              }
            }, 10, false);
          }
        });

        element.on('blur', function() {
          focusedElement = null;
        });
      }
    };
  });
