angular.module('bagu.directive')
  .directive('invoicePanel', function() {
    return {
      restrict: 'E',
      transclude: true,
      scope: {
        invoice: '=',
        showRoomCode: '=?showroomcode',
        canSelect: '=?canselect',
        canJump: '=?canjump',
        showButtons: '=?showbuttons',
        canHideDetails: '=?canhidedetails',
        showDetails: '=?showdetails'
      },
      link: function(scope, element, attrs, controller, transcludeFn) {
        scope.showRoomCode = angular.isDefined(scope.showRoomCode) ? scope.showRoomCode : false;
        scope.canSelect = angular.isDefined(scope.canSelect) ? scope.canSelect : false;
        scope.canJump = angular.isDefined(scope.canJump) ? scope.canJump : true;
        scope.showButtons = angular.isDefined(scope.showButtons) ? scope.showButtons : true;
        scope.canHideDetails = angular.isDefined(scope.canHideDetails) ? scope.canHideDetails : false;
        scope.showDetails = angular.isDefined(scope.showDetails) && !angular.isString(scope.showDetails) ? scope.showDetails : 'auto';
        scope.isShowDetails = scope.showDetails;        scope.onJump = function(){
          if(attrs.onjump){
            scope.$eval(attrs.onjump);
          }
        };
      },
      controller: ['$ionicPopup', '$ionicLoading', '$scope', '$state', '$Window', '$Sms', '$Print', '$Invoice', '$RoomValue', 'DATALIST', '_',
        function($ionicPopup, $ionicLoading, $scope, $state, $Window, $Sms, $Print, $Invoice, $RoomValue, DATALIST, _) {

      		//数据字典
      		$scope.DATALIST = DATALIST;
      		//是否一次性计费项目
      		$scope.isOnceFeeItem = $Invoice.isOnceFeeItem;
      		//是否按月计费项目
      		$scope.isMonthlyFeeItem = $Invoice.isMonthlyFeeItem;
      		//是否按量计费项目
      		$scope.isAmountFeeItem = $Invoice.isAmountFeeItem;
      		//是否按面积计费项目
      		$scope.isAreaFeeItem = $Invoice.isAreaFeeItem;
      		//是否按人数计费项目
      		$scope.isPersonFeeItem = $Invoice.isPersonFeeItem;
      		//是否收取押金项目?
      		$scope.isPledgeInvoiceItem = $Invoice.isPledgeInvoiceItem;
      		//是否未收费单据?
      		$scope.isUnFinanceInvoice = $Invoice.isUnFinanceInvoice;
      		//是否已收费单据?
      		$scope.isFinanceInvoice = $Invoice.isFinanceInvoice;
      		//是否已收费单据?
      		$scope.isDeleteInvoice = $Invoice.isDeleteInvoice;

          //是否逾期为交租?
          $scope.isWarning = function(invoice){
            return invoice.guessPayDate && invoice.guessPayDate < new Date();
          };

          //编辑出租单
          $scope.doRoomRent = function(invoice) {
            if(!$scope.canJump){
              return;
            }
            $scope.onJump();
            $state.go('app.rent', {
              roomId: invoice.room,
              invoiceId: invoice._id
            });
          };

          //头部点击事件,如果显示了选择框,则设置选择状态
          $scope.doHeadClick = function(invoice) {
            if ($scope.canSelect) {
              invoice.select = !invoice.select;
            } else if ($scope.canHideDetails && $scope.showDetails) {
              $scope.isShowDetails = !$scope.isShowDetails;
            } else {
              $scope.doRoomRent(invoice);
            }
          };

          //发送单个催缴短信
          $scope.doSendSms = function(invoice) {
            $Sms.sendInvoiceSms(invoice.building, invoice._id).then(function() {
              $Window.showAlert('恭喜', invoice.code + '房催缴短信已发送!');
            }, function(err) {
              $Window.showAlert('失败', err.message || err);
            });
          };
          //打印单个租金单
          $scope.doPrintInvoice = function(invoice) {
            //写入租金单数据
            $Print.clearPrintData();
            $Print.addInvoiceData([invoice]);
            $state.go('app.printer');
          };
          //设置单个租金单为已收费状态
          $scope.doSetFee = function(invoice) {
            $scope.feedata.money = invoice.money;
            var myPopup = $ionicPopup.show({
              template: ' \
            <div class="row"> <div class="col">应收金额:</div><div class="col col-50">{{::feedata.money}}元</div> </div>\
            <div class="row"> <div class="col">收费方式:</div> <div class="col"></div></div>\
            <div > \
              <div class="button-bar"> \
                <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 0}" ng-click="feedata.feetype = 0">{{feedata.financeType[0]}}</a> \
                <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 1}" ng-click="feedata.feetype = 1">{{feedata.financeType[1]}}</a> \
                <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 2}" ng-click="feedata.feetype = 2">{{feedata.financeType[2]}}</a> \
              </div> \
              <div class="button-bar"> \
                <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 3}" ng-click="feedata.feetype = 3">{{feedata.financeType[3]}}</a> \
                <a class="button" ng-class="{\'button-balanced\': feedata.feetype === 4}" ng-click="feedata.feetype = 4">{{feedata.financeType[4]}}</a> \
              </div> \
            </div>',
              title: '确认收费',
              subTitle: '请仔细核对租金单费用,并选择收费方式',
              scope: $scope,
              buttons: [{
                text: '取消'
              }, {
                text: '<b>确认</b>',
                type: 'button-positive',
                onTap: function(e) {
                  return true;
                }
              }]
            });
            myPopup.then(function(res) {
              //console.log('Tapped!', res);
              myPopup.close();
              if (res) {
                var noprint = invoice.invoicestatus < DATALIST.INVOICE_STATUS.PRINT;
                //设置收费状态
                $Window.showLoading();
                $Invoice.updateInvoiceHasFee(invoice, $scope.feedata).then(function(response) { //获取楼房未打印的租金单
                  var buildingId = invoice.building && invoice.building._id ? invoice.building._id : invoice.building;
                  var roomId = invoice.room && invoice.room._id ? invoice.room._id : invoice.room;
                  if (buildingId && roomId) {
                    $RoomValue.updateRoomValue(buildingId, roomId).then(function(roomvalues) {});
                  }
                  //$scope.refreshData(false);
                  $Window.hideLoading();
                  //如果之前未打印单据,则提示是否打印单据,否则显示收费完成提示
                  if (noprint) {
                    $Window.showConfirm('恭喜', '收费完成,是否打印单据?').then(function(ok) {
                      if (ok) {
                        $scope.doPrintInvoice(invoice);
                      }
                    });
                  } else {
                    $Window.showAlert('恭喜', '收费完成!');
                  }
                })
                .finally(function(){
                  $Window.hideLoading();
                });
              }
            });
          };

          //作废单据
          $scope.doDeleteInvoice = function(invoice) {
            $Window.showConfirm('警告', '是否确认作废该单据?').then(function(isok) {
              if (isok) {
                $Invoice.deleteInvoice(invoice).then(function(response) {
                  //刷新显示列表
                  invoice.invoicestatus = response.invoicestatus;
                  //刷新按量计费项目的最后抄表记录(表底数)
                  $RoomValue.updateRoomValue(invoice.building, invoice.room).then(function(roomvalues) {});
                  //调用onDelete方法
                  if ($scope.onDelete && _.isFunction($scope.onDelete)) {
                    $scope.onDelete(invoice);
                  }
                  $Window.showAlert('恭喜', '作废单据完成!');
                }, function(err) {
                  $Window.showAlert('失败', err.message || err);
                });
              }
            });
          };

          //作废单据
          $scope.doRemoveInvoice = function(invoice) {
            $Window.showConfirm('警告', '彻底删除的单据将不再显示,确认删除?').then(function(isok) {
              if (isok) {
                $Invoice.removeInvoice(invoice).then(function(response) {
                  //调用onRemove方法
                  if ($scope.onRemove && _.isFunction($scope.onRemove)) {
                    $scope.onRemove(invoice);
                  }
                  $Window.showAlert('恭喜', '单据删除成功!');
                  // _.remove($scope.invoices, function(item){
                  //   return invoice === item;
                  // });
                }, function(err) {
                  $Window.showAlert('失败', err.message || err);
                });
              }
            });
          };

          //默认现金收费
          $scope.feedata = {
            feetype: DATALIST.FINANCE_PAYTYPE.CASH,
            financeType: {
              0: '现金',
              1: '微信',
              2: '刷卡',
              3: '支付宝',
              4: '银行转账'
            }
          };
        }
      ],
      templateUrl: 'templates/directive/panel.invoice.directive.html'
    };
  });
