angular.module('bagu')
  .provider('$Str', function() {
    return {
      $get: function(_) {
        //左侧补齐
  			function padLeft(str, length) {
  				if (str.length < length) {
  					str = '0' + str;
  					return padLeft(str, length);
  				} else {
  					return str;
  				}
  			}
        //获取右侧数字的位置(包含开始和结束的位置)
  			function getRightNumberIndex(str) {
  				var result = {
            start: 0, //开始位置
            end: 0, //结束位置
            count: 0 //字符个数
          },start = false;
  				for (var i = str.length - 1; i >= 0; i--) {
  					var code = str.charCodeAt(i);
  					if (code >= 48 || code <= 57) {
              if(!start){
                result.end = i;
                result.count = 1;
                start = true;
              }else{
                result.start = i;
                result.count++;
              }
  						continue;
  					} else if(!start){
              continue;
            } else {
  						//result = i;
  						break;
  					}
  				}
  				return result;
  			}
        //获取右侧数据,默认返回0
  			function getRightNumber(str) {
          var numbindex = getRightNumberIndex(str);
  				return str.substr(numbindex.start,numbindex.count);
  			}
        //右侧数字自增
  			function incRightNumber(str) {
          var numbindex = getRightNumberIndex(str);
  				var index = numbindex.start;
  				var rNum = getRightNumber(str);
  				var num = Number(rNum);
          //如果末端有字符,则采用parseInt()方式转换
          if(_.isNaN(num)){
            num = parseInt(rNum);
          }
          //如果无法转换,则默认为0
          if(_.isNaN(num)){
            num = 0;
          }
  				num++;
          //返回
          var result = '';
          if(numbindex.start !== 0){
            result += str.substr(0, index - 1);
          }
          result += padLeft(num.toString(), rNum.length);
          if(numbindex.end !== str.length - 1){
            result += str.substr(numbindex.end +1);
          }
  				return result;
  			}
        //获取房间号,如605=>5,1202=>2
        function getCodeNum(str){
          var rNum = getRightNumber(str);
          var num = Number(rNum);
          //如果末端有字符,则采用parseInt()方式转换
          if(_.isNaN(num)){
            num = parseInt(rNum);
          }
          //如果无法转换,则默认为0
          if(_.isNaN(num)){
            num = 0;
          }
  				return num % 100;
        }

        return {
          padLeft: padLeft,
          getRightNumberIndex: getRightNumberIndex,
          getRightNumber: getRightNumber,
          incRightNumber: incRightNumber,
          getCodeNum: getCodeNum
        };
      }
    };
  });
