// 路由模块
angular.module('bagu')
//路由配置
.config(function($stateProvider, $urlRouterProvider, LOCAL) {
  $stateProvider
  .state('login', {
    url: '/login',
    templateUrl: 'templates/login.html',
    controller: 'LoginCtrl'
  })
  .state('register', {
    url: '/register',
    templateUrl: 'templates/register.html',
    controller: 'RegisterCtrl'
  })
  // .state('map', {
  //   url: '/map',
  //   templateUrl: 'templates/map.baidu.html',
  //   controller: 'BaiduMapCtrl'
  // })
  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })
  //服务中心
  .state('app.services', {
    url: '/services',
    views: {
      'menuContent': {
        templateUrl: 'templates/services.html',
        controller: 'ServicesCtrl'
      }
    }
  })
  //系统设置
  .state('app.settings', {
    url: '/settings',
    views: {
      'menuContent': {
        templateUrl: 'templates/settings.html',
        controller: 'SettingsCtrl'
      }
    }
  })
  //打印
  .state('app.printer', {
    url: '/printer',
    views: {
      'menuContent': {
        templateUrl: 'templates/printer.html',
        controller: 'PrinterCtrl'
      }
    }
  })
  //区域列表(如果区域小有楼房,则一同显示)
  .state('app.netareas', {
    url: '/netareas',
    views: {
      'menuContent': {
        templateUrl: 'templates/netareas.html',
        controller: 'NetAreasCtrl'
      }
    }
  })
  //子区域列表(如果区域小有楼房,则一同显示)
  .state('app.subnetareas', {
    url: '/netareas/:netareaId/:netareaName',
    views: {
      'menuContent': {
        templateUrl: 'templates/netareas.html',
        controller: 'NetAreasCtrl'
      }
    }
  })
  //楼房列表(显示有权限的楼房列表)
  .state('app.buildings', {
    url: '/buildings',
    views: {
      'menuContent': {
        templateUrl: 'templates/buildings.html',
        controller: 'BuildingsCtrl'
      }
    }
  })
  //楼房管理
  .state('app.building', {
    url: '/building/:buildingId',
    views: {
      'menuContent': {
        templateUrl: 'templates/building.html',
        controller: 'BuildingCtrl'
      }
    }
  })
  //批量初始化出租信息
  .state('app.initbuilding', {
    //abstract: true,
    url: '/building/:buildingId/init',
    views: {
      'menuContent': {
        templateUrl: 'templates/init.building.html',
        controller: 'BuildingInitCtrl'
      }
    }
  })
  //批量抄表管理
  .state('app.valuelogs', {
    url: '/valuelogs/:buildingId/:productId',
    views: {
      'menuContent': {
        templateUrl: 'templates/valuelogs.html',
        controller: 'ValueLogsCtrl'
      }
    }
  })
  //缓存中的抄表记录
  .state('app.cachevaluelogs', {
    url: '/cachevaluelogs',
    views: {
      'menuContent': {
        templateUrl: 'templates/cachevaluelogs.html',
        controller: 'CacheValueLogsCtrl'
      }
    }
  })
  //房间的某个费用的抄表历史
  .state('app.valueloghistorys', {
    url: '/valueloghistorys/:buildingId/:roomId/:productId',
    views: {
      'menuContent': {
        templateUrl: 'templates/valueloghistorys.html',
        controller: 'ValueLogHistorysCtrl'
      }
    }
  })
  //批量收租
  .state('app.batchrent', {
    url: '/batchrent/:buildingId',
    views: {
      'menuContent': {
        templateUrl: 'templates/batchrent.html',
        controller: 'BatchRentCtrl'
      }
    }
  })
  //房间收租
  .state('app.rent', {
    //abstract: true,
    url: '/rent/:roomId/:invoiceId',
    views: {
      'menuContent': {
        templateUrl: 'templates/rent.room.html',
        controller: 'RoomRentCtrl'
      }
    }
  })
  //批量打单
  .state('app.batchprint', {
    url: '/batchprint/:buildingId',
    views: {
      'menuContent': {
        templateUrl: 'templates/batchprint.html',
        controller: 'BatchPrintCtrl'
      }
    }
  })
  //单个抄表
  .state('app.valuelog', {
    url: '/valuelog/:buildingId/:roomId/:productId',
    views: {
      'menuContent': {
        templateUrl: 'templates/valuelog.html',
        controller: 'ValueLogCtrl'
      }
    }
  })
  //房间信息
  .state('app.room', {
    //abstract: true,
    url: '/room/:roomId',
    views: {
      'menuContent': {
        templateUrl: 'templates/room.html',
        controller: 'RoomCtrl'
      }
    }
  })
  //初始化出租信息
  .state('app.initroom', {
    //abstract: true,
    url: '/room/:roomId/init',
    views: {
      'menuContent': {
        templateUrl: 'templates/room.init.html',
        controller: 'RoomInitCtrl'
      }
    }
  })
  //房间退房
  .state('app.backroom', {
    //abstract: true,
    url: '/room/:roomId/back/:isRunBack',
    views: {
      'menuContent': {
        templateUrl: 'templates/back.room.html',
        controller: 'RoomBackCtrl'
      }
    }
  })
  //房间费用历史
  .state('app.invoices', {
    //abstract: true,
    url: '/room/:roomId/invoices',
    views: {
      'menuContent': {
        templateUrl: 'templates/history.invoice.room.html',
        controller: 'InvoiceHistoryCtrl'
      }
    }
  })
  //房间出租
  .state('app.contract', {
    //abstract: true,
    url: '/contract/:roomId',
    views: {
      'menuContent': {
        templateUrl: 'templates/room.contract.html',
        controller: 'RoomContractCtrl'
      }
    }
  })
  //财务统计(楼房按月)
  .state('app.analysis', {
    //abstract: true,
    url: '/analysis/:buildingId/:year/:month',
    views: {
      'menuContent': {
        templateUrl: 'templates/monthly.analysis.html',
        controller: 'AnalysisMonthlyCtrl'
      }
    }
  })
  //群发短信
  .state('app.batchsms', {
    url: '/batchsms/:buildingId',
    views: {
      'menuContent': {
        templateUrl: 'templates/batchsms.html',
        controller: 'BatchSmsCtrl'
      }
    }
  })
  .state('app.roomchoose', {
    url: '/roomchoose/:buildingId',
    views: {
      'menuContent': {
        templateUrl: 'templates/roomchoose.html',
        controller: 'RoomChooseCtrl'
      }
    }
  })
  .state('app.batchsmshistory', {
    url: '/batchsmshistory',
    views: {
      'menuContent': {
        templateUrl: 'templates/batchsmshistory.html',
        controller: 'BatchSmsHistoryCtrl'
      }
    }
  })
  .state('app.roomorder',{
    url:'/roomorder/:roomId',
    views: {
      'menuContent': {
        templateUrl: 'templates/roomorder.html',
        controller: 'RoomOrderCtrl'
      }
    }
  }).state('app.contractdetail',{
    url:'/contractdetail/:roomId',
    views: {
      'menuContent': {
        templateUrl: 'templates/contractdetail.html',
        controller: 'ContractDetailCtrl'
      }
    }
  }).state('app.providers',{
    url:'/providers',
    views: {
      'menuContent': {
        templateUrl: 'templates/providers.html',
        controller: 'ProvidersCtrl'
      }
    }
  });

  //有登陆? 默认打开地区列表页
  var token = window.localStorage.getItem(LOCAL.TOKEN_KEY);
  if(token){
    //$urlRouterProvider.when('', '/netareas');
    $urlRouterProvider.otherwise('/app/buildings');
  }else{
    //$urlRouterProvider.when('', '/login');
    $urlRouterProvider.otherwise('/register');
  }

})
.config(function($provide) {
  //增加IonicHistory的扩展方法:
  $provide.decorator('$ionicHistory', function($delegate) {
    //  goBackByState(statename,statename1,statename2,...)方法,
    //  返回指定状态的历史,按照参数给定的顺序匹配,,如果找不到状态,则返回上一页
    $delegate.goBackByState = function() {
      var me = this;
      var curview = me.currentView(),
          backview = null;
      var historyId = curview.historyId;
      //histories->stack
      var stack = me.viewHistory().histories[historyId].stack;
      if(stack && angular.isArray(stack)){
        //遍历参数
        if(!backview){ //angular forEach 不支持return false 退出循环
          angular.forEach(arguments,function(statename){
            //遍历历史堆栈
            angular.forEach(stack,function(item){
              if(!backview && item && item.stateName === statename){
                backview = item;
                return false;
              }
            });
          });
        }
      }
      //是否找到正确的返回视图?否则默认返回上一页
      if(!backview){
        return me.goBack();
      }else{
        return me.goBack(backview.index - curview.index);
      }
    };

    // goBackJumpState(jumpstates,done)方法,
    // jumpstates:需要跳过的状态,字符串或字符串数组
    // done:回调方法,接受backview参数
    // 返回指定状态的历史,跳过参数给定的状态
    $delegate.goBackJumpState = function(jumpstates,done) {
      var me = this;
      var curview = me.currentView(),
          backview = null,
          jump = false;
      var historyId = curview.historyId;
      var item,statename;
      //histories->stack
      var stack = me.viewHistory().histories[historyId].stack;
      if(stack && angular.isArray(stack)){
        for (var i = 0, ilen = stack.length; i < ilen; i++) {
          item = stack[i];
          for (var j = 0, jlen = jumpstates.length; j < jlen; j++) {
            statename = jumpstates[j];
            if (item && item.stateName === statename) {
              jump = true;
              break;
            }
          }
          if(jump){
            //重置状态,继续检查下一个状态
            jump = false;
            continue;
          }else{
            backview = item;
            break;
          }
        }
      }
      //跳过全部视图?默认返回buildings页面
      if(backview){
        return me.goBack(backview.index - curview.index);
      }
      //回调方法
      if(angular.isFunction(done)){
        return done(backview);
      }
    };


    return $delegate;
  });
});
