angular.module('bagu')
  /********
  本地设置缓存,格式:{"key":value,...}
  未来需要增加本地设置保存到服务器功能,以便多个同一个账号在多个客户端共享设置
  ********/
  .service('$Local', function($Cache, SERVER_SETTINGS) {
    /****对象定义****/
    //表名
    var TABLENAME = 'local';
    //数据实体对象
    var DATA = null;
    //服务对象
    var service = {};

    /****工具函数****/
    //获取缓存数据
    function loadCacheData() {
      //缓存对象的引用
      DATA = $Cache.get(TABLENAME, function(cachetable) {
        DATA = $Cache.get(TABLENAME) || {};
      });
      if(DATA && DATA.CUR_SERVER){
        SERVER_SETTINGS.CUR_SERVER = DATA.CUR_SERVER;
      }
      return DATA;
    }
    //保存数据到缓存
    function save2Cache() {
      //保存结果到缓存
      $Cache.saveTable(TABLENAME);
    }

    /****服务方法****/
    //获取本地缓存对象
    service.get = function(){
      //加载缓存
      if (!DATA) {
        loadCacheData();
      }
      return DATA;
    };
    //保存到本地缓存
    service.save = function(){
      save2Cache();
    };

    //加载缓存
    if (!DATA) {
      loadCacheData();
    }

    return service;
  });
