angular.module('bagu')

.service('$Print', function ($q, $http, $ionicPlatform, $timeout, $Cache, $Date, $cordovaBluetoothSerial, $cordovaBLE, _, $Mustache,
	CHARSET, POSTMPL, $Local, DATALIST,
	$Building, $Room, $Invoice
) {
	/****变量定义****/
	//打印机表名
	var TABLENAME = 'printers';
	//字符编码缓存
	var TABLENAME_CHARSET = 'charset';
	//数据实体对象
	var DATA = null,
		CHARSET_DATA = null;

	/****工具函数****/
	//获取字符编码缓存数据
	function loadCharSetCacheData() {
		CHARSET_DATA = $Cache.get(TABLENAME_CHARSET, function (cachetable) {
			CHARSET_DATA = $Cache.get(TABLENAME_CHARSET);
		});
		return CHARSET_DATA;
	}

	function charsetCacheData() {
		if (!CHARSET_DATA) {
			loadCharSetCacheData();
		}
		return CHARSET_DATA;
	}
	//保存数据到字符编码缓存
	function saveCharSet2Cache() {
		//保存结果到缓存
		$Cache.saveTable(TABLENAME_CHARSET);
	}

	//加载缓存数据
	function loadCacheData() {
		//缓存对象的引用
		DATA = $Cache.get(TABLENAME, function (cachetable) {
			DATA = $Cache.get(TABLENAME);
		});
		return DATA;
	}

	//获取缓存数据
	function cacheData() {
		if (!DATA) {
			loadCacheData();
		}
		return DATA;
	}

	//保存数据到缓存
	function save2Cache() {
		//保存结果到缓存
		$Cache.saveTable(TABLENAME);
	}
	//清除缓存数据
	function clearCache() {
		DATA = $Cache.clearTable(TABLENAME);
		//保存结果到缓存
		$Cache.saveTable(TABLENAME);
		return DATA;
	}
	//打印内容输出为Int10
	function str2ab(str) {
	  var buf = new ArrayBuffer(str.length*2); // 2 bytes for each char
	  var bufView = new Uint16Array(buf);
	  for (var i=0, strLen=str.length; i<strLen; i++) {
	    bufView[i] = str.charCodeAt(i);
	  }
	  return buf;
	}


	//保存数据到缓存,将_id转换成属性名称,方便后面使用
	function savePrinters2Cache(printers, isBluetoothPrinter) {
		isBluetoothPrinter = isBluetoothPrinter || false;
		if (printers) {
			//更新或新增打印机到缓存
			_.forEach(printers, function (printer) {
				//蓝牙打印机使用id作为key
				var id = printer._id ? printer._id : printer.id;
				printer.isBluetoothPrinter = isBluetoothPrinter;
				var cacheprinter = _.find(DATA, function (item) {
					return (!item.isBluetoothPrinter || item.isBluetoothPrinter === isBluetoothPrinter) && item.id === printer.id;
				});
				if (cacheprinter) {
					cacheprinter = _.assign(cacheprinter, printer);
				} else {
					DATA[id] = printer;
				}
			});
			//写入缓存
			save2Cache();
		}
	}
	//保存数据到缓存,将_id转换成属性名称,方便后面使用
	function saveCloudPrinters2Cache(printers) {
		return savePrinters2Cache(printers, false);
	}
	//保存数据到缓存,将_id转换成属性名称,方便后面使用
	function saveBluetoothPrinters2Cache(printers) {
		return savePrinters2Cache(printers, true);
	}
	//将字符串由unicode编码转换为Gb2312编码
	function str2Gb2312(str) {
		//读取缓存
		var db = charsetCacheData();
		var hasnewcharset = false;

		var buf = new ArrayBuffer(str.length * 2);
		var buf8 = new Uint8Array(buf);
		var buf16 = null,
			charbuf = null;
		var index = 0;
		for (var i = 0, strLen = str.length; i < strLen; i++) {
			var code = str.charCodeAt(i);
			//属于Ascii字符?
			if (code <= 255) {
				buf8[index] = code;
				index++;
			} else {
				//只能取双数地址
				if (index % 2 !== 0) {
					index++;
				}
				buf16 = new Uint16Array(buf, index, 1); //只能取双数地址
				//缓存中存在?
				if (db[code] && _.isNumber(db[code])) {
					buf16[0] = db[code];
				} else {
					buf16[0] = CHARSET.getGb2312Code(CHARSET.GB2312, code);
					db[code] = buf16[0];
					hasnewcharset = true;
				}
				index += 2;
			}
		}
		//更新缓存?
		if (hasnewcharset) {
			saveCharSet2Cache();
		}
		return new Uint8Array(buf, 0, index);
	}

	//打印数据
	//'invoice','preorder','pledge','contract'
	var _data = {
		//租金单
		invoices: [],
		//定金单
		preorders: [],
		//押金单
		pledges: [],
		//合同
		contracts: [],
		//财务统计
		analysises: []
	};
	//打印机列表
	var printers = [];
	//选择的打印机
	var selectprinter = null;
	//IOS下受支持的蓝牙打印机service和characteristic定义
	var IOS_SURPORT_PRINTER = {
		printers: [ //受支持的蓝牙打印机
			{ //佳博
				names: [/GPrinter*/g, 'GPrinter_F9CF'],
				service: 'E7810A71-73AE-499D-8C15-FAA9AEF0C3F2',
				characteristic: 'BEF8D6C9-9C21-4C9E-B632-BD58C1009F9F'
			},
			{ //MPT
				names: [/MPT*/g, 'MPT-II-4'],
				service: 'E7810A71-73AE-499D-8C15-FAA9AEF0C3F2',
				characteristic: 'BEF8D6C9-9C21-4C9E-B632-BD58C1009F9F'
			}
		],
		//获取service和characteristic配对属性
		getSc: function (printerName, characteristics) {
			var result = null;
			//判断蓝牙服务列表
			if (!_.isArray(characteristics) || characteristics.length === 0) {
				return result;
			}
			//依据名字获取
			result = _.find(this.printers, function (printer) {
				var finded = false;
				_.forEach(printer.names, function (pname) {
					//是否正则表达式
					if (pname instanceof RegExp) {
						finded = pname.test(printerName);
					} else if (_.isString(pname)) {
						finded = printerName.toLowerCase() === pname.toLowerCase();
					}
					//如果找打则直接返回false,跳出forEach
					return !finded;
				});
				return finded;
			});
			if(!result){
				//匹配service和characteristic的值
				result = _.find(characteristics, function (scitem) {
					var finded = false;
					_.forEach(this.printers, function (defineitem) {
						finded = scitem && scitem.service &&  defineitem.service && scitem.service.toLowerCase() === defineitem.service.toLowerCase();
						//如果找打则直接返回false,跳出forEach
						return !finded;
					});
					return finded;
				});
			}
			if(!result){
				//如果仍然未找到,则取properties属性最多的characteristic
				var sorteCharacteristics = _.sortBy(characteristics, function(scitem){
					return scitem.properties && _.isArray(scitem.properties) ? scitem.properties.length * -1 : 0 ;
				});
				result = sorteCharacteristics[0];
			}
			return result;
		}
	};

	//修正为统一标准的printer对象
	var fixPrinter = function (printer, isBluetooth) {
		if(!_.isBoolean(isBluetooth)){
			isBluetooth = false;
		}
		printer.isBluetoothPrinter = isBluetooth;
		if (!printer.address) {
			printer.address = printer.id || printer.uuid;
		}
		if(selectprinter && printer.address && printer.address === selectprinter.address){
			printer.selected = true;
		}
	};
	//蓝牙打印机模块,封装Android和Ios的差异
	var $BlePrinter = {};
	if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
		$BlePrinter = {
			list: function (timeout) {
				timeout = timeout || 15;
				var q = $q.defer();
				var printers = [];
				$cordovaBLE.scan([], timeout).then(function (ok) {
					q.resolve(printers);
				}, function (err) {
					q.reject(err);
				}, function (printer) {
					q.notify(printer);
					printers.push(printer);
				});
				return q.promise;
			},
			isEnabled: $cordovaBLE.isEnabled,
			enable: $cordovaBLE.enable,
			isConnected: function () {
				return $cordovaBLE.isConnected(this.address);
			},
			disconnect: function () {
				return $cordovaBLE.disconnect(this.address);
			},
			connect: function (printer,timeout) {
				var q = $q.defer();
				var me = this;
				var address = printer.address || printer.id || printer;
				var isTimeOut = false;
				timeout = timeout || 10000;
				//ios需要判断:10秒未连接成功,则算超时
				var timer = $timeout(function () {
					if(timer){
						$timeout.cancel( timer );
					}
					return q.reject('连接超时!');
				}, timeout);

				$cordovaBLE.connect(address).then(function (result) {
					me.address = address;
					var iosPrinterService = IOS_SURPORT_PRINTER.getSc(printer.name, result.characteristics);
					if (!iosPrinterService) {
						// TODO:
						//如果本地配置中没有,则从服务器获取
						if(!isTimeOut){
							return q.reject('不支持该型号打印机!');
						}
					} else {
						me.service = iosPrinterService.service;
						me.characteristic = iosPrinterService.characteristic;
						if(!isTimeOut){
							return q.resolve(result);
						}
					}
				}, function (error) {
					if(!isTimeOut){
						return q.reject(error);
					}
				})
				.finally(function(){
					if(timer){
						$timeout.cancel( timer );
					}
				});
				return q.promise;
			},
			write: function (data) {
				var q = $q.defer();
				var me = this;
				//console.log(data);
				$cordovaBLE.writeWithoutResponse(me.address, me.service, me.characteristic, data.buffer).then(function (result) {
					q.resolve(result);
				}, function (error) {
					q.reject(error);
				});
				return q.promise;
			},
		};
	}else{
		//$cordovaBluetoothSerial
		$BlePrinter = {
			list: function (unpaired) {
				var q = $q.defer();
				var allPrinters = [];
				//判断是否蓝牙打印机(class:1664)
				function isPrinter(device){
					console.log(device);
					if(device && device.class ){
						//不同蓝牙打印机的class非常不标准,取消校验
						return 1 === 1 || (device.class & 1664) === 1664 || device.class === 7936;
					}else{
						return false;
					}
				}
				//第一步,获取已配对的蓝牙设备
				$cordovaBluetoothSerial.list().then(function (printers) {
					_.forEach(printers, function (printer) {
						if(isPrinter(printer)){
							allPrinters.push(printer);
							fixPrinter(printer, true);
							q.notify(printer);
						}
					});
					if(unpaired){
						//第二步,设置监听
						$cordovaBluetoothSerial.setDeviceDiscoveredListener().then(null,null,function (printer) {
							if(isPrinter(printer)){
								allPrinters.push(printer);
								fixPrinter(printer, true);
								q.notify(printer);
							}
						});
						//第二步,搜索未配对蓝牙设备
						$cordovaBluetoothSerial.discoverUnpaired().then(function (printers) {
							_.forEach(printers, function (printer) {
								if(isPrinter(printer)){
									fixPrinter(printer, true);
									//已经配对的设备?
									var discovered = _.find(allPrinters, function(item){
										return item.address === printer.address;
									});
									if(!discovered){
										allPrinters.push(printer);
										q.notify(printer);
									}else{
										_.assign( discovered, printer );
									}
								}
							});
							q.resolve(allPrinters);
						}, function (err) {
							q.reject(err);
						}).finally(function () {
							//取消监听
							$cordovaBluetoothSerial.clearDeviceDiscoveredListener();
						});
					}else{
						q.resolve(allPrinters);
					}
				}, function (err) {
					q.reject(err);
				});
				return q.promise;
			},
			isEnabled: $cordovaBluetoothSerial.isEnabled,
			enable: $cordovaBluetoothSerial.enable,
			isConnected: $cordovaBluetoothSerial.isConnected,
			disconnect: $cordovaBluetoothSerial.disconnect,
			connect: function (printer) {
				var address = printer.address || printer.id || printer;
				return $cordovaBluetoothSerial.connect(address);
			},
			write: $cordovaBluetoothSerial.write
		};
	}
	//按顺序输出打印内容
	function write2Printer(printdatas){
		var q = $q.defer();
		function write(datas){
			var line = datas[0];
			$BlePrinter.write(str2Gb2312(line)).then(function(){
				if(datas.length <= 1){
					q.resolve(printdatas);
				}else{
					q.notify(line);
					write(datas.slice(1));
				}
			},function(err){
				q.reject(err);
			});
		}
		write(printdatas);
		return q.promise;
	}

	//增加打印数据
	function addData2List(list, datas) {
		if (!_.isArray(datas)) {
			datas = [datas];
		}
		_.forEach(datas, function (item) {
			list.push(item);
		});
	}

	//获取缓存中的打印设置
	var getLocalSetting = function(){
		//获取缓存设置
		var localData = $Local.get();
		localData.PRINTER = localData.PRINTER || {};
		localData.PRINTER.invoice = localData.PRINTER.invoice || {
			customer: true, //租客联
			owner: false //房东联
		};
		localData.PRINTER.analysis = localData.PRINTER.analysis || {
			opration: true, //状态统计(新租,退房,调租)
			product: true, //收费项目统计
			paytype: true, //付款方式统计
			basedetail: true,  //租金单(简单)
			detail: false  //租金单(详细)
		};
		return localData.PRINTER;
	};

	//保存打印设置到缓存
	var saveLocalSetting = function(){
		return $Local.save();
	};

	/******** 蓝牙方法 ************/
	//搜索蓝牙
	var listBluetoothPrinter = function (unpaired) {
		var q = $q.defer();
		console.log('scan bluetoothprinter');
		$BlePrinter.list(unpaired).then(function (printers) {
				//console.log(printers);
				saveBluetoothPrinters2Cache(printers);
				q.resolve(printers);
			},
			function (err) {
				q.reject(err);
			},
			function (printer) {
				//如果是当前选择蓝牙打印机,则忽略
				if(!selectprinter || selectprinter.address !== printer.address){
					fixPrinter(printer, true);
					q.notify(printer);
				}
			});
		return q.promise;
	};
	//获取蓝牙打印机列表(搜索蓝牙设备)
	var getBluetoothPrinters = function (unpaired) {
		var q = $q.defer();
		//如果是WebView,则直接从缓存返回
		if (!ionic.Platform.isAndroid() && !ionic.Platform.isIOS() && !ionic.Platform.isIPad() && !ionic.Platform.isWindowsPhone()) {
			q.resolve(cacheData());
			console.log('isWebView');
		}
		try {
			//如果未开启蓝牙,则自动开启(Android适用)
			$BlePrinter.isEnabled().then(function () {
				console.log('isEnabled');
				listBluetoothPrinter(unpaired).then(function (printers) {
					q.resolve(printers);
				}, function (err) {
					q.reject(err);
				}, function (printer) {
					q.notify(printer);
				});
			}, function () {
				console.log('not Enabled');
				if (ionic.Platform.isAndroid()) {
					$BlePrinter.enable().then(function (ok) {
						listBluetoothPrinter(unpaired).then(function (printers) {
							q.resolve(printers);
						}, function (err) {
							q.reject(err);
						}, function (printer) {
							q.notify(printer);
						});
					});
				} else {
					return q.reject('您的设备当前未开启蓝牙功能,请先开启再搜索蓝牙打印机!');
				}
			});
		} catch (e) {
			q.reject(e);
		}
		return q.promise;
	};

	//蓝牙是否打开
	var isBluetoothEnable = function () {
		return $BlePrinter.isEnabled();
	};

	//打开蓝牙
	var enableBluetooth = function () {
		return $BlePrinter.enable();
	};

	//获取本地缓存印机列表(默认从缓存中获取)
	//如果是ios,则进行一次scan
	var getPrints = function (fromServer) {
		var q = $q.defer();
		fromServer = fromServer || false;
		var cachedb = cacheData();
		var selectedBluePrinter = null;
		//如果是IOS,需要自动Scan一次
		if (ionic.Platform.isIOS() || ionic.Platform.isIPad()) {
			selectedBluePrinter = _.find(cachedb, function (printer) {
				return printer.isBluetoothPrinter && printer.selected;
			});
		}
		//清空缓存
		if (fromServer) {
			clearCache();
		}
		//发送找到打印机通知
		function notifyPrinters(printers,callback){
			setTimeout(function () {
				_.forEach(printers, function (printer) {
					//显示云打印机和已连接蓝牙设备
					if (!printer.isBluetoothPrinter || (selectprinter && selectprinter.address === printer.address)) {
						q.notify(printer);
					}
				});
				if(_.isFunction( callback )){
					callback();
				}
			}, 100);
		}
		//搜索蓝牙打印机(判断是否获取未配对的)
		function scanPrinters() {
			return getBluetoothPrinters(fromServer).then(function (printers) {
				return printers;
			}, function (err) {
				return $q.reject(err);
			});
		}
		if (!_.isEmpty(cachedb) && fromServer === false) {
			notifyPrinters(cachedb,function(){
				scanPrinters().then(function (printers) {
					q.resolve(cachedb);
				}, function (err) {
					//出错也直接返回缓存中的打印机列表
					q.resolve(cachedb);
				},function(printer){
					//如果如果不在缓存中,或者不为当前选择的蓝牙打印机
					if(selectprinter !== printer || !_.find(cachedb, function(item){
						return item.address === printer.address;
					})){
						q.notify(printer);
					}
				});
			});
		} else {
			$http.get('/printers')
				.success(function (response) {
					saveCloudPrinters2Cache(response);
					_.forEach(cacheData(), function (printer) {
						fixPrinter(printer, false);
						q.notify(printer);
					});
					//重新扫描蓝牙设备
					scanPrinters().then(function () {
						q.resolve(cachedb);
					}, function (err) {
						//出错也直接返回缓存中的打印机列表
						q.resolve(cachedb);
					});
				}).error(function (err) {
					q.reject(err);
				});
		}
		return q.promise;
	};

	//获取云打印机列表(从服务器获取)
	var getCloudPrints = function () {
		return $q(function (resolve, reject) {
			$http.get('/printers')
				.success(function (response) {
					saveCloudPrinters2Cache(response);
					resolve(response);
				}).error(function (err) {
					reject(err);
				});
		});
	};

	// TODO: 打印完后,立即切换打印机会出现选择状态紊乱和短时间无法连接的错误.
	//选择打印机
	var selectPrinter = function (printer) {
		var q = $q.defer();
		//如果为当前选择打印机,则忽略
		if (printer.selected && selectprinter && (selectprinter === printer || selectprinter.address === printer.address)) {
			q.resolve(printer);
			return q.promise;
		}
		//清除所有标志
		_.forEach(DATA, function (item) {
			item.selected = false;
		});
		var tasks = [];
		var disconnectTask;
		//如果之前选择的是蓝牙打印机,则先断开连接
		if (selectprinter && selectprinter.isBluetoothPrinter && selectprinter !== printer) {
			//先断开连接
			disconnectTask = $q(function (resolve, reject) {
				console.log('是否处于已连接状态?');
				if (!selectprinter) {
					console.log('无连接中的打印机,直接正常返回');
					return resolve();
				}
				//是否处于已连接状态?
				$BlePrinter.isConnected(selectprinter.address).then(function () {
						console.log('处于已连接状态');
						//断开连接
						$BlePrinter.disconnect(selectprinter.address).then(function () {
								//正常断开连接
								if(selectprinter){
									selectprinter.selected = false;
								}
								resolve(printer);
								console.log('正常断开连接');
							},
							function (err) {
								console.log('取消已连接出错');
								reject(err);
							});
					},
					function () { //未处于已连接状态,直接正常返回
						resolve(printer);
						console.log('未处于已连接状态,直接正常返回');
					});
			});
		}else{
			//空任务
			disconnectTask = $q(function (resolve, reject) {
				resolve(printer);
			});
		}

		//先执行断开连接操作
		$q.when(disconnectTask).then(function(printer){
			var connectTask;
			//如果是蓝牙打印机,则调用蓝牙打印机的connect方法
			if (printer && printer.isBluetoothPrinter && selectprinter !== printer) {
				//重新进行连接
				connectTask = $q(function (resolve, reject) {
					var _printer = printer;
					console.log('连接蓝牙设备');
					//连接蓝牙设备
					try {
						$BlePrinter.connect(_printer).then(function (result) {
							console.log('连接设备成功');
							_printer.selected = true;
							selectprinter = _printer;
							//写入缓存
							save2Cache();
							return resolve(_printer);
						}, function (err) {
							console.log('连接设备不成功');
							_printer.selected = false;
							selectprinter = null;
							return reject(err);
						});
					} catch (e) {
						console.log('连接设备不成功');
						_printer.selected = false;
						selectprinter = null;
						return reject(e);
					}
				});
			}else if(printer && !printer.isBluetoothPrinter){
				//重新进行连接
				connectTask = $q(function (resolve, reject) {
					//否则为云打印机
					printer.selected = true;
					//写入缓存
					save2Cache();
					return resolve(printer);
				});
			}
			$q.when(connectTask).then(function () {
				//云打印机
			  if(selectprinter && !selectprinter.isBluetoothPrinter){
					selectprinter.selected = false;
					//写入缓存
					save2Cache();
				}
				selectprinter = printer;
				return q.resolve(printer);
			},
			function (err) {
				return q.reject(err);
			});
		},function(err){
			return q.reject(err);
		});
		return q.promise;
	};

	var thisPrinter = function () {
		return selectprinter;
	};

	//生成租金单打印数据
	var genInvoicePrintData = function (invoice, template) {
		if (!_.isArray(template)) {
			template = [template];
		}
		var scope = {
			invoice: invoice,
			customers: invoice.customers ? invoice.customers : [],
			customer: invoice.customers ? invoice.customers[0] : null,
			begindate: $Date.getChinaDateString(invoice.begindate),
			enddate: $Date.getChinaDateString(invoice.enddate),
			printDate: $Date.getChinaDateString(new Date())
		};
		var pts = [];
		//获取楼房对象
		pts.push(
			$q(function (resolve, reject) {
				var buildingId = invoice.building;
				$Building.getBuilding(buildingId).then(function (building) {
					scope.building = building;
					resolve();
				}, function (err) {
					reject(err);
				});
			})
		);
		//获取房间对象
		pts.push(
			$q(function (resolve, reject) {
				var roomId = invoice.room;
				$Room.getRoom(roomId).then(function (room) {
					scope.room = room;
					scope.rent = room.rent ? room.rent : null;
					resolve();
				}, function (err) {
					reject(err);
				});
			})
		);
		return $q.all(pts).then(function () {
			var printdata = [];
			_.forEach(template, function (line) {
				//console.log(line);
				var content = $Mustache.render(line, scope) || '';
				//console.log(content);
				printdata = printdata.concat(content.split(POSTMPL.mark));
			});
			invoice.printdata = printdata;
			//console.log(printdata);
			return printdata;
		}, function (err) {
			return $q.reject(err);
		});
	};
	//生成财务统计打印数据
	var genAnalysisPrintData = function (analysis, template) {
		if (!_.isArray(template)) {
			template = [template];
		}
		var scope = {
			analysis: analysis,
			invoices: [],
			printDate: $Date.getChinaDateString(new Date())
		};
		var pts = [];
		//获取楼房对象
		pts.push(
			$q(function (resolve, reject) {
				var buildingId = analysis.building;
				$Building.getBuilding(buildingId).then(function (building) {
					scope.building = building;
					resolve();
				}, function (err) {
					reject(err);
				});
			})
		);
		//获取明细租金单
		pts.push(
			$q(function (resolve, reject) {
				$Invoice.getBuildingMonthlyInvoices(analysis.building,analysis.year,analysis.month).then(function(invoices){
					scope.invoices = invoices;
					resolve(true);
        }, function (err) {
					reject(err);
				});
			})
		);
		return $q.all(pts).then(function () {
			var printdata = [];
			_.forEach(template, function (line) {
				//console.log(line);
				var content = $Mustache.render(line, scope) || '';
				//console.log(content);
				printdata = printdata.concat(content.split(POSTMPL.mark));
			});
			analysis.printdata = printdata;
			//console.log(printdata);
			return printdata;
		}, function (err) {
			return $q.reject(err);
		});
	};


	//设置租金单打印数据
	var addInvoiceData = function (invoices) {
		if (!_.isArray(invoices)) {
			invoices = [invoices];
		}
		//为每个租金单生成明细项目简述(用于pos打印机打印租金单详情)
		_.forEach(invoices, function(invoice){
			_.forEach(invoice.items, function(item){
				item.typestr = '';
				if(item.itemtype === DATALIST.INVOICE_ITEM_TYPE.PLEDGE){
					item.typestr = '(押)';
				}else if(item.itemtype === DATALIST.INVOICE_ITEM_TYPE.ADDITION){
					item.typestr = '(临)';
				}else if(item.itemtype === DATALIST.INVOICE_ITEM_TYPE.DEDUCTION){
					item.typestr = '(扣)';
				}
			});
			//租金单类型:只显示签合同和退房
			if(invoice.invoicetype === DATALIST.INVOICE_TYPE.MONTHLY){
				invoice.typestr = '';
			}
		});
		addData2List(_data.invoices, invoices);
	};

	//设置定金单打印数据
	var addPreOrderData = function (preorders) {
		if (!_.isArray(preorders)) {
			preorders = [preorders];
		}
		console.log('设置定金单打印数据', preorders);
		addData2List(_data.preorders, preorders);
	};

	//设置押金单打印数据
	var addPledgeData = function (pledges) {
		if (!_.isArray(pledges)) {
			pledges = [pledges];
		}
		console.log('设置押金单打印数据', pledges);
		addData2List(_data.pledges, pledges);
	};

	//设置合同打印数据
	var addContractData = function (contracts) {
		if (!_.isArray(contracts)) {
			contracts = [contracts];
		}
		console.log('设置合同打印数据', contracts);
		addData2List(_data.contracts, contracts);
	};
	//设置合同打印数据
	var addAnalysisesData = function (analysises) {
		if (!_.isArray(analysises)) {
			analysises = [analysises];
		}
		console.log('设置合同打印数据', analysises);
		addData2List(_data.analysises, analysises);
	};

	//获取打印单据数量
	var getPrintDataCount = function () {
		return {
			invoices: _data.invoices.length,
			preorders: _data.preorders.length,
			pledges: _data.pledges.length,
			contracts: _data.contracts.length,
			analysises: _data.analysises.length,
			all: _data.invoices.length + _data.preorders.length + _data.pledges.length + _data.contracts.length + _data.analysises.length
		};
	};

	//获取打印数据
	var getPrintData = function () {
		return _data;
	};

	//清除打印数据
	var clearPrintData = function () {
		_data = {
			//租金单
			invoices: [],
			//定金单
			preorders: [],
			//押金单
			pledges: [],
			//合同
			contracts: [],
			//财务统计
			analysises: []
		};
		return _data;
	};

	//打印数据
	var print = function (discription) {
		var q = $q.defer();

		//准备打印
		var pretask = [];
		//如果是蓝牙打印机,则判断蓝牙是否可用,并且已连接
		if (selectprinter && selectprinter.isBluetoothPrinter) {
			//是否处于可用状态?
			pretask.push($BlePrinter.isEnabled());
			//是否处于已连接状态?
			pretask.push($BlePrinter.isConnected());
			//生成打印数据
		  //获取缓存设置
		  var localsetting = getLocalSetting();
			if(_data.invoices && _data.invoices.length > 0){
				//console.log('设置租金单打印数据', _data.invoices);
				var templ_invoice = [];
				if(localsetting && localsetting.invoice && localsetting.invoice.owner){
					templ_invoice = templ_invoice.concat(POSTMPL.invoice.ownerRent);
				}
				if(localsetting && localsetting.invoice && localsetting.invoice.customer){
					templ_invoice = templ_invoice.concat(POSTMPL.invoice.customerRent);
				}
				//有切刀功能的打印机?
				if(localsetting && localsetting.cut){
					templ_invoice = templ_invoice.concat(POSTMPL.cut);
				}
				_.forEach(_data.invoices, function (invoice) {
					//生成打印数据
					pretask.push(genInvoicePrintData(invoice, templ_invoice));
				});
			}
			if(_data.analysises && _data.analysises.length > 0){
				console.log('设置月度财务统计打印数据', _data.analysises);
				var templ_analysis = POSTMPL.analysis.header;
				if(localsetting && localsetting.analysis && localsetting.analysis.opration){
					templ_analysis = templ_analysis.concat(POSTMPL.analysis.opration);
				}
				if(localsetting && localsetting.analysis && localsetting.analysis.product){
					templ_analysis = templ_analysis.concat(POSTMPL.analysis.product);
				}
				if(localsetting && localsetting.analysis && localsetting.analysis.paytype){
					templ_analysis = templ_analysis.concat(POSTMPL.analysis.paytype);
				}
				if(localsetting && localsetting.analysis && localsetting.analysis.basedetail && !localsetting.analysis.detail){
					templ_analysis = templ_analysis.concat(POSTMPL.analysis.basedetail);
				}
				if(localsetting && localsetting.analysis && localsetting.analysis.detail){
					templ_analysis = templ_analysis.concat(POSTMPL.analysis.detail);
				}
				templ_analysis = templ_analysis.concat(POSTMPL.analysis.footer);
				_.forEach(_data.analysises, function (analysis) {
					//有切刀功能的打印机?
					if(localsetting && localsetting.cut){
						templ_invoice = templ_analysis.concat(POSTMPL.cut);
					}
					//生成打印数据
					pretask.push(genAnalysisPrintData(analysis, templ_analysis));
				});
			}
		}
		//创建打印任务
		//按顺序输出打印内容
		function printerOneByOne(datas){
			var q = $q.defer();
			function inlinePrint(datas){
				var item = datas[0];
				try {
					var delay4cut = 50 * item.printdata.length;
					delay4cut = delay4cut > 3000 ? delay4cut : 3000;
					if (item.printdata && item.printdata.length > 0){
						write2Printer(item.printdata).then(function(printdata){
							if(datas.length <= 1){
								q.resolve(true);
							}else{
								q.notify(item);
								/********延时,撕纸*********/
								$timeout(function () {
									inlinePrint(datas.slice(1));
								}, delay4cut, false);
							}
							q.resolve(true);
						}, function (err) {
							q.reject(err);
						});
					}else{
						if(datas.length <= 1){
							q.resolve(true);
						}else{
							q.notify(item);
							/********延时,撕纸*********/
							$timeout(function () {
								inlinePrint(datas.slice(1));
							}, delay4cut, false);
						}
					}
				} catch (err) {
					q.reject(err);
				}
			}
			inlinePrint(datas);
			return q.promise;
		}

		var pts = [];
		function createpromise(type, datas) {
			if (datas && datas.length > 0) {
				//如果是蓝牙打印机,则输出打印内容
				if (selectprinter.isBluetoothPrinter) {
					pts.push(printerOneByOne(datas));
					// _.forEach(datas, function (data) {
					// 	if (data.printdata && data.printdata.length > 0) {
					// 		pts.push(
					// 			$q(function (resolve, reject) {
					// 				var ptasks = [];
					// 				try {
					// 					write2Printer(data.printdata).then(function(printdata){
					// 						resolve(true);
					// 					}, function (err) {
					// 						reject(err);
					// 					});
					// 					// _.forEach(data.printdata, function (line) {
					// 					// 	console.log(str2ab(line));
					// 					// 	ptasks.push($BlePrinter.write(str2Gb2312(line)));
					// 					// });
					// 					// $q.all(ptasks).then(function (results) {
					// 					// 	resolve(true);
					// 					// }, function (err) {
					// 					// 	reject(err);
					// 					// });
					// 				} catch (err) {
					// 					reject(err);
					// 				}
					// 			})
					// 		);
					// 	}
					// });
				}
				//新增保存云打印任务
				var printdata = {
					type: type,
					businessIDs: _.map(datas, '_id'),
					discription: discription,
					printer: selectprinter.isBluetoothPrinter ? null : selectprinter._id,
					printerMac: selectprinter.isBluetoothPrinter ? selectprinter.address : selectprinter.Mac
				};
				pts.push(
					$q(function (resolve, reject) {
						var url = selectprinter.isBluetoothPrinter ? '/bluetoothprinter/tasks' : '/printer/' + selectprinter._id + '/tasks';
						$http.post(url, printdata)
							.success(function (response) {
								//更新缓存中租金单的状态(云打印个->打印中;蓝牙打印->已打印)
								if(_data.invoices && _data.invoices.length > 0){
									_.forEach(_data.invoices, function (invoice) {
										//更新状态
										invoice.invoicestatus = selectprinter.isBluetoothPrinter ? DATALIST.INVOICE_STATUS.PRINT : DATALIST.INVOICE_STATUS.CONFIRM;
									});
								}
								save2Cache();
								resolve(response);
							})
							.error(function (err) {
								reject(err);
							});
					})
				);
			}
		}

		$q.when($q.all(pretask)).then(function(){
			//租金单打印任务
			createpromise('invoice', _data.invoices);
			//定金单打印任务
			createpromise('preorder', _data.preorders);
			//租金单打印任务
			createpromise('pledge', _data.pledges);
			//租金单打印任务
			createpromise('contract', _data.contracts);
			//财务统计打印任务
			createpromise('analysis', _data.analysises);

			return $q.all(pts).then(function (results) {
				return q.resolve(results);
			}, function (err) {
				//如果是蓝牙打印机,则取消连接状态,让用户重新手动连接蓝牙
				if (selectprinter && selectprinter.isBluetoothPrinter) {
					selectprinter.selected = false;
					selectprinter = null;
				}
				return q.reject(err);
			});
		},function(err){
			return q.reject(err);
		});

		return q.promise;
	};


	return {
		getPrints: getPrints,
		getCloudPrints: getCloudPrints,
		getBluetoothPrinters: getBluetoothPrinters,
		isBluetoothEnable: isBluetoothEnable,
		enableBluetooth: enableBluetooth,
		selectPrinter: selectPrinter,
		thisPrinter: thisPrinter,
		addInvoiceData: addInvoiceData,
		addPreOrderData: addPreOrderData,
		addPledgeData: addPledgeData,
		addContractData: addContractData,
		addAnalysisesData: addAnalysisesData,
		getPrintData: getPrintData,
		getPrintDataCount: getPrintDataCount,
		clearPrintData: clearPrintData,
		print: print,
		clearCache: clearCache,
		getLocalSetting: getLocalSetting,
		saveLocalSetting: saveLocalSetting
	};
});
