angular.module('bagu')
	/********
	缓存房间,格式:{"buildingID":{room,room,...}}
	********/
	.service('$Room', function ($q, $http, $Cache, $Sets, DATALIST, _) {
		/****对象定义****/
		//表名
		var TABLENAME = 'rooms';
		//数据实体对象
		var DATA = null;
		//选择的房间
		var CHOOSEROOMS = {};
		//快速选择房间的模板
		var SELECTTEMPL = {
			aUNFINANCE: {
				name: '未收费',
				status: [DATALIST.ROOM_STATUS.NOFEE],
				count: 0,
				selectcount: 0,
				selected: false
			},
			bWILLEXPIRE: {
				name: '将到期',
				status: [DATALIST.ROOM_STATUS.WILLEXPIRE],
				count: 0,
				selectcount: 0,
				selected: false
			},
			cBACKING: {
				name: '退房中',
				status: [DATALIST.ROOM_STATUS.BACKING],
				count: 0,
				selectcount: 0,
				selected: false
			},
			dALL: {
				name: '全部',
				status: [],
				count: 0,
				selectcount: 0,
				selected: false
			}
		};
		//服务对象
		var service = {};

		/****工具函数****/

		// //配置集合转换为数值
		// function value2DeploySets(value, perRow) {
		// 	perRow = perRow || 4;
		// 	//按位拆分房间配置,同时分组
		// 	var deploysets = [],
		// 		_sets = [],
		// 		i = 0,
		// 		deploynames = DATALIST.COMM_DEPLOY;
		// 	_.forIn(deploynames, function (itemValue, key) { // TODO: 顺序有可能不一致,此处需要改进
		// 		var item = {};
		// 		item.name = key;
		// 		item.itemValue = itemValue;
		// 		item.value = (value && (value & Math.pow(2, itemValue)) !==
		// 			0);
		// 		_sets.push(item);
		// 		if (_sets.length > 0 && (_sets.length % perRow === 0 || i ===
		// 				deploynames.length - 1)) {
		// 			deploysets.push(_sets);
		// 			_sets = [];
		// 		}
		// 		i++;
		// 	});
		//
		// 	return deploysets;
		// }
		//
		// //配置集合转换为数值
		// function deploySets2Value(sets) {
		// 	var _sets = [],
		// 		_deploy = 0;
		// 	for (var i = 0; i < sets.length; i++) { //行
		// 		for (var j = 0; j < sets[i].length; j++) { //列
		// 			_deploy = _deploy | (sets[i][j].value ? Math.pow(
		// 				2, sets[i][j].itemValue) : 0);
		// 		}
		// 	}
		// 	return _deploy;
		// }

		//修正对象中的日期对象
		function fixRoom(room) {
			//修正合同日期
			if (room.rent && room.rent.contract) {
				var contract = room.rent.contract;
				if (contract.begindate) {
					contract.begindate = new Date(contract.begindate);
				}
				if (contract.enddate) {
					contract.enddate = new Date(contract.enddate);
				}
			}
      //更新日期
      if(_.isString( room.updatetime )){
        room.updatetime = new Date();
      }
      room.updatetime = new Date();
			//修正配置项目
			room.deploysets = $Sets.value2DeploySets(room.deploy,DATALIST.COMM_DEPLOY,4);
			//状态名称
			room.statusmsg = DATALIST.ROOM_STATUS.enum[room.roomstatus];
			//房间状态对应的样式
			room.color = DATALIST.ROOM_COLORS[room.roomstatus] ? DATALIST.ROOM_COLORS[room.roomstatus] : DATALIST.ROOM_COLORS[DATALIST.ROOM_STATUS.NULL];
			//租客,电话,身份证的未录入标志
			room.noinfos = {
				noCustomer: !room.rent || !room.rent.contract || room.rent.contract.customers.length > 0 ? false : true,
				noMobile: !room.rent || !room.rent.contract || room.rent.contract.mobiles > 0 ? false : true,
				noCreCode: !room.rent || !room.rent.contract || (room.rent.contract.peoples !== 0 && room.rent.contract.crecodes === room.rent.contract.peoples) ? false : true,
			};
		}

		//获取缓存数据
		function loadCacheData() {
			//缓存对象的引用
			DATA = $Cache.get(TABLENAME, function (cachetable) {
				DATA = $Cache.get(TABLENAME);
			});
			//为每个缓存对象设置版本号
			_.forEach(DATA, function (building) {
				_.forEach(building, function (room) {
					fixRoom(room);
				});
			});
			// //缓存清空回调
			// $Cache.registerCacheClearCallback(function(){
			//   DATA = $Cache.get(TABLENAME);
			// });
			return DATA;
		}
		//保存数据到缓存
		function save2Cache() {
			//保存结果到缓存
			$Cache.saveTable(TABLENAME);
		}
		//保存单个楼房数据到缓存,将_id转换成属性名称,方便后面使用
		function saveBuildingRooms2Cache(building, roomlist) {
			var buildingId = building._id ? building._id : building;
			//清除原有楼房的房间数据
			//DATA[buildingId] = {};
			_.forEach(DATA[buildingId], function(item){
				//查找已删除的对象?
				var inNewList = _.find(roomlist, function(newitem){
					return item && newitem && item._id === newitem._id;
				});
				if(!inNewList && item._id){
					delete DATA[buildingId][item._id];
				}
			});
			// _.remove(DATA[buildingId], function(item){
			// 	var inNewList = _.find(roomlist, function(newitem){
			// 		return item && newitem && item._id === newitem._id;
			// 	});
			// 	return !inNewList;
			// });
			//_id转换
			if (roomlist && _.isArray(roomlist)) {
				_.forEach(roomlist, function (room) {
					if (room && room._id) {
						fixRoom(room);
						DATA[buildingId][room._id] = DATA[buildingId][room._id] ? _.assign(DATA[buildingId][room._id], room) : room;
					}
				});
			}
			//写入缓存
			save2Cache();
		}

		//从缓存中获取房间对象
		function getCacheRoom(roomId) {
			var cacheRoom = null;
			_.forEach(DATA, function (building) {
				if (building[roomId]) {
					cacheRoom = building[roomId];
					fixRoom(cacheRoom);
					return false;
				}
			});
			return cacheRoom;
		}

		/****服务方法****/
		//修正room对象
		service.fixRoom = fixRoom;

		//获取指定楼房的房间列表
		//building:楼房(_id,或对象)
		//fromServer:是否强制从服务器刷新数据
		//返回值:
		// {
		//  "roomId":room
		//  ....
		// }
		service.getBuildingRooms = function (building, fromServer) {
			fromServer = fromServer || false;
			//返回promise
			return $q(function (resolve, reject) {
				if (!building) {
					return reject('楼房参数错误!');
				}
				var buildingId = building._id ? building._id : building;

				DATA[buildingId] = DATA[buildingId] || {};

				if (fromServer !== true && !_.isEmpty(DATA[buildingId])) {
					//返回缓存数据
					return resolve(DATA[buildingId]);
				} else {
					//无缓存数据或强制刷新,则从远程取
					$http.get('/rooms/' + buildingId)
						.success(function (response) {
							//保存到缓存
							saveBuildingRooms2Cache(buildingId, response);
							//回调
							resolve(DATA[buildingId]);
						})
						.error(function (err) {
							reject(err);
						});
				}
			});
		};

		//从缓存获取指定房间数据
		//roomId:房间对象_id
		service.getCacheRoom = function (roomId) {
			var cacheroom = getCacheRoom(roomId);
			//返回promise
			return $q(function (resolve, reject) {
				resolve(cacheroom);
			});
		};

		//获取指定房间数据
		//roomId:房间对象_id
		//fromServer:是否强制从服务器刷新数据
		service.getRoom = function (roomId, fromServer) {
			fromServer = fromServer || false;
			//返回promise
			return $q(function (resolve, reject) {
				if (!roomId) {
					return reject('房间参数错误!');
				}
				//存在于缓存中?(遍历每个building)
				var cacheRoom = getCacheRoom(roomId);
				if (fromServer !== true && cacheRoom) {
					//返回内存副本
					return resolve(cacheRoom);
				} else {
					//无缓存数据或强制刷新,则从远程取
					$http.get('/room/' + roomId)
						.success(function (response) {
							cacheRoom = response;
							fixRoom(cacheRoom);
							//保存到缓存
							DATA[cacheRoom.building] = DATA[cacheRoom.building] || {};
							DATA[cacheRoom.building][cacheRoom._id] = cacheRoom;
							save2Cache();
							//回调
							resolve(DATA[cacheRoom.building][cacheRoom._id]);
						})
						.error(function (err) {
							reject(err);
						});
				}
			});
		};

		//修改指定房间信息
		//roomId:房间对象_id
		//data:修改内容
		service.initRoom = function (buildingId, roomId, initdata) {
			//返回promise
			return $q(function (resolve, reject) {
				if (!roomId) {
					return reject('房间参数错误!');
				}
				var roomstatus = initdata.roomstatus;
				//房屋不能初始化?
				if (!_.contains([DATALIST.ROOM_STATUS.OWN, DATALIST.ROOM_STATUS.EMPTY, DATALIST.ROOM_STATUS.RENT], roomstatus)) {
					return reject('状态参数错误!');
				}
				var url = '/room/' + roomId + '/init';
				$http.post(url, initdata)
					.success(function (response, status, headers, config) {
						//将修改内容保存到缓存
						var cacheroom = DATA[buildingId][roomId];
						var room;
						if (roomstatus === DATALIST.ROOM_STATUS.RENT) {
							//更新房间出租信息,并保存到缓存
							cacheroom.popularize = 0;
							cacheroom.rent = response.rent;
							if (response.rent && response.rent.contract) {
								cacheroom.price = response.rent.contract.price;
								cacheroom.pledge = response.rent.contract.pledge;
							}
							cacheroom.statusmsg = DATALIST.ROOM_STATUS.enum[DATALIST.ROOM_STATUS.RENT];
						} else {
							cacheroom.popularize = 1;
							cacheroom.prerent = null;
							cacheroom.rent = null;
						}
						cacheroom.roomstatus = roomstatus;
						service.updateRoom2Cache(cacheroom);
            fixRoom(cacheroom);
						save2Cache();
						//回调
						resolve(response, status, headers, config);
					})
					.error(function (response, status, headers, config) {
						reject(response, status, headers, config);
					});
			});
		};

		//新增房间
		//roomId:房间对象_id
		//data:修改内容
		service.addRoom = function (buildingId, roomData) {
			//返回promise
			return $q(function (resolve, reject) {
				var url = '/rooms/' + buildingId;
				$http.post(url, roomData)
					.success(function (response, status, headers, config) {
						var room = response;
						//将修改内容保存到缓存
						DATA[buildingId][room._id] = room;
            fixRoom(room);
						save2Cache();
						//回调
						resolve(room);
					})
					.error(function (response, status, headers, config) {
						reject(response, status, headers, config);
					});
			});
		};

		//修改指定房间信息
		//roomId:房间对象_id
		//data:修改内容
		service.editRoom = function (roomId, roomData) {
			//返回promise
			return $q(function (resolve, reject) {
				if (!roomId) {
					return reject('房间参数错误!');
				}
				var postData = _.cloneDeep(roomData);
				//转换配置项目为数值
				if (postData.deploysets) {
					postData.deploy = $Sets.deploySets2Value(postData.deploysets);
					postData.deploysets = undefined;
				}
				var url = '/room/' + roomId;
				$http.put(url, postData)
					.success(function (response, status, headers, config) {
						//将修改内容保存到缓存
						var buildingId = response.building._id ? response.building._id : response.building;
						var room = DATA[buildingId][roomId];
						//还原Sets
						postData.deploysets = $Sets.value2DeploySets(postData.deploy,DATALIST.COMM_DEPLOY,4);
						_.assign(room, postData);
            fixRoom(room);
						save2Cache();
						//回调
						resolve(response, status, headers, config);
					})
					.error(function (response, status, headers, config) {
						reject(response, status, headers, config);
					});
			});
		};

		//删除指定房间信息
		//roomId:房间对象_id
		//data:修改内容
		service.deleteRoom = function (buildingId, roomId) {
			//返回promise
			return $q(function (resolve, reject) {
				if (!roomId) {
					return reject('房间参数错误!');
				}
				var url = '/room/' + roomId;
				$http.delete(url)
					.success(function (response, status, headers, config) {
						//删除缓存内容
						//delete DATA[buildingId][roomId];
						_.remove(DATA[buildingId], function (item) {
							return item._id === roomId;
						});
						save2Cache();
						//回调
						resolve(response, status, headers, config);
					})
					.error(function (response, status, headers, config) {
						reject(response, status, headers, config);
					});
			});
		};

		//更新房间状态
		//room:更新内容
		service.updateRoomStatus = function (room) {
			//返回promise
			return $q(function (resolve, reject) {
				var roomId = room && room._id ? room._id : room;
				if (!roomId) {
					return reject('房间参数错误!');
				}
				var url = '/room/' + roomId + '/updatestatus';
				$http.post(url)
					.success(function (response, status, headers, config) {
						var cacheroom = getCacheRoom(roomId);
						if (cacheroom && cacheroom._id && response.roomstatus) {
							cacheroom.roomstatus = response.roomstatus;
						}
            fixRoom(cacheroom);
						//回调
						resolve(response);
					})
					.error(function (response, status, headers, config) {
						reject(response);
					});
			});
		};

		//楼房之房间状态分类统计 0,自住; 1,未出租; 2,已预订; 3,已出租; 4,未缴费; 5,快到期; 6,退房中; 100,未初始化;
		service.getBuildingRoomStatusCount = function (building, fromServer) {
			//默认从缓存取数据
			fromServer = fromServer || false;
			//返回promise
			return $q(function (resolve, reject) {
				//无缓存数据或强制刷新,则从远程取
				service.getBuildingRooms(building, fromServer).then(function (rooms) {
					var result = {};
					//遍历统计
					_.forEach(rooms, function (room) {
						if (room) {
							if (result[room.roomstatus]) {
								result[room.roomstatus] += 1;
							} else {
								result[room.roomstatus] = 1;
							}
						}
					});
					resolve(result);
				}, function (err) {
					reject(err);
				});
			});
		};

		//更新缓存内容(内存->缓存) warning:经测试cloneDeep无法将子数组复制
		//room:更新内容
		service.updateRoom2Cache = function (room) {
			var buildingId = room.building,
				roomId = room._id;
			if (DATA[buildingId] && DATA[buildingId][roomId]) {
				DATA[buildingId][roomId] = room;
				save2Cache();
			}
		};

		//为房间新增租客
		service.addCustomer4Cache = function (roomId, customer) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom.rent && cacheRoom.rent.contract && cacheRoom.rent.contract.customers) {
				cacheRoom.rent.contract.customers.push(customer);
				//更新统计数据
				if(customer.mobile){
					cacheRoom.rent.contract.mobiles++;
				}
				if(customer.credentialscode){
					cacheRoom.rent.contract.crecodes++;
				}
				cacheRoom.rent.contract.peoples++;
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//修改房间租客信息
		service.editCustomer4Cache = function (roomId, customer) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom.rent && cacheRoom.rent.contract && cacheRoom.rent.contract.customers) {
				var cachecustomer = _.find(cacheRoom.rent.contract.customers, function (item) {
					return item._id === customer._id;
				});
				if (cachecustomer) {
					//更新统计数据
					var mobiles=0,crecodes=0;
					if(customer.mobile){
						mobiles++;
					}
					if(cachecustomer.mobile){
						mobiles--;
					}
					if(customer.credentialscode){
						crecodes++;
					}
					if(cachecustomer.credentialscode){
						crecodes--;
					}
					cacheRoom.rent.contract.mobiles += mobiles;
					cacheRoom.rent.contract.crecodes += crecodes;
					cachecustomer = _.assign(cachecustomer, customer);
          fixRoom(cacheRoom);
					save2Cache();
				}
			}
		};

		//删除房间租客
		service.deleteCustomer4Cache = function (roomId, customer) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom.rent && cacheRoom.rent.contract && cacheRoom.rent.contract.customers) {
				_.remove(cacheRoom.rent.contract.customers, function (item) {
					return item._id === customer._id;
				});
				//更新统计数据
				if(customer.mobile){
					cacheRoom.rent.contract.mobiles --;
				}
				if(customer.credentialscode){
					cacheRoom.rent.contract.crecodes--;
				}
				cacheRoom.rent.contract.peoples--;
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//为房间订购产品
		service.addProduct4Cache = function (roomId, product) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom.rent && cacheRoom.rent.contract && cacheRoom.rent.contract.products) {
				cacheRoom.rent.contract.products.push(product);
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//修改房间产品信息
		service.editProduct4Cache = function (roomId, product) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom.rent && cacheRoom.rent.contract && cacheRoom.rent.contract.products) {
				var cacheproduct = _.find(cacheRoom.rent.contract.products, function (item) {
					return item._id === product._id;
				});
				if (cacheproduct) {
					cacheproduct = _.assign(cacheproduct, product);
          fixRoom(cacheRoom);
					save2Cache();
				}
			}
		};

		//删除房间产品
		service.deleteProduct4Cache = function (roomId, product) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom.rent && cacheRoom.rent.contract && cacheRoom.rent.contract.products) {
				//修正product无属性_id
				if (!product._id) {
					product._id = product.product;
				}
				_.remove(cacheRoom.rent.contract.products, function (item) {
					return item._id === product._id;
				});
        fixRoom(cacheRoom);
				save2Cache();
			}
		};
		//设为自住房
		service.setRoomIsOwn = function (roomId, prerent, roomstatus) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom._id) {
				//增加room.prerent 对象
				cacheRoom.prerent = prerent;
				//修改为自住状态
				cacheRoom.roomstatus = DATALIST.ROOM_STATUS.OWN;
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//对外出租,设置房间为未出租状态
		service.setRoomEmpty = function (roomId, prerent, roomstatus) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom._id) {
				//修改为出租状态
				cacheRoom.roomstatus = DATALIST.ROOM_STATUS.EMPTY;
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//续约,设置房间为出租状态
		service.setRoomRent = function (roomId, prerent, roomstatus) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom._id) {
				//增加room.prerent 对象
				cacheRoom.prerent = prerent;
				//修改为出租状态
				cacheRoom.roomstatus = DATALIST.ROOM_STATUS.RENT;
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//收费,设置房间为出租状态


		//设置房间为预定状态
		service.setRoomIsOrder = function (roomId, preinfo) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom._id) {
				//增加room.prerent 对象
				cacheRoom.prerent = cacheRoom.prerent || {};
				cacheRoom.prerent.preinfo = preinfo;
				//修改为预定状态,,如果是未收费状态,则不改变房间状态
				if(cacheRoom.roomstatus !== DATALIST.ROOM_STATUS.NOFEE){
				  cacheRoom.roomstatus = DATALIST.ROOM_STATUS.ORDER;
				}
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		//取消房间的预定状态
		service.setRoomCancelOrder = function (roomId, roomstatus) {
			var cacheRoom = getCacheRoom(roomId);
			if (cacheRoom && cacheRoom._id) {
				//删除room.prerent对象
				cacheRoom.prerent = null;
				//取消预定后的状态
				cacheRoom.roomstatus = roomstatus;
        //
        fixRoom(cacheRoom);
				save2Cache();
			}
		};

		/***计算每层楼显示的行数和列数***/
		/* 规则
		  1,5间以内显示1行
		  2,能整除[5,4,3]的,每行[5,4,3]列
		  3,否则每行4列
		  案例
		  4间:4,5间:5,6间:33,7间:43,8间,44,9间:333,10间:55,11间:443,12间:444
		*/
		/*
			options: 处理设置
				groupfun: 分组方法,传入需分组的对象,返回分组的值
				sortfun: 排序方法,传入需排序的对象,返回排序的值
		*/
		service.groupRooms = function (buildingId, roomlist, options) {
			var result = [];

			function splitrooms(rooms, num) {
				var i = 0,
					resultlist = [],
					tmplist = [];
				_.forEach(rooms, function (room) {
					i++;
					tmplist.push(room);
					if (num <= i && i % num === 0) {
						resultlist.push(tmplist);
						tmplist = [];
					}
				});
				if (tmplist.length > 0) {
					while (tmplist.length !== num) {
						tmplist.push({
							_id: '',
							code: ''
						});
					}
					resultlist.push(tmplist);
				}
				return resultlist.reverse();
			}
			////按楼层汇总并倒序
			var _g_f = _.groupBy(roomlist, function (item) {
				if(options && options.groupfun && _.isFunction(options.groupfun)){
					return options.groupfun(item);
				}else{
					return item.floor;
				}
			});
			var floorrooms = [];
			_.forEach(_g_f, function (rooms, key) {
				floorrooms.push({
					floor: key,
					rooms: rooms
				});
			});
			floorrooms = _.sortBy(floorrooms, function (item) {
				if(options && options.sortfun && _.isFunction(options.sortfun)){
					return options.sortfun(item);
				}else{
					return item.floor * -1;
				}
			});

			_.forEach(floorrooms, function (item) {
				var floorobj = {
					floor: item.floor,
					rooms: []
				};
				//房间按照Code排序
				item.rooms =  _.sortBy(item.rooms, 'code');
				//5间以内显示在一行
				if (item.rooms.length <= 5) {
					floorobj.rooms.push(item.rooms);
				} else if (item.rooms.length % 5 === 0) { //能被5整除?
					floorobj.rooms = splitrooms(item.rooms, 5);
				} else if (item.rooms.length % 4 === 0) { //能被4整除?
					floorobj.rooms = splitrooms(item.rooms, 4);
				} else if (item.rooms.length % 3 === 0) { //能被3整除?
					floorobj.rooms = splitrooms(item.rooms, 3);
				} else { //其余按每行4列处理
					floorobj.rooms = splitrooms(item.rooms, 4);
				}
				result.push(floorobj);
			});

			return result;
		};

		//CHOOSEROOMS
		/***设置选择的房间***/
		service.setChooseRooms = function (buildingId, rooms) {
			CHOOSEROOMS[buildingId] = rooms;
		};
		/***获取选择的房间***/
		service.getChooseRooms = function (buildingId) {
			return CHOOSEROOMS[buildingId];
		};
		/***获取选择的模板,及其状态***/
		service.getChooseTemplate = function () {
			return SELECTTEMPL;
		};


		//加载缓存
		if (!DATA) {
			loadCacheData();
		}

		return service;
	});
