angular.module('bagu')

.service('$Update', function($ionicPlatform, $q, $http, $cordovaAppVersion, SERVER_SETTINGS, $ionicPopup, _) {

  //服务对象
  var service = {};

  //获取当前App的版本
  service.getLocalVersion = function() {
    //返回promise
    return $q(function(resolve, reject) {
      var localVersion = null;
      //不是移动设备环境?
      if(!window.cordova){
        return reject('当前平台不支持获取版本操作!');
      }
      if(!cordova.getAppVersion){
        cordova.getAppVersion = window.cordova.require('cordova-plugin-app-version.AppVersionPlugin');
      }
      $cordovaAppVersion.getVersionNumber().then(function(version){
        console.log(version);
        if (!version || !_.isString(version) || version.length === 0) {
          return reject('无法获取本地版本!');
        } else {
          localVersion = version;
          //获取版本号
          $cordovaAppVersion.getVersionCode().then(function(number){
            console.log(number);
            if (!number || (!_.isNumber(number) && !_.isString(number))) {
              return reject('无法获取本地版本号!');
            } else {
              localVersion = localVersion + '(' + number.toString() + ')';
              //返回
              return resolve(localVersion);
            }
          }, function(err) {
            console.log(arguments);
            return reject(err);
          });
        }
      }, function(err) {
        console.log(arguments);
        return reject(err);
      });
    });
    //   //获取当前(android适用)
    //   if (window.cordova && $ionicPlatform.is('Android')) {
    //     var appUpdate = window.cordova.require('cordova-plugin-app-update.AppUpdate');
    //     appUpdate.getLocalVersion(function(version) {
    //       console.log(version);
    //       if (!version || !_.isString(version) || version.length === 0) {
    //         return reject('无法获取本地版本!');
    //       } else {
    //         //返回
    //         return resolve(version);
    //       }
    //     }, function(err) {
    //       console.log(arguments);
    //       return reject(err);
    //     });
    //   } else {
    //     return reject('平台不支持获取本地版本!');
    //   }
    // });
  };

  //更新系统
  service.updateApp = function(isAuto) {
    isAuto = isAuto || false;
    //自动更新(android适用)
    if (window.cordova && $ionicPlatform.is('Android')) {
      var updateUrl = '';
      if (_.isArray(SERVER_SETTINGS.UPDATESERVER_LIST) && SERVER_SETTINGS.UPDATESERVER_LIST.length > 0) {
        updateUrl = SERVER_SETTINGS.UPDATESERVER_LIST[0].url;
      }
      var appUpdate = window.cordova.require('cordova-plugin-app-update.AppUpdate');
      appUpdate.checkAppUpdate(function() {
        console.log(arguments);
      }, function() {
        console.log(arguments);
      }, updateUrl,isAuto);
    }
  };

  //输出服务对象
  return service;
});
