angular.module('bagu')

.service('$Window', function($window, $q, $http, $ionicPopup, $ionicLoading, $ionicActionSheet, _, $cordovaToast) {

  //服务对象
  var service = {};

  //显示加载动画
  service.showLoading = function(opt){
    var defaultopt = {
      delay: 300,
      duration: 5000
    };
    _.assign(defaultopt, opt);
    $ionicLoading.show(defaultopt);
  };
  //隐藏加载动画
  service.hideLoading = function(){
    $ionicLoading.hide();
  };

  //弹出Toast
  service.showToast = function(message) {
    if ($window.plugins && $window.plugins.toast) {
      return $cordovaToast.showShortBottom(message);
    } else {
      return service.showAlert('', message);
    }
  };

  //弹出提示窗口
  service.showAlert = function(title, message) {
    return $ionicPopup.alert({
      title: title,
      template: message,
      okText: '确认'
    });
  };

  //弹出询问窗口
  service.showConfirm = function(title, message, oktext, canceltext) {
    return $ionicPopup.confirm({
      title: title,
      template: message,
      cancelText: canceltext || '取消',
      okText: oktext || '确认'
    });
  };

  //弹出操作选择窗口
  service.showActionSheet = function(title, buttons, click, destructive, destructiveFun, cancel, cancelFun) {
    var sheetData = {
      titleText: title || '选择操作方式',
      buttons: buttons,
      buttonClicked: click
    };
    if (_.isString(destructive) && _.isFunction(destructiveFun)) {
      sheetData.destructiveText = destructive;
      sheetData.destructiveButtonClicked = destructiveFun;
    }
    sheetData.cancelText = _.isString(cancel) ? cancel : '取消';
    sheetData.cancel = cancelFun || function() {
      return true;
    };
    return $ionicActionSheet.show(sheetData);
  };

  //输出服务对象
  return service;
});
