//ESC/POS命令字符
var ESCCOMMAND = {
	ESC: 27, //换码
	FS: 28, //文本分隔符
	GS: 29, //组分隔符
	DLE: 16, //数据连接换码
	EOT: 4, //传输结束
	ENQ: 5, //询问字符
	SP: 32, //空格
	HT: 9, //横向列表
	LF: 10, //打印并换行（水平定位）
	CR: 13, //归位键
	FF: 12, //走纸控制（打印并回到标准模式（在页模式下） ）
	CAN: 24 //作废（页模式下取消打印数据 ）
};
//ESC/POS命令集
var ESCPOS = {
	mark: '$$$', //用于ios蓝牙批量发送数据的标志
	init: String.fromCharCode(ESCCOMMAND.ESC, 64, 0), //初始化
	newline: String.fromCharCode(ESCCOMMAND.LF), //换行
	line: '--------------------------------\n', //画一条横线,并换行
	endline: '================================\n', //画一条双横线,并换行
	underline1: String.fromCharCode(ESCCOMMAND.ESC, 45, 1), //下划线,一点线宽
	underline2: String.fromCharCode(ESCCOMMAND.ESC, 45, 2), //下划线,一点线宽
	underlineOff: String.fromCharCode(ESCCOMMAND.ESC, 45, 0), //取消下划线
	boldOn: String.fromCharCode(ESCCOMMAND.ESC, 69, 0xF), //加粗
	boldOff: String.fromCharCode(ESCCOMMAND.ESC, 69, 0), //取消加粗
	alignLeft: String.fromCharCode(ESCCOMMAND.ESC, 97, 0), //左对齐
	alignCenter: String.fromCharCode(ESCCOMMAND.ESC, 97, 1), //居中对齐
	alignRight: String.fromCharCode(ESCCOMMAND.ESC, 97, 2), //右对齐
	setTable: function (cols) {
		var result = String.fromCharCode(ESCCOMMAND.ESC, 68);
		cols.forEach(function (col) {
			result += String.fromCharCode(col);
		});
		result += String.fromCharCode(0);
		return result;
	}, //设置制表符,cols为整形数组,[N1..Nk]
	nextCol: String.fromCharCode(ESCCOMMAND.HT, 0), //下移1列
	firstCol: String.fromCharCode(ESCCOMMAND.ESC, 60, 0), //移动至第一列
	clearTable: String.fromCharCode(ESCCOMMAND.ESC, 68, 0), //取消制表设置
	bigfont: function (size) {
		return String.fromCharCode(29, 33, [0, 0, 17, 34, 51, 68, 85, 102, 119][size > 8 ? 8 : (size < 0 ? 0 : size)]);
	}, //设置字体大小
	bigfont1: String.fromCharCode(29, 33, 0), //字体加大1倍
	bigfont2: String.fromCharCode(29, 33, 17), //字体加大2倍
	bigfont3: String.fromCharCode(29, 33, 34), //字体加大3倍
	bigfont4: String.fromCharCode(29, 33, 51), //字体加大4倍
	bigfont5: String.fromCharCode(29, 33, 68), //字体加大5倍
	bigfont6: String.fromCharCode(29, 33, 85), //字体加大6倍
	bigfont7: String.fromCharCode(29, 33, 102), //字体加大7倍
	bigfont8: String.fromCharCode(29, 33, 119), //字体加大8倍
	fontNormal: String.fromCharCode(29, 33, 0), //取消字体变大变宽(MPT-II:29;GPprinter:27?)
	cut: String.fromCharCode(ESCCOMMAND.GS, 86, 65, 0), //切纸
	cutLeft: String.fromCharCode(ESCCOMMAND.GS, 86, 66, 0), //切纸,右边到左边
};
//Pos打印模板
var POSTMPL = {
  mark: '$$$',
  //租金单模板
  invoice: {
    //租客联
    customerRent: [
      '\n租客联\n', ESCPOS.line,
      ESCPOS.bigfont2, ESCPOS.alignCenter, '{{building.name}}-{{room.code}}{{#invoice.typestr}}{{invoice.typestr}}{{/invoice.typestr}}\r\n\n', ESCPOS.alignLeft, ESCPOS.fontNormal,
      '租户:{{#customer}}{{{realname}}}{{/customer}}\n',
      '日期:{{begindate}}-{{enddate}}\n',
      ESCPOS.line, ESCPOS.setTable([1, 25]),
      '{{#invoice.items}}' +
      ESCPOS.firstCol + ESCPOS.mark + '{{name}}:' +
			//'{{#price}}{{price}}元/{{#unit}}{{unit}}{{/unit}}{{^unit}}月{{/unit}}{{/price}}{{#typestr}}{{typestr}}{{/typestr}}' +
			'{{{info}}}' +
			ESCPOS.nextCol + ESCPOS.mark  + '{{money}}元\r\n' +
      '{{#value.amount}}' + ESCPOS.alignLeft +
      ESCPOS.firstCol + ESCPOS.mark + '     {{value.init}}->{{value.current}}={{value.amount}}\r\n' +
      '{{/value.amount}}' +
      '{{/invoice.items}}',
      ESCPOS.line, ESCPOS.setTable([1, 20]),
      ESCPOS.firstCol, '合计:' + ESCPOS.nextCol  + ESCPOS.bigfont2 + '{{invoice.money}}元\n\n', ESCPOS.alignLeft , ESCPOS.fontNormal, ESCPOS.clearTable,
      '备注:{{invoice.description}}\n',
      '签字:\n\n',
      ESCPOS.line,
      '打印日期:{{printDate}}\n',
      '深圳包租婆科技有限公司\n',
      '客服热线:4008-128-028\n',
      'http://www.bzptech.com\n',
      ESCPOS.endline, '\n\n'
      //ESCPOS.cut,
    ],
    //租客联(IOS)
    customerRentIos: [],
    //房东联
    ownerRent: [
      '\n房东联\n', ESCPOS.line,
      ESCPOS.bigfont2, ESCPOS.alignCenter, '{{building.name}}-{{room.code}}{{#invoice.typestr}}{{invoice.typestr}}{{/invoice.typestr}}\r\n\n', ESCPOS.alignLeft, ESCPOS.fontNormal,
      '租户:{{#customer}}{{{realname}}}{{/customer}}\n',
      '日期:{{begindate}}-{{enddate}}\n',
      ESCPOS.line, ESCPOS.setTable([1, 25]),
      '{{#invoice.items}}' +
      ESCPOS.firstCol + ESCPOS.mark + '{{name}}:'+
			//'{{#price}}{{price}}元/{{#unit}}{{unit}}{{/unit}}{{^unit}}月{{/unit}}{{/price}}{{#typestr}}{{typestr}}{{/typestr}}' +
			'{{{info}}}' +
			ESCPOS.nextCol + ESCPOS.mark  + '{{money}}元\r\n' +
      '{{#value.amount}}' + ESCPOS.alignLeft +
      ESCPOS.firstCol + ESCPOS.mark + '     {{value.init}}->{{value.current}}={{value.amount}}\r\n' +
      '{{/value.amount}}' +
      '{{/invoice.items}}',
      ESCPOS.line, ESCPOS.setTable([1, 20]),
      ESCPOS.firstCol, '合计:' + ESCPOS.nextCol  + ESCPOS.bigfont2 + '{{invoice.money}}元\n\n', ESCPOS.alignLeft, ESCPOS.fontNormal, ESCPOS.clearTable,
      '备注:{{invoice.description}}\n',
      '签字:\n\n',
      ESCPOS.line,
      '打印日期:{{printDate}}\n',
      ESCPOS.endline, '\n\n'
      //ESCPOS.cut,
    ],
    //房东联(IOS)
    ownerRentIos: [],
  },
  //财务统计模板
  analysis:{
    header: [
      ESCPOS.bigfont2, ESCPOS.alignCenter, '{{building.name}}',ESCPOS.newline,'{{analysis.year}}年{{analysis.month}}月\r\n\n',
      ESCPOS.alignLeft, '总收入:{{analysis.money}}元',ESCPOS.newline,
      ESCPOS.fontNormal,ESCPOS.line
    ],
  	opration: [
      ESCPOS.alignLeft, ESCPOS.setTable([1, 13, 25]),
      ESCPOS.firstCol, '新租({{analysis.rent}})', ESCPOS.nextCol, '退房({{analysis.back}})', ESCPOS.nextCol, '调租({{analysis.upprice}})\r\n',
      ESCPOS.clearTable
    ], //状态统计(新租,退房,调租)
  	product: [
      ESCPOS.newline,
      '费用类型统计\n',
      ESCPOS.line, ESCPOS.setTable([1, 25]),
      '{{#analysis.products}}' +
      ESCPOS.firstCol + ESCPOS.mark + '{{name}}' + ESCPOS.nextCol + ESCPOS.mark  + '{{money}}元\r\n' +
      '{{/analysis.products}}',
      ESCPOS.clearTable, ESCPOS.alignLeft
    ], //收费项目统计
  	paytype: [
      ESCPOS.newline,
      '收费方式统计\n',
      ESCPOS.line, ESCPOS.setTable([1, 13, 25]),
      '{{#analysis.paytypes}}' +
      ESCPOS.firstCol + ESCPOS.mark + '{{name}}' + ESCPOS.nextCol + ESCPOS.mark + '{{count}}笔' + ESCPOS.nextCol + ESCPOS.mark  + '{{money}}元\r\n' +
      '{{/analysis.paytypes}}',
      ESCPOS.clearTable, ESCPOS.alignLeft
    ], //付款方式统计
  	basedetail: [
      ESCPOS.newline,
      '收费明细\n',
      ESCPOS.line, ESCPOS.setTable([1, 13, 25]),
      '{{#invoices}}' +
      ESCPOS.firstCol + ESCPOS.mark + '{{code}}' + ESCPOS.nextCol + ESCPOS.mark + '{{typestr}}' + ESCPOS.nextCol + ESCPOS.mark  + '{{money}}元\r\n' +
      '{{/invoices}}',
      ESCPOS.clearTable, ESCPOS.alignLeft
    ], //租金单详情(简单,只显示租金)
  	detail: [
      ESCPOS.newline,
      '收费明细\n',
      ESCPOS.line,
      '{{#invoices}}' +
      ESCPOS.setTable([1, 13, 25]) +
      ESCPOS.firstCol + ESCPOS.mark + '{{code}}' + ESCPOS.nextCol + ESCPOS.mark + '{{typestr}}' +  ESCPOS.nextCol + ESCPOS.mark  + '{{money}}元\r\n' +
      ESCPOS.clearTable +
      ESCPOS.mark + '  {{itemstr}}\r\n' +
      '{{/invoices}}',
      ESCPOS.alignLeft
    ], //租金单详情(详细,显示所有明细费用)
    footer:[
      ESCPOS.newline,ESCPOS.newline,
      '备注:\r\n\n\n',
      '签字:\r\n\n',
      ESCPOS.line,
      '打印日期:{{printDate}}\r\n',
      '深圳包租婆科技有限公司\r\n',
      '客服热线:4008-128-028\r\n',
      'http://www.bzptech.com\r\n',
      ESCPOS.endline, '\r\n\n'
    ] //尾部
  },
  //切刀命令
  cut:[ESCPOS.cut]
};

angular.module('bagu')
	/******************
	     静态常量定义
	*******************/
	//ESC/POS命令集
	.constant('ESCPOS', ESCPOS)
	//打印模板(蓝牙)
	.constant('POSTMPL', POSTMPL);
